/* Indicator.c generated by valac 0.56.17, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*
 * Copyright 2011-2021 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "power.h"
#include <glib.h>
#include <gio/gio.h>
#include <wingpanel.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <libnotify/notify.h>
#include <gmodule.h>

#define POWER_INDICATOR_LOW_BATTERY_PERCENTAGE 20.0
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	POWER_INDICATOR_0_PROPERTY,
	POWER_INDICATOR_IS_IN_SESSION_PROPERTY,
	POWER_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY,
	POWER_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY,
	POWER_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* power_indicator_properties[POWER_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerIndicatorPrivate {
	gboolean _is_in_session;
	gboolean _natural_scroll_touchpad;
	gboolean _natural_scroll_mouse;
	PowerWidgetsDisplayWidget* display_widget;
	PowerWidgetsPopoverWidget* popover_widget;
	PowerServicesDevice* display_device;
	PowerServicesDeviceManager* dm;
	GSettings* settings;
};

static gint PowerIndicator_private_offset;
static gpointer power_indicator_parent_class = NULL;

static GtkWidget* power_indicator_real_get_display_widget (WingpanelIndicator* base);
static void power_indicator_update_visibility (PowerIndicator* self);
static void _power_indicator_update_visibility_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void power_indicator_update_display_device (PowerIndicator* self);
static void _power_indicator_update_display_device_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void power_indicator_update_tooltip (PowerIndicator* self);
static void _power_indicator_update_tooltip_g_settings_changed (GSettings* _sender,
                                                         const gchar* key,
                                                         gpointer self);
static gboolean ____lambda26_ (PowerIndicator* self,
                        GdkEventScroll* e);
static gboolean power_indicator_show_notification (PowerIndicator* self);
static gboolean _____lambda26__gtk_widget_scroll_event (GtkWidget* _sender,
                                                 GdkEventScroll* event,
                                                 gpointer self);
static void _power_indicator_update_tooltip_power_services_device_manager_brightness_changed (PowerServicesDeviceManager* _sender,
                                                                                       gint brightness,
                                                                                       gpointer self);
static GtkWidget* power_indicator_real_get_widget (WingpanelIndicator* base);
static void power_indicator_real_opened (WingpanelIndicator* base);
static void power_indicator_real_closed (WingpanelIndicator* base);
static void power_indicator_show_backlight_data (PowerIndicator* self);
static void power_indicator_show_display_device_data (PowerIndicator* self);
static void _power_indicator_show_display_device_data_power_services_device_properties_updated (PowerServicesDevice* _sender,
                                                                                         gpointer self);
static GObject * power_indicator_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void power_indicator_finalize (GObject * obj);
static GType power_indicator_get_type_once (void);
static void _vala_power_indicator_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_power_indicator_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
power_indicator_get_instance_private (PowerIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, PowerIndicator_private_offset);
}

PowerIndicator*
power_indicator_construct (GType object_type,
                           gboolean is_in_session)
{
	PowerIndicator * self = NULL;
#line 37 "../src/Indicator.vala"
	self = (PowerIndicator*) g_object_new (object_type, "code-name", WINGPANEL_INDICATOR_POWER, "is-in-session", is_in_session, NULL);
#line 36 "../src/Indicator.vala"
	return self;
#line 135 "Indicator.c"
}

PowerIndicator*
power_indicator_new (gboolean is_in_session)
{
#line 36 "../src/Indicator.vala"
	return power_indicator_construct (POWER_TYPE_INDICATOR, is_in_session);
#line 143 "Indicator.c"
}

static void
_power_indicator_update_visibility_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 66 "../src/Indicator.vala"
	power_indicator_update_visibility ((PowerIndicator*) self);
#line 153 "Indicator.c"
}

static void
_power_indicator_update_display_device_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 67 "../src/Indicator.vala"
	power_indicator_update_display_device ((PowerIndicator*) self);
#line 163 "Indicator.c"
}

static void
_power_indicator_update_tooltip_g_settings_changed (GSettings* _sender,
                                                    const gchar* key,
                                                    gpointer self)
{
#line 68 "../src/Indicator.vala"
	power_indicator_update_tooltip ((PowerIndicator*) self);
#line 173 "Indicator.c"
}

static gboolean
____lambda26_ (PowerIndicator* self,
               GdkEventScroll* e)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 71 "../src/Indicator.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 72 "../src/Indicator.vala"
	_tmp0_ = self->priv->_natural_scroll_mouse;
#line 72 "../src/Indicator.vala"
	_tmp1_ = self->priv->_natural_scroll_touchpad;
#line 72 "../src/Indicator.vala"
	if (power_utils_handle_scroll_event (e, _tmp0_, _tmp1_)) {
#line 191 "Indicator.c"
		gboolean _tmp2_ = FALSE;
		PowerWidgetsPopoverWidget* _tmp3_;
#line 73 "../src/Indicator.vala"
		_tmp3_ = self->priv->popover_widget;
#line 73 "../src/Indicator.vala"
		if (_tmp3_ == NULL) {
#line 73 "../src/Indicator.vala"
			_tmp2_ = TRUE;
#line 200 "Indicator.c"
		} else {
			PowerWidgetsPopoverWidget* _tmp4_;
#line 73 "../src/Indicator.vala"
			_tmp4_ = self->priv->popover_widget;
#line 73 "../src/Indicator.vala"
			_tmp2_ = !gtk_widget_is_visible ((GtkWidget*) _tmp4_);
#line 207 "Indicator.c"
		}
#line 73 "../src/Indicator.vala"
		if (_tmp2_) {
#line 74 "../src/Indicator.vala"
			power_indicator_show_notification (self);
#line 213 "Indicator.c"
		}
#line 77 "../src/Indicator.vala"
		result = TRUE;
#line 77 "../src/Indicator.vala"
		return result;
#line 219 "Indicator.c"
	}
#line 80 "../src/Indicator.vala"
	result = FALSE;
#line 80 "../src/Indicator.vala"
	return result;
#line 225 "Indicator.c"
}

static gboolean
_____lambda26__gtk_widget_scroll_event (GtkWidget* _sender,
                                        GdkEventScroll* event,
                                        gpointer self)
{
	gboolean result;
	result = ____lambda26_ ((PowerIndicator*) self, event);
#line 71 "../src/Indicator.vala"
	return result;
#line 237 "Indicator.c"
}

static void
_power_indicator_update_tooltip_power_services_device_manager_brightness_changed (PowerServicesDeviceManager* _sender,
                                                                                  gint brightness,
                                                                                  gpointer self)
{
#line 83 "../src/Indicator.vala"
	power_indicator_update_tooltip ((PowerIndicator*) self);
#line 247 "Indicator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 87 "../src/Indicator.vala"
	return self ? g_object_ref (self) : NULL;
#line 255 "Indicator.c"
}

static GtkWidget*
power_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	PowerIndicator * self;
	PowerWidgetsDisplayWidget* _tmp0_;
	PowerWidgetsDisplayWidget* _tmp21_;
	GtkWidget* _tmp22_;
	GtkWidget* result;
#line 57 "../src/Indicator.vala"
	self = (PowerIndicator*) base;
#line 58 "../src/Indicator.vala"
	_tmp0_ = self->priv->display_widget;
#line 58 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 272 "Indicator.c"
		PowerWidgetsDisplayWidget* _tmp1_;
		gboolean _tmp2_ = FALSE;
		PowerServicesDeviceManager* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		PowerServicesDeviceManager* _tmp11_;
		PowerServicesDeviceManager* _tmp12_;
		GSettings* _tmp13_;
		PowerServicesDeviceManager* _tmp14_;
		PowerServicesBacklight* _tmp15_;
		PowerServicesBacklight* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 59 "../src/Indicator.vala"
		_tmp1_ = power_widgets_display_widget_new ();
#line 59 "../src/Indicator.vala"
		g_object_ref_sink (_tmp1_);
#line 59 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->display_widget);
#line 59 "../src/Indicator.vala"
		self->priv->display_widget = _tmp1_;
#line 62 "../src/Indicator.vala"
		_tmp3_ = self->priv->dm;
#line 62 "../src/Indicator.vala"
		_tmp4_ = power_services_device_manager_get_has_battery (_tmp3_);
#line 62 "../src/Indicator.vala"
		_tmp5_ = _tmp4_;
#line 62 "../src/Indicator.vala"
		if (_tmp5_) {
#line 62 "../src/Indicator.vala"
			_tmp2_ = TRUE;
#line 304 "Indicator.c"
		} else {
			PowerServicesDeviceManager* _tmp6_;
			PowerServicesBacklight* _tmp7_;
			PowerServicesBacklight* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 62 "../src/Indicator.vala"
			_tmp6_ = self->priv->dm;
#line 62 "../src/Indicator.vala"
			_tmp7_ = power_services_device_manager_get_backlight (_tmp6_);
#line 62 "../src/Indicator.vala"
			_tmp8_ = _tmp7_;
#line 62 "../src/Indicator.vala"
			_tmp9_ = power_services_backlight_get_present (_tmp8_);
#line 62 "../src/Indicator.vala"
			_tmp10_ = _tmp9_;
#line 62 "../src/Indicator.vala"
			_tmp2_ = _tmp10_;
#line 323 "Indicator.c"
		}
#line 62 "../src/Indicator.vala"
		if (_tmp2_) {
#line 63 "../src/Indicator.vala"
			power_indicator_update_visibility (self);
#line 329 "Indicator.c"
		}
#line 66 "../src/Indicator.vala"
		_tmp11_ = self->priv->dm;
#line 66 "../src/Indicator.vala"
		g_signal_connect_object ((GObject*) _tmp11_, "notify::has-battery", (GCallback) _power_indicator_update_visibility_g_object_notify, self, 0);
#line 67 "../src/Indicator.vala"
		_tmp12_ = self->priv->dm;
#line 67 "../src/Indicator.vala"
		g_signal_connect_object ((GObject*) _tmp12_, "notify::display-device", (GCallback) _power_indicator_update_display_device_g_object_notify, self, 0);
#line 68 "../src/Indicator.vala"
		_tmp13_ = self->priv->settings;
#line 68 "../src/Indicator.vala"
		g_signal_connect_object (_tmp13_, "changed::show-percentage", (GCallback) _power_indicator_update_tooltip_g_settings_changed, self, 0);
#line 70 "../src/Indicator.vala"
		_tmp14_ = self->priv->dm;
#line 70 "../src/Indicator.vala"
		_tmp15_ = power_services_device_manager_get_backlight (_tmp14_);
#line 70 "../src/Indicator.vala"
		_tmp16_ = _tmp15_;
#line 70 "../src/Indicator.vala"
		_tmp17_ = power_services_backlight_get_present (_tmp16_);
#line 70 "../src/Indicator.vala"
		_tmp18_ = _tmp17_;
#line 70 "../src/Indicator.vala"
		if (_tmp18_) {
#line 355 "Indicator.c"
			PowerWidgetsDisplayWidget* _tmp19_;
			PowerServicesDeviceManager* _tmp20_;
#line 71 "../src/Indicator.vala"
			_tmp19_ = self->priv->display_widget;
#line 71 "../src/Indicator.vala"
			g_signal_connect_object ((GtkWidget*) _tmp19_, "scroll-event", (GCallback) _____lambda26__gtk_widget_scroll_event, self, 0);
#line 83 "../src/Indicator.vala"
			_tmp20_ = self->priv->dm;
#line 83 "../src/Indicator.vala"
			g_signal_connect_object (_tmp20_, "brightness-changed", (GCallback) _power_indicator_update_tooltip_power_services_device_manager_brightness_changed, self, 0);
#line 366 "Indicator.c"
		}
	}
#line 87 "../src/Indicator.vala"
	_tmp21_ = self->priv->display_widget;
#line 87 "../src/Indicator.vala"
	_tmp22_ = _g_object_ref0 ((GtkWidget*) _tmp21_);
#line 87 "../src/Indicator.vala"
	result = _tmp22_;
#line 87 "../src/Indicator.vala"
	return result;
#line 377 "Indicator.c"
}

static GtkWidget*
power_indicator_real_get_widget (WingpanelIndicator* base)
{
	PowerIndicator * self;
	PowerWidgetsPopoverWidget* _tmp0_;
	PowerWidgetsPopoverWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* result;
#line 90 "../src/Indicator.vala"
	self = (PowerIndicator*) base;
#line 91 "../src/Indicator.vala"
	_tmp0_ = self->priv->popover_widget;
#line 91 "../src/Indicator.vala"
	if (_tmp0_ == NULL) {
#line 394 "Indicator.c"
		gboolean _tmp1_;
		PowerWidgetsPopoverWidget* _tmp2_;
#line 92 "../src/Indicator.vala"
		_tmp1_ = self->priv->_is_in_session;
#line 92 "../src/Indicator.vala"
		_tmp2_ = power_widgets_popover_widget_new (_tmp1_);
#line 92 "../src/Indicator.vala"
		g_object_ref_sink (_tmp2_);
#line 92 "../src/Indicator.vala"
		_g_object_unref0 (self->priv->popover_widget);
#line 92 "../src/Indicator.vala"
		self->priv->popover_widget = _tmp2_;
#line 407 "Indicator.c"
	}
#line 95 "../src/Indicator.vala"
	_tmp3_ = self->priv->popover_widget;
#line 95 "../src/Indicator.vala"
	_tmp4_ = _g_object_ref0 ((GtkWidget*) _tmp3_);
#line 95 "../src/Indicator.vala"
	result = _tmp4_;
#line 95 "../src/Indicator.vala"
	return result;
#line 417 "Indicator.c"
}

static void
power_indicator_real_opened (WingpanelIndicator* base)
{
	PowerIndicator * self;
	PowerServicesProcessMonitorMonitor* _tmp0_;
	PowerServicesProcessMonitorMonitor* _tmp1_;
#line 98 "../src/Indicator.vala"
	self = (PowerIndicator*) base;
#line 99 "../src/Indicator.vala"
	_tmp0_ = power_services_process_monitor_monitor_get_default ();
#line 99 "../src/Indicator.vala"
	_tmp1_ = _tmp0_;
#line 99 "../src/Indicator.vala"
	power_services_process_monitor_monitor_update (_tmp1_);
#line 99 "../src/Indicator.vala"
	_g_object_unref0 (_tmp1_);
#line 436 "Indicator.c"
}

static void
power_indicator_real_closed (WingpanelIndicator* base)
{
	PowerIndicator * self;
	PowerWidgetsPopoverWidget* _tmp0_;
#line 102 "../src/Indicator.vala"
	self = (PowerIndicator*) base;
#line 103 "../src/Indicator.vala"
	_tmp0_ = self->priv->popover_widget;
#line 103 "../src/Indicator.vala"
	power_widgets_popover_widget_slim_down (_tmp0_);
#line 450 "Indicator.c"
}

static void
power_indicator_update_visibility (PowerIndicator* self)
{
	PowerServicesDeviceManager* dm = NULL;
	PowerServicesDeviceManager* _tmp0_;
	PowerServicesDeviceManager* _tmp1_;
	gboolean _tmp2_ = FALSE;
	PowerServicesDeviceManager* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean should_be_visible = FALSE;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
#line 106 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/Indicator.vala"
	_tmp0_ = power_services_device_manager_get_default ();
#line 107 "../src/Indicator.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 107 "../src/Indicator.vala"
	dm = _tmp1_;
#line 109 "../src/Indicator.vala"
	_tmp3_ = dm;
#line 109 "../src/Indicator.vala"
	_tmp4_ = power_services_device_manager_get_has_battery (_tmp3_);
#line 109 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 109 "../src/Indicator.vala"
	if (_tmp5_) {
#line 109 "../src/Indicator.vala"
		_tmp2_ = TRUE;
#line 486 "Indicator.c"
	} else {
		PowerServicesDeviceManager* _tmp6_;
		PowerServicesBacklight* _tmp7_;
		PowerServicesBacklight* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 109 "../src/Indicator.vala"
		_tmp6_ = dm;
#line 109 "../src/Indicator.vala"
		_tmp7_ = power_services_device_manager_get_backlight (_tmp6_);
#line 109 "../src/Indicator.vala"
		_tmp8_ = _tmp7_;
#line 109 "../src/Indicator.vala"
		_tmp9_ = power_services_backlight_get_present (_tmp8_);
#line 109 "../src/Indicator.vala"
		_tmp10_ = _tmp9_;
#line 109 "../src/Indicator.vala"
		_tmp2_ = _tmp10_;
#line 505 "Indicator.c"
	}
#line 109 "../src/Indicator.vala"
	should_be_visible = _tmp2_;
#line 110 "../src/Indicator.vala"
	_tmp11_ = wingpanel_indicator_get_visible ((WingpanelIndicator*) self);
#line 110 "../src/Indicator.vala"
	_tmp12_ = _tmp11_;
#line 110 "../src/Indicator.vala"
	if (_tmp12_ != should_be_visible) {
#line 112 "../src/Indicator.vala"
		wingpanel_indicator_set_visible ((WingpanelIndicator*) self, should_be_visible);
#line 517 "Indicator.c"
	}
#line 115 "../src/Indicator.vala"
	_tmp13_ = wingpanel_indicator_get_visible ((WingpanelIndicator*) self);
#line 115 "../src/Indicator.vala"
	_tmp14_ = _tmp13_;
#line 115 "../src/Indicator.vala"
	if (_tmp14_) {
#line 525 "Indicator.c"
		PowerServicesDeviceManager* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 116 "../src/Indicator.vala"
		_tmp15_ = dm;
#line 116 "../src/Indicator.vala"
		_tmp16_ = power_services_device_manager_get_has_battery (_tmp15_);
#line 116 "../src/Indicator.vala"
		_tmp17_ = _tmp16_;
#line 116 "../src/Indicator.vala"
		if (_tmp17_) {
#line 117 "../src/Indicator.vala"
			power_indicator_update_display_device (self);
#line 539 "Indicator.c"
		} else {
#line 119 "../src/Indicator.vala"
			power_indicator_show_backlight_data (self);
#line 543 "Indicator.c"
		}
	}
#line 123 "../src/Indicator.vala"
	power_indicator_update_tooltip (self);
#line 106 "../src/Indicator.vala"
	_g_object_unref0 (dm);
#line 550 "Indicator.c"
}

static void
_power_indicator_show_display_device_data_power_services_device_properties_updated (PowerServicesDevice* _sender,
                                                                                    gpointer self)
{
#line 128 "../src/Indicator.vala"
	power_indicator_show_display_device_data ((PowerIndicator*) self);
#line 559 "Indicator.c"
}

static void
power_indicator_update_display_device (PowerIndicator* self)
{
	PowerServicesDevice* _tmp0_;
	PowerServicesDeviceManager* _tmp3_;
	PowerServicesDevice* _tmp4_;
	PowerServicesDevice* _tmp5_;
	PowerServicesDevice* _tmp6_;
	PowerServicesDevice* _tmp7_;
#line 126 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/Indicator.vala"
	_tmp0_ = self->priv->display_device;
#line 127 "../src/Indicator.vala"
	if (_tmp0_ != NULL) {
#line 577 "Indicator.c"
		PowerServicesDevice* _tmp1_;
		guint _tmp2_;
#line 128 "../src/Indicator.vala"
		_tmp1_ = self->priv->display_device;
#line 128 "../src/Indicator.vala"
		g_signal_parse_name ("properties-updated", POWER_SERVICES_TYPE_DEVICE, &_tmp2_, NULL, FALSE);
#line 128 "../src/Indicator.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _power_indicator_show_display_device_data_power_services_device_properties_updated, self);
#line 586 "Indicator.c"
	}
#line 131 "../src/Indicator.vala"
	_tmp3_ = power_services_device_manager_get_default ();
#line 131 "../src/Indicator.vala"
	_tmp4_ = power_services_device_manager_get_display_device (_tmp3_);
#line 131 "../src/Indicator.vala"
	_tmp5_ = _tmp4_;
#line 131 "../src/Indicator.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 131 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->display_device);
#line 131 "../src/Indicator.vala"
	self->priv->display_device = _tmp6_;
#line 132 "../src/Indicator.vala"
	_tmp7_ = self->priv->display_device;
#line 132 "../src/Indicator.vala"
	if (_tmp7_ != NULL) {
#line 604 "Indicator.c"
		PowerServicesDevice* _tmp8_;
#line 133 "../src/Indicator.vala"
		power_indicator_show_display_device_data (self);
#line 134 "../src/Indicator.vala"
		_tmp8_ = self->priv->display_device;
#line 134 "../src/Indicator.vala"
		g_signal_connect_object (_tmp8_, "properties-updated", (GCallback) _power_indicator_show_display_device_data_power_services_device_properties_updated, self, 0);
#line 612 "Indicator.c"
	}
#line 137 "../src/Indicator.vala"
	power_indicator_update_tooltip (self);
#line 616 "Indicator.c"
}

static void
power_indicator_show_display_device_data (PowerIndicator* self)
{
	gboolean _tmp0_ = FALSE;
	PowerServicesDevice* _tmp1_;
#line 140 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/Indicator.vala"
	_tmp1_ = self->priv->display_device;
#line 141 "../src/Indicator.vala"
	if (_tmp1_ != NULL) {
#line 630 "Indicator.c"
		PowerWidgetsDisplayWidget* _tmp2_;
#line 141 "../src/Indicator.vala"
		_tmp2_ = self->priv->display_widget;
#line 141 "../src/Indicator.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 636 "Indicator.c"
	} else {
#line 141 "../src/Indicator.vala"
		_tmp0_ = FALSE;
#line 640 "Indicator.c"
	}
#line 141 "../src/Indicator.vala"
	if (_tmp0_) {
#line 644 "Indicator.c"
		gchar* icon_name = NULL;
		PowerServicesDevice* _tmp3_;
		gchar* _tmp4_;
		PowerWidgetsDisplayWidget* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		PowerServicesDevice* _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
#line 142 "../src/Indicator.vala"
		_tmp3_ = self->priv->display_device;
#line 142 "../src/Indicator.vala"
		_tmp4_ = power_services_device_get_symbolic_icon_name_for_battery (_tmp3_);
#line 142 "../src/Indicator.vala"
		icon_name = _tmp4_;
#line 143 "../src/Indicator.vala"
		_tmp5_ = self->priv->display_widget;
#line 143 "../src/Indicator.vala"
		_tmp6_ = icon_name;
#line 143 "../src/Indicator.vala"
		power_widgets_display_widget_set_icon_name (_tmp5_, _tmp6_);
#line 146 "../src/Indicator.vala"
		_tmp7_ = icon_name;
#line 146 "../src/Indicator.vala"
		g_debug ("Indicator.vala:146: Icon changed to \"%s\"", _tmp7_);
#line 148 "../src/Indicator.vala"
		_tmp8_ = self->priv->display_device;
#line 148 "../src/Indicator.vala"
		_tmp9_ = power_services_device_get_percentage (_tmp8_);
#line 148 "../src/Indicator.vala"
		_tmp10_ = _tmp9_;
#line 148 "../src/Indicator.vala"
		if (_tmp10_ <= ((gdouble) 0)) {
#line 678 "Indicator.c"
			PowerWidgetsDisplayWidget* _tmp11_;
#line 149 "../src/Indicator.vala"
			_tmp11_ = self->priv->display_widget;
#line 149 "../src/Indicator.vala"
			power_widgets_display_widget_set_allow_percent (_tmp11_, FALSE);
#line 684 "Indicator.c"
		} else {
			PowerWidgetsDisplayWidget* _tmp12_;
			PowerServicesDevice* _tmp13_;
			gdouble _tmp14_;
			gdouble _tmp15_;
			PowerWidgetsDisplayWidget* _tmp16_;
#line 151 "../src/Indicator.vala"
			_tmp12_ = self->priv->display_widget;
#line 151 "../src/Indicator.vala"
			_tmp13_ = self->priv->display_device;
#line 151 "../src/Indicator.vala"
			_tmp14_ = power_services_device_get_percentage (_tmp13_);
#line 151 "../src/Indicator.vala"
			_tmp15_ = _tmp14_;
#line 151 "../src/Indicator.vala"
			power_widgets_display_widget_set_percentage (_tmp12_, (gint) round (_tmp15_));
#line 152 "../src/Indicator.vala"
			_tmp16_ = self->priv->display_widget;
#line 152 "../src/Indicator.vala"
			power_widgets_display_widget_set_allow_percent (_tmp16_, TRUE);
#line 705 "Indicator.c"
		}
#line 155 "../src/Indicator.vala"
		power_indicator_update_tooltip (self);
#line 141 "../src/Indicator.vala"
		_g_free0 (icon_name);
#line 711 "Indicator.c"
	}
}

static void
power_indicator_show_backlight_data (PowerIndicator* self)
{
	PowerWidgetsDisplayWidget* _tmp0_;
#line 159 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 160 "../src/Indicator.vala"
	_tmp0_ = self->priv->display_widget;
#line 160 "../src/Indicator.vala"
	if (_tmp0_ != NULL) {
#line 725 "Indicator.c"
		PowerWidgetsDisplayWidget* _tmp1_;
		PowerWidgetsDisplayWidget* _tmp2_;
#line 161 "../src/Indicator.vala"
		_tmp1_ = self->priv->display_widget;
#line 161 "../src/Indicator.vala"
		power_widgets_display_widget_set_icon_name (_tmp1_, "display-brightness-symbolic");
#line 162 "../src/Indicator.vala"
		_tmp2_ = self->priv->display_widget;
#line 162 "../src/Indicator.vala"
		power_widgets_display_widget_set_allow_percent (_tmp2_, FALSE);
#line 736 "Indicator.c"
	}
}

static void
power_indicator_update_tooltip (PowerIndicator* self)
{
	gchar* primary_text = NULL;
	gchar* secondary_text = NULL;
	PowerServicesDevice* _tmp0_;
	gboolean _tmp33_ = FALSE;
	const gchar* _tmp34_;
	const gchar* _tmp45_;
#line 166 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 167 "../src/Indicator.vala"
	primary_text = NULL;
#line 168 "../src/Indicator.vala"
	secondary_text = NULL;
#line 169 "../src/Indicator.vala"
	_tmp0_ = self->priv->display_device;
#line 169 "../src/Indicator.vala"
	if (_tmp0_ != NULL) {
#line 759 "Indicator.c"
		gboolean _tmp1_ = FALSE;
		PowerServicesDevice* _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		gboolean is_showing_percent = FALSE;
		GSettings* _tmp9_;
		gboolean _tmp10_ = FALSE;
		PowerServicesDevice* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		PowerServicesDevice* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
#line 170 "../src/Indicator.vala"
		_tmp2_ = self->priv->display_device;
#line 170 "../src/Indicator.vala"
		_tmp3_ = power_services_device_get_percentage (_tmp2_);
#line 170 "../src/Indicator.vala"
		_tmp4_ = _tmp3_;
#line 170 "../src/Indicator.vala"
		if (_tmp4_ <= POWER_INDICATOR_LOW_BATTERY_PERCENTAGE) {
#line 781 "Indicator.c"
			PowerServicesDevice* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 170 "../src/Indicator.vala"
			_tmp5_ = self->priv->display_device;
#line 170 "../src/Indicator.vala"
			_tmp6_ = power_services_device_get_is_charging (_tmp5_);
#line 170 "../src/Indicator.vala"
			_tmp7_ = _tmp6_;
#line 170 "../src/Indicator.vala"
			_tmp1_ = !_tmp7_;
#line 793 "Indicator.c"
		} else {
#line 170 "../src/Indicator.vala"
			_tmp1_ = FALSE;
#line 797 "Indicator.c"
		}
#line 170 "../src/Indicator.vala"
		if (_tmp1_) {
#line 801 "Indicator.c"
			PowerWidgetsDisplayWidget* _tmp8_;
#line 171 "../src/Indicator.vala"
			_tmp8_ = self->priv->display_widget;
#line 171 "../src/Indicator.vala"
			power_widgets_display_widget_show_percentage (_tmp8_, TRUE);
#line 807 "Indicator.c"
		}
#line 175 "../src/Indicator.vala"
		_tmp9_ = self->priv->settings;
#line 175 "../src/Indicator.vala"
		is_showing_percent = g_settings_get_boolean (_tmp9_, "show-percentage");
#line 176 "../src/Indicator.vala"
		_tmp11_ = self->priv->display_device;
#line 176 "../src/Indicator.vala"
		_tmp12_ = power_services_device_get_is_charging (_tmp11_);
#line 176 "../src/Indicator.vala"
		_tmp13_ = _tmp12_;
#line 176 "../src/Indicator.vala"
		if (_tmp13_) {
#line 176 "../src/Indicator.vala"
			_tmp10_ = !is_showing_percent;
#line 823 "Indicator.c"
		} else {
#line 176 "../src/Indicator.vala"
			_tmp10_ = FALSE;
#line 827 "Indicator.c"
		}
#line 176 "../src/Indicator.vala"
		if (_tmp10_) {
#line 831 "Indicator.c"
			PowerWidgetsDisplayWidget* _tmp14_;
#line 177 "../src/Indicator.vala"
			_tmp14_ = self->priv->display_widget;
#line 177 "../src/Indicator.vala"
			power_widgets_display_widget_show_percentage (_tmp14_, FALSE);
#line 837 "Indicator.c"
		}
#line 179 "../src/Indicator.vala"
		_tmp15_ = self->priv->display_device;
#line 179 "../src/Indicator.vala"
		_tmp16_ = power_services_device_get_is_a_battery (_tmp15_);
#line 179 "../src/Indicator.vala"
		_tmp17_ = _tmp16_;
#line 179 "../src/Indicator.vala"
		if (_tmp17_) {
#line 847 "Indicator.c"
			PowerServicesDevice* _tmp18_;
			PowerServicesDeviceType _tmp19_;
			PowerServicesDeviceType _tmp20_;
			const gchar* _tmp21_;
			PowerServicesDevice* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			const gchar* _tmp26_ = NULL;
			gchar* _tmp27_;
#line 180 "../src/Indicator.vala"
			_tmp18_ = self->priv->display_device;
#line 180 "../src/Indicator.vala"
			_tmp19_ = power_services_device_get_device_type (_tmp18_);
#line 180 "../src/Indicator.vala"
			_tmp20_ = _tmp19_;
#line 180 "../src/Indicator.vala"
			_tmp21_ = power_services_device_type_get_name (_tmp20_);
#line 180 "../src/Indicator.vala"
			_tmp22_ = self->priv->display_device;
#line 180 "../src/Indicator.vala"
			_tmp23_ = power_services_device_get_info (_tmp22_);
#line 180 "../src/Indicator.vala"
			_tmp24_ = _tmp23_;
#line 180 "../src/Indicator.vala"
			_tmp25_ = g_strdup_printf (_ ("%s: %s"), _tmp21_, _tmp24_);
#line 180 "../src/Indicator.vala"
			_g_free0 (primary_text);
#line 180 "../src/Indicator.vala"
			primary_text = _tmp25_;
#line 180 "../src/Indicator.vala"
			_g_free0 (_tmp24_);
#line 181 "../src/Indicator.vala"
			if (is_showing_percent) {
#line 181 "../src/Indicator.vala"
				_tmp26_ = _ ("Middle-click to hide percentage");
#line 884 "Indicator.c"
			} else {
#line 181 "../src/Indicator.vala"
				_tmp26_ = _ ("Middle-click to show percentage");
#line 888 "Indicator.c"
			}
#line 181 "../src/Indicator.vala"
			_tmp27_ = g_strdup (_tmp26_);
#line 181 "../src/Indicator.vala"
			_g_free0 (secondary_text);
#line 181 "../src/Indicator.vala"
			secondary_text = _tmp27_;
#line 896 "Indicator.c"
		} else {
			PowerServicesDevice* _tmp28_;
			PowerServicesDeviceType _tmp29_;
			PowerServicesDeviceType _tmp30_;
			const gchar* _tmp31_;
			gchar* _tmp32_;
#line 184 "../src/Indicator.vala"
			_tmp28_ = self->priv->display_device;
#line 184 "../src/Indicator.vala"
			_tmp29_ = power_services_device_get_device_type (_tmp28_);
#line 184 "../src/Indicator.vala"
			_tmp30_ = _tmp29_;
#line 184 "../src/Indicator.vala"
			_tmp31_ = power_services_device_type_get_name (_tmp30_);
#line 184 "../src/Indicator.vala"
			_tmp32_ = g_strdup (_tmp31_);
#line 184 "../src/Indicator.vala"
			_g_free0 (primary_text);
#line 184 "../src/Indicator.vala"
			primary_text = _tmp32_;
#line 917 "Indicator.c"
		}
	}
#line 188 "../src/Indicator.vala"
	_tmp34_ = primary_text;
#line 188 "../src/Indicator.vala"
	if (_tmp34_ == NULL) {
#line 924 "Indicator.c"
		PowerServicesDeviceManager* _tmp35_;
		PowerServicesBacklight* _tmp36_;
		PowerServicesBacklight* _tmp37_;
		gboolean _tmp38_;
		gboolean _tmp39_;
#line 188 "../src/Indicator.vala"
		_tmp35_ = self->priv->dm;
#line 188 "../src/Indicator.vala"
		_tmp36_ = power_services_device_manager_get_backlight (_tmp35_);
#line 188 "../src/Indicator.vala"
		_tmp37_ = _tmp36_;
#line 188 "../src/Indicator.vala"
		_tmp38_ = power_services_backlight_get_present (_tmp37_);
#line 188 "../src/Indicator.vala"
		_tmp39_ = _tmp38_;
#line 188 "../src/Indicator.vala"
		_tmp33_ = _tmp39_;
#line 942 "Indicator.c"
	} else {
#line 188 "../src/Indicator.vala"
		_tmp33_ = FALSE;
#line 946 "Indicator.c"
	}
#line 188 "../src/Indicator.vala"
	if (_tmp33_) {
#line 950 "Indicator.c"
		PowerServicesDeviceManager* _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
#line 189 "../src/Indicator.vala"
		_tmp40_ = self->priv->dm;
#line 189 "../src/Indicator.vala"
		_tmp41_ = power_services_device_manager_get_brightness (_tmp40_);
#line 189 "../src/Indicator.vala"
		_tmp42_ = _tmp41_;
#line 189 "../src/Indicator.vala"
		_tmp43_ = g_strdup_printf (_ ("Screen brightness: %i"), (gint) _tmp42_);
#line 189 "../src/Indicator.vala"
		_g_free0 (primary_text);
#line 189 "../src/Indicator.vala"
		primary_text = _tmp43_;
#line 190 "../src/Indicator.vala"
		_tmp44_ = g_strdup (_ ("Scroll to change screen brightness"));
#line 190 "../src/Indicator.vala"
		_g_free0 (secondary_text);
#line 190 "../src/Indicator.vala"
		secondary_text = _tmp44_;
#line 974 "Indicator.c"
	}
#line 193 "../src/Indicator.vala"
	_tmp45_ = primary_text;
#line 193 "../src/Indicator.vala"
	if (_tmp45_ == NULL) {
#line 980 "Indicator.c"
		PowerWidgetsDisplayWidget* _tmp46_;
#line 194 "../src/Indicator.vala"
		_tmp46_ = self->priv->display_widget;
#line 194 "../src/Indicator.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp46_, NULL);
#line 986 "Indicator.c"
	} else {
		const gchar* _tmp47_;
#line 195 "../src/Indicator.vala"
		_tmp47_ = secondary_text;
#line 195 "../src/Indicator.vala"
		if (_tmp47_ == NULL) {
#line 993 "Indicator.c"
			PowerWidgetsDisplayWidget* _tmp48_;
			const gchar* _tmp49_;
#line 196 "../src/Indicator.vala"
			_tmp48_ = self->priv->display_widget;
#line 196 "../src/Indicator.vala"
			_tmp49_ = primary_text;
#line 196 "../src/Indicator.vala"
			gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp48_, _tmp49_);
#line 1002 "Indicator.c"
		} else {
			PowerWidgetsDisplayWidget* _tmp50_;
			const gchar* _tmp51_;
			const gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
#line 198 "../src/Indicator.vala"
			_tmp50_ = self->priv->display_widget;
#line 198 "../src/Indicator.vala"
			_tmp51_ = primary_text;
#line 198 "../src/Indicator.vala"
			_tmp52_ = secondary_text;
#line 198 "../src/Indicator.vala"
			_tmp53_ = g_strdup_printf (GRANITE_TOOLTIP_SECONDARY_TEXT_MARKUP, _tmp52_);
#line 198 "../src/Indicator.vala"
			_tmp54_ = _tmp53_;
#line 198 "../src/Indicator.vala"
			_tmp55_ = g_strdup_printf ("%s\n%s", _tmp51_, _tmp54_);
#line 198 "../src/Indicator.vala"
			_tmp56_ = _tmp55_;
#line 198 "../src/Indicator.vala"
			gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp50_, _tmp56_);
#line 198 "../src/Indicator.vala"
			_g_free0 (_tmp56_);
#line 198 "../src/Indicator.vala"
			_g_free0 (_tmp54_);
#line 1031 "Indicator.c"
		}
	}
#line 166 "../src/Indicator.vala"
	_g_free0 (secondary_text);
#line 166 "../src/Indicator.vala"
	_g_free0 (primary_text);
#line 1038 "Indicator.c"
}

static gboolean
power_indicator_show_notification (PowerIndicator* self)
{
	gboolean _tmp0_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 205 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "../src/Indicator.vala"
	_tmp0_ = self->priv->_is_in_session;
#line 206 "../src/Indicator.vala"
	if (_tmp0_) {
#line 1053 "Indicator.c"
		NotifyNotification* notification = NULL;
		NotifyNotification* _tmp1_;
		NotifyNotification* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		NotifyNotification* _tmp5_;
		PowerServicesDeviceManager* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		GVariant* _tmp9_;
		GVariant* _tmp10_;
#line 207 "../src/Indicator.vala"
		_tmp1_ = notify_notification_new ("indicator-power", "", "display-brightness-symbolic");
#line 207 "../src/Indicator.vala"
		notification = _tmp1_;
#line 208 "../src/Indicator.vala"
		_tmp2_ = notification;
#line 208 "../src/Indicator.vala"
		_tmp3_ = g_variant_new_string ("indicator-power");
#line 208 "../src/Indicator.vala"
		g_variant_ref_sink (_tmp3_);
#line 208 "../src/Indicator.vala"
		_tmp4_ = _tmp3_;
#line 208 "../src/Indicator.vala"
		notify_notification_set_hint (_tmp2_, "x-canonical-private-synchronous", _tmp4_);
#line 208 "../src/Indicator.vala"
		_g_variant_unref0 (_tmp4_);
#line 209 "../src/Indicator.vala"
		_tmp5_ = notification;
#line 209 "../src/Indicator.vala"
		_tmp6_ = self->priv->dm;
#line 209 "../src/Indicator.vala"
		_tmp7_ = power_services_device_manager_get_brightness (_tmp6_);
#line 209 "../src/Indicator.vala"
		_tmp8_ = _tmp7_;
#line 209 "../src/Indicator.vala"
		_tmp9_ = g_variant_new_int32 ((gint32) _tmp8_);
#line 209 "../src/Indicator.vala"
		g_variant_ref_sink (_tmp9_);
#line 209 "../src/Indicator.vala"
		_tmp10_ = _tmp9_;
#line 209 "../src/Indicator.vala"
		notify_notification_set_hint (_tmp5_, "value", _tmp10_);
#line 209 "../src/Indicator.vala"
		_g_variant_unref0 (_tmp10_);
#line 1099 "Indicator.c"
		{
			NotifyNotification* _tmp11_;
#line 211 "../src/Indicator.vala"
			_tmp11_ = notification;
#line 211 "../src/Indicator.vala"
			notify_notification_show (_tmp11_, &_inner_error0_);
#line 211 "../src/Indicator.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1108 "Indicator.c"
				goto __catch0_g_error;
			}
#line 212 "../src/Indicator.vala"
			result = TRUE;
#line 212 "../src/Indicator.vala"
			_g_object_unref0 (notification);
#line 212 "../src/Indicator.vala"
			return result;
#line 1117 "Indicator.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 210 "../src/Indicator.vala"
			e = _inner_error0_;
#line 210 "../src/Indicator.vala"
			_inner_error0_ = NULL;
#line 214 "../src/Indicator.vala"
			_tmp12_ = e;
#line 214 "../src/Indicator.vala"
			_tmp13_ = _tmp12_->message;
#line 214 "../src/Indicator.vala"
			g_warning ("Indicator.vala:214: Unable to show notification: %s", _tmp13_);
#line 210 "../src/Indicator.vala"
			_g_error_free0 (e);
#line 1137 "Indicator.c"
		}
		__finally0:
#line 210 "../src/Indicator.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1142 "Indicator.c"
			gboolean _tmp14_ = FALSE;
#line 210 "../src/Indicator.vala"
			_g_object_unref0 (notification);
#line 210 "../src/Indicator.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 210 "../src/Indicator.vala"
			g_clear_error (&_inner_error0_);
#line 210 "../src/Indicator.vala"
			return _tmp14_;
#line 1152 "Indicator.c"
		}
#line 206 "../src/Indicator.vala"
		_g_object_unref0 (notification);
#line 1156 "Indicator.c"
	}
#line 219 "../src/Indicator.vala"
	result = FALSE;
#line 219 "../src/Indicator.vala"
	return result;
#line 1162 "Indicator.c"
}

gboolean
power_indicator_get_is_in_session (PowerIndicator* self)
{
	gboolean result;
#line 23 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 23 "../src/Indicator.vala"
	result = self->priv->_is_in_session;
#line 23 "../src/Indicator.vala"
	return result;
#line 1175 "Indicator.c"
}

static void
power_indicator_set_is_in_session (PowerIndicator* self,
                                   gboolean value)
{
	gboolean old_value;
#line 23 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Indicator.vala"
	old_value = power_indicator_get_is_in_session (self);
#line 23 "../src/Indicator.vala"
	if (old_value != value) {
#line 23 "../src/Indicator.vala"
		self->priv->_is_in_session = value;
#line 23 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, power_indicator_properties[POWER_INDICATOR_IS_IN_SESSION_PROPERTY]);
#line 1193 "Indicator.c"
	}
}

gboolean
power_indicator_get_natural_scroll_touchpad (PowerIndicator* self)
{
	gboolean result;
#line 24 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24 "../src/Indicator.vala"
	result = self->priv->_natural_scroll_touchpad;
#line 24 "../src/Indicator.vala"
	return result;
#line 1207 "Indicator.c"
}

void
power_indicator_set_natural_scroll_touchpad (PowerIndicator* self,
                                             gboolean value)
{
	gboolean old_value;
#line 24 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Indicator.vala"
	old_value = power_indicator_get_natural_scroll_touchpad (self);
#line 24 "../src/Indicator.vala"
	if (old_value != value) {
#line 24 "../src/Indicator.vala"
		self->priv->_natural_scroll_touchpad = value;
#line 24 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, power_indicator_properties[POWER_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY]);
#line 1225 "Indicator.c"
	}
}

gboolean
power_indicator_get_natural_scroll_mouse (PowerIndicator* self)
{
	gboolean result;
#line 25 "../src/Indicator.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 25 "../src/Indicator.vala"
	result = self->priv->_natural_scroll_mouse;
#line 25 "../src/Indicator.vala"
	return result;
#line 1239 "Indicator.c"
}

void
power_indicator_set_natural_scroll_mouse (PowerIndicator* self,
                                          gboolean value)
{
	gboolean old_value;
#line 25 "../src/Indicator.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Indicator.vala"
	old_value = power_indicator_get_natural_scroll_mouse (self);
#line 25 "../src/Indicator.vala"
	if (old_value != value) {
#line 25 "../src/Indicator.vala"
		self->priv->_natural_scroll_mouse = value;
#line 25 "../src/Indicator.vala"
		g_object_notify_by_pspec ((GObject *) self, power_indicator_properties[POWER_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY]);
#line 1257 "Indicator.c"
	}
}

static GObject *
power_indicator_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerIndicator * self;
	PowerServicesDeviceManager* _tmp0_;
	PowerServicesDeviceManager* _tmp1_;
	GSettings* mouse_settings = NULL;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	GSettings* touchpad_settings = NULL;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
#line 43 "../src/Indicator.vala"
	parent_class = G_OBJECT_CLASS (power_indicator_parent_class);
#line 43 "../src/Indicator.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 43 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_INDICATOR, PowerIndicator);
#line 44 "../src/Indicator.vala"
	bindtextdomain (CONSTANTS_GETTEXT_PACKAGE, CONSTANTS_LOCALEDIR);
#line 45 "../src/Indicator.vala"
	bind_textdomain_codeset (CONSTANTS_GETTEXT_PACKAGE, "UTF-8");
#line 47 "../src/Indicator.vala"
	_tmp0_ = power_services_device_manager_get_default ();
#line 47 "../src/Indicator.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 47 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->dm);
#line 47 "../src/Indicator.vala"
	self->priv->dm = _tmp1_;
#line 49 "../src/Indicator.vala"
	_tmp2_ = g_settings_new ("org.gnome.desktop.peripherals.mouse");
#line 49 "../src/Indicator.vala"
	mouse_settings = _tmp2_;
#line 50 "../src/Indicator.vala"
	_tmp3_ = mouse_settings;
#line 50 "../src/Indicator.vala"
	g_settings_bind (_tmp3_, "natural-scroll", (GObject*) self, "natural-scroll-mouse", G_SETTINGS_BIND_DEFAULT);
#line 51 "../src/Indicator.vala"
	_tmp4_ = g_settings_new ("org.gnome.desktop.peripherals.touchpad");
#line 51 "../src/Indicator.vala"
	touchpad_settings = _tmp4_;
#line 52 "../src/Indicator.vala"
	_tmp5_ = touchpad_settings;
#line 52 "../src/Indicator.vala"
	g_settings_bind (_tmp5_, "natural-scroll", (GObject*) self, "natural-scroll-touchpad", G_SETTINGS_BIND_DEFAULT);
#line 54 "../src/Indicator.vala"
	_tmp6_ = g_settings_new ("io.elementary.desktop.wingpanel.power");
#line 54 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->settings);
#line 54 "../src/Indicator.vala"
	self->priv->settings = _tmp6_;
#line 43 "../src/Indicator.vala"
	_g_object_unref0 (touchpad_settings);
#line 43 "../src/Indicator.vala"
	_g_object_unref0 (mouse_settings);
#line 43 "../src/Indicator.vala"
	return obj;
#line 1324 "Indicator.c"
}

static void
power_indicator_class_init (PowerIndicatorClass * klass,
                            gpointer klass_data)
{
#line 20 "../src/Indicator.vala"
	power_indicator_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Indicator.vala"
	g_type_class_adjust_private_offset (klass, &PowerIndicator_private_offset);
#line 20 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) power_indicator_real_get_display_widget;
#line 20 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) power_indicator_real_get_widget;
#line 20 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) power_indicator_real_opened;
#line 20 "../src/Indicator.vala"
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) power_indicator_real_closed;
#line 20 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_indicator_get_property;
#line 20 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_indicator_set_property;
#line 20 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->constructor = power_indicator_constructor;
#line 20 "../src/Indicator.vala"
	G_OBJECT_CLASS (klass)->finalize = power_indicator_finalize;
#line 20 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_INDICATOR_IS_IN_SESSION_PROPERTY, power_indicator_properties[POWER_INDICATOR_IS_IN_SESSION_PROPERTY] = g_param_spec_boolean ("is-in-session", "is-in-session", "is-in-session", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY, power_indicator_properties[POWER_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY] = g_param_spec_boolean ("natural-scroll-touchpad", "natural-scroll-touchpad", "natural-scroll-touchpad", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/Indicator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY, power_indicator_properties[POWER_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY] = g_param_spec_boolean ("natural-scroll-mouse", "natural-scroll-mouse", "natural-scroll-mouse", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1357 "Indicator.c"
}

static void
power_indicator_instance_init (PowerIndicator * self,
                               gpointer klass)
{
#line 20 "../src/Indicator.vala"
	self->priv = power_indicator_get_instance_private (self);
#line 23 "../src/Indicator.vala"
	self->priv->_is_in_session = FALSE;
#line 27 "../src/Indicator.vala"
	self->priv->display_widget = NULL;
#line 29 "../src/Indicator.vala"
	self->priv->popover_widget = NULL;
#line 31 "../src/Indicator.vala"
	self->priv->display_device = NULL;
#line 1374 "Indicator.c"
}

static void
power_indicator_finalize (GObject * obj)
{
	PowerIndicator * self;
#line 20 "../src/Indicator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_INDICATOR, PowerIndicator);
#line 27 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->display_widget);
#line 29 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->popover_widget);
#line 31 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->display_device);
#line 32 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->dm);
#line 34 "../src/Indicator.vala"
	_g_object_unref0 (self->priv->settings);
#line 20 "../src/Indicator.vala"
	G_OBJECT_CLASS (power_indicator_parent_class)->finalize (obj);
#line 1395 "Indicator.c"
}

static GType
power_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerIndicator), 0, (GInstanceInitFunc) power_indicator_instance_init, NULL };
	GType power_indicator_type_id;
	power_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "PowerIndicator", &g_define_type_info, 0);
	PowerIndicator_private_offset = g_type_add_instance_private (power_indicator_type_id, sizeof (PowerIndicatorPrivate));
	return power_indicator_type_id;
}

GType
power_indicator_get_type (void)
{
	static volatile gsize power_indicator_type_id__once = 0;
	if (g_once_init_enter (&power_indicator_type_id__once)) {
		GType power_indicator_type_id;
		power_indicator_type_id = power_indicator_get_type_once ();
		g_once_init_leave (&power_indicator_type_id__once, power_indicator_type_id);
	}
	return power_indicator_type_id__once;
}

static void
_vala_power_indicator_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	PowerIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_INDICATOR, PowerIndicator);
#line 20 "../src/Indicator.vala"
	switch (property_id) {
#line 20 "../src/Indicator.vala"
		case POWER_INDICATOR_IS_IN_SESSION_PROPERTY:
#line 20 "../src/Indicator.vala"
		g_value_set_boolean (value, power_indicator_get_is_in_session (self));
#line 20 "../src/Indicator.vala"
		break;
#line 20 "../src/Indicator.vala"
		case POWER_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY:
#line 20 "../src/Indicator.vala"
		g_value_set_boolean (value, power_indicator_get_natural_scroll_touchpad (self));
#line 20 "../src/Indicator.vala"
		break;
#line 20 "../src/Indicator.vala"
		case POWER_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY:
#line 20 "../src/Indicator.vala"
		g_value_set_boolean (value, power_indicator_get_natural_scroll_mouse (self));
#line 20 "../src/Indicator.vala"
		break;
#line 1448 "Indicator.c"
		default:
#line 20 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Indicator.vala"
		break;
#line 1454 "Indicator.c"
	}
}

static void
_vala_power_indicator_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	PowerIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_INDICATOR, PowerIndicator);
#line 20 "../src/Indicator.vala"
	switch (property_id) {
#line 20 "../src/Indicator.vala"
		case POWER_INDICATOR_IS_IN_SESSION_PROPERTY:
#line 20 "../src/Indicator.vala"
		power_indicator_set_is_in_session (self, g_value_get_boolean (value));
#line 20 "../src/Indicator.vala"
		break;
#line 20 "../src/Indicator.vala"
		case POWER_INDICATOR_NATURAL_SCROLL_TOUCHPAD_PROPERTY:
#line 20 "../src/Indicator.vala"
		power_indicator_set_natural_scroll_touchpad (self, g_value_get_boolean (value));
#line 20 "../src/Indicator.vala"
		break;
#line 20 "../src/Indicator.vala"
		case POWER_INDICATOR_NATURAL_SCROLL_MOUSE_PROPERTY:
#line 20 "../src/Indicator.vala"
		power_indicator_set_natural_scroll_mouse (self, g_value_get_boolean (value));
#line 20 "../src/Indicator.vala"
		break;
#line 1486 "Indicator.c"
		default:
#line 20 "../src/Indicator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Indicator.vala"
		break;
#line 1492 "Indicator.c"
	}
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	PowerIndicator* indicator = NULL;
	PowerIndicator* _tmp0_;
	WingpanelIndicator* result;
#line 223 "../src/Indicator.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 224 "../src/Indicator.vala"
	g_debug ("Indicator.vala:224: Activating Power Indicator");
#line 226 "../src/Indicator.vala"
	_tmp0_ = power_indicator_new (server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION);
#line 226 "../src/Indicator.vala"
	indicator = _tmp0_;
#line 228 "../src/Indicator.vala"
	result = (WingpanelIndicator*) indicator;
#line 228 "../src/Indicator.vala"
	return result;
#line 1515 "Indicator.c"
}

