/* Device.c generated by valac 0.56.17, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * Copyright (c) 2011-2015 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "power.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <gio/gio.h>

#define POWER_SERVICES_DEVICE_DEVICE_INTERFACE "org.freedesktop.UPower"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	POWER_SERVICES_DEVICE_0_PROPERTY,
	POWER_SERVICES_DEVICE_HAS_HISTORY_PROPERTY,
	POWER_SERVICES_DEVICE_HAS_STATISTICS_PROPERTY,
	POWER_SERVICES_DEVICE_IS_PRESENT_PROPERTY,
	POWER_SERVICES_DEVICE_IS_RECHARGEABLE_PROPERTY,
	POWER_SERVICES_DEVICE_ONLINE_PROPERTY,
	POWER_SERVICES_DEVICE_POWER_SUPPLY_PROPERTY,
	POWER_SERVICES_DEVICE_CAPACITY_PROPERTY,
	POWER_SERVICES_DEVICE_ENERGY_PROPERTY,
	POWER_SERVICES_DEVICE_ENERGY_EMPTY_PROPERTY,
	POWER_SERVICES_DEVICE_ENERGY_FULL_PROPERTY,
	POWER_SERVICES_DEVICE_ENERGY_FULL_DESIGN_PROPERTY,
	POWER_SERVICES_DEVICE_ENERGY_RATE_PROPERTY,
	POWER_SERVICES_DEVICE_LUMINOSITY_PROPERTY,
	POWER_SERVICES_DEVICE_PERCENTAGE_PROPERTY,
	POWER_SERVICES_DEVICE_TEMPERATURE_PROPERTY,
	POWER_SERVICES_DEVICE_VOLTAGE_PROPERTY,
	POWER_SERVICES_DEVICE_TIME_TO_EMPTY_PROPERTY,
	POWER_SERVICES_DEVICE_TIME_TO_FULL_PROPERTY,
	POWER_SERVICES_DEVICE_MODEL_PROPERTY,
	POWER_SERVICES_DEVICE_NATIVE_PATH_PROPERTY,
	POWER_SERVICES_DEVICE_SERIAL_PROPERTY,
	POWER_SERVICES_DEVICE_VENDOR_PROPERTY,
	POWER_SERVICES_DEVICE_STATE_PROPERTY,
	POWER_SERVICES_DEVICE_TECHNOLOGY_PROPERTY,
	POWER_SERVICES_DEVICE_DEVICE_TYPE_PROPERTY,
	POWER_SERVICES_DEVICE_UPDATE_TIME_PROPERTY,
	POWER_SERVICES_DEVICE_IS_CHARGING_PROPERTY,
	POWER_SERVICES_DEVICE_IS_A_BATTERY_PROPERTY,
	POWER_SERVICES_DEVICE_NUM_PROPERTIES
};
static GParamSpec* power_services_device_properties[POWER_SERVICES_DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	POWER_SERVICES_DEVICE_PROPERTIES_UPDATED_SIGNAL,
	POWER_SERVICES_DEVICE_NUM_SIGNALS
};
static guint power_services_device_signals[POWER_SERVICES_DEVICE_NUM_SIGNALS] = {0};

struct _PowerServicesDevicePrivate {
	gchar* device_path;
	PowerServicesDBusInterfacesDevice* device;
	gboolean _has_history;
	gboolean _has_statistics;
	gboolean _is_present;
	gboolean _is_rechargeable;
	gboolean _online;
	gboolean _power_supply;
	gdouble _capacity;
	gdouble _energy;
	gdouble _energy_empty;
	gdouble _energy_full;
	gdouble _energy_full_design;
	gdouble _energy_rate;
	gdouble _luminosity;
	gdouble _percentage;
	gdouble _temperature;
	gdouble _voltage;
	gint64 _time_to_empty;
	gint64 _time_to_full;
	gchar* _model;
	gchar* _native_path;
	gchar* _serial;
	gchar* _vendor;
	PowerServicesDeviceState _state;
	PowerServicesDeviceTechnology _technology;
	PowerServicesDeviceType _device_type;
	guint64 _update_time;
	gboolean _is_charging;
	gboolean _is_a_battery;
};

static gint PowerServicesDevice_private_offset;
static gpointer power_services_device_parent_class = NULL;

static gboolean power_services_device_connect_to_bus (PowerServicesDevice* self);
static void power_services_device_update_properties (PowerServicesDevice* self);
static void power_services_device_connect_signals (PowerServicesDevice* self);
static void _power_services_device_update_properties_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                                 GVariant* changed_properties,
                                                                                 gchar** invalidated_properties,
                                                                                 gpointer self);
static void power_services_device_set_has_history (PowerServicesDevice* self,
                                            gboolean value);
static void power_services_device_set_has_statistics (PowerServicesDevice* self,
                                               gboolean value);
static void power_services_device_set_is_present (PowerServicesDevice* self,
                                           gboolean value);
static void power_services_device_set_is_rechargeable (PowerServicesDevice* self,
                                                gboolean value);
static void power_services_device_set_online (PowerServicesDevice* self,
                                       gboolean value);
static void power_services_device_set_power_supply (PowerServicesDevice* self,
                                             gboolean value);
static void power_services_device_set_capacity (PowerServicesDevice* self,
                                         gdouble value);
static void power_services_device_set_energy (PowerServicesDevice* self,
                                       gdouble value);
static void power_services_device_set_energy_empty (PowerServicesDevice* self,
                                             gdouble value);
static void power_services_device_set_energy_full (PowerServicesDevice* self,
                                            gdouble value);
static void power_services_device_set_energy_full_design (PowerServicesDevice* self,
                                                   gdouble value);
static void power_services_device_set_energy_rate (PowerServicesDevice* self,
                                            gdouble value);
static void power_services_device_set_luminosity (PowerServicesDevice* self,
                                           gdouble value);
static void power_services_device_set_percentage (PowerServicesDevice* self,
                                           gdouble value);
static void power_services_device_set_temperature (PowerServicesDevice* self,
                                            gdouble value);
static void power_services_device_set_voltage (PowerServicesDevice* self,
                                        gdouble value);
static void power_services_device_set_time_to_empty (PowerServicesDevice* self,
                                              gint64 value);
static void power_services_device_set_time_to_full (PowerServicesDevice* self,
                                             gint64 value);
static void power_services_device_set_model (PowerServicesDevice* self,
                                      const gchar* value);
static void power_services_device_set_native_path (PowerServicesDevice* self,
                                            const gchar* value);
static void power_services_device_set_serial (PowerServicesDevice* self,
                                       const gchar* value);
static void power_services_device_set_vendor (PowerServicesDevice* self,
                                       const gchar* value);
static PowerServicesDeviceType power_services_device_determine_device_type (PowerServicesDevice* self);
static void power_services_device_set_device_type (PowerServicesDevice* self,
                                            PowerServicesDeviceType value);
static void power_services_device_set_state (PowerServicesDevice* self,
                                      PowerServicesDeviceState value);
static void power_services_device_set_technology (PowerServicesDevice* self,
                                           PowerServicesDeviceTechnology value);
static void power_services_device_set_update_time (PowerServicesDevice* self,
                                            guint64 value);
static void power_services_device_set_is_charging (PowerServicesDevice* self,
                                            gboolean value);
static void power_services_device_set_is_a_battery (PowerServicesDevice* self,
                                             gboolean value);
static const gchar* power_services_device_get_battery_icon (PowerServicesDevice* self);
static void power_services_device_finalize (GObject * obj);
static GType power_services_device_get_type_once (void);
static void _vala_power_services_device_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec);
static void _vala_power_services_device_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec);

static inline gpointer
power_services_device_get_instance_private (PowerServicesDevice* self)
{
	return G_STRUCT_MEMBER_P (self, PowerServicesDevice_private_offset);
}

static GType
power_services_device_state_get_type_once (void)
{
	static const GEnumValue values[] = {{POWER_SERVICES_DEVICE_STATE_UNKNOWN, "POWER_SERVICES_DEVICE_STATE_UNKNOWN", "unknown"}, {POWER_SERVICES_DEVICE_STATE_CHARGING, "POWER_SERVICES_DEVICE_STATE_CHARGING", "charging"}, {POWER_SERVICES_DEVICE_STATE_DISCHARGING, "POWER_SERVICES_DEVICE_STATE_DISCHARGING", "discharging"}, {POWER_SERVICES_DEVICE_STATE_EMPTY, "POWER_SERVICES_DEVICE_STATE_EMPTY", "empty"}, {POWER_SERVICES_DEVICE_STATE_FULLY_CHARGED, "POWER_SERVICES_DEVICE_STATE_FULLY_CHARGED", "fully-charged"}, {POWER_SERVICES_DEVICE_STATE_PENDING_CHARGE, "POWER_SERVICES_DEVICE_STATE_PENDING_CHARGE", "pending-charge"}, {POWER_SERVICES_DEVICE_STATE_PENDING_DISCHARGE, "POWER_SERVICES_DEVICE_STATE_PENDING_DISCHARGE", "pending-discharge"}, {0, NULL, NULL}};
	GType power_services_device_state_type_id;
	power_services_device_state_type_id = g_enum_register_static ("PowerServicesDeviceState", values);
	return power_services_device_state_type_id;
}

GType
power_services_device_state_get_type (void)
{
	static volatile gsize power_services_device_state_type_id__once = 0;
	if (g_once_init_enter (&power_services_device_state_type_id__once)) {
		GType power_services_device_state_type_id;
		power_services_device_state_type_id = power_services_device_state_get_type_once ();
		g_once_init_leave (&power_services_device_state_type_id__once, power_services_device_state_type_id);
	}
	return power_services_device_state_type_id__once;
}

static GType
power_services_device_technology_get_type_once (void)
{
	static const GEnumValue values[] = {{POWER_SERVICES_DEVICE_TECHNOLOGY_UNKNOWN, "POWER_SERVICES_DEVICE_TECHNOLOGY_UNKNOWN", "unknown"}, {POWER_SERVICES_DEVICE_TECHNOLOGY_LITHIUM_ION, "POWER_SERVICES_DEVICE_TECHNOLOGY_LITHIUM_ION", "lithium-ion"}, {POWER_SERVICES_DEVICE_TECHNOLOGY_LITHIUM_POLYMER, "POWER_SERVICES_DEVICE_TECHNOLOGY_LITHIUM_POLYMER", "lithium-polymer"}, {POWER_SERVICES_DEVICE_TECHNOLOGY_LITHIUM_IRON_PHOSPHATE, "POWER_SERVICES_DEVICE_TECHNOLOGY_LITHIUM_IRON_PHOSPHATE", "lithium-iron-phosphate"}, {POWER_SERVICES_DEVICE_TECHNOLOGY_LEAD_ACID, "POWER_SERVICES_DEVICE_TECHNOLOGY_LEAD_ACID", "lead-acid"}, {POWER_SERVICES_DEVICE_TECHNOLOGY_NICKEL_CADMIUM, "POWER_SERVICES_DEVICE_TECHNOLOGY_NICKEL_CADMIUM", "nickel-cadmium"}, {POWER_SERVICES_DEVICE_TECHNOLOGY_NICKEL_METAL_HYDRIDE, "POWER_SERVICES_DEVICE_TECHNOLOGY_NICKEL_METAL_HYDRIDE", "nickel-metal-hydride"}, {0, NULL, NULL}};
	GType power_services_device_technology_type_id;
	power_services_device_technology_type_id = g_enum_register_static ("PowerServicesDeviceTechnology", values);
	return power_services_device_technology_type_id;
}

GType
power_services_device_technology_get_type (void)
{
	static volatile gsize power_services_device_technology_type_id__once = 0;
	if (g_once_init_enter (&power_services_device_technology_type_id__once)) {
		GType power_services_device_technology_type_id;
		power_services_device_technology_type_id = power_services_device_technology_get_type_once ();
		g_once_init_leave (&power_services_device_technology_type_id__once, power_services_device_technology_type_id);
	}
	return power_services_device_technology_type_id__once;
}

const gchar*
power_services_device_type_get_name (PowerServicesDeviceType self)
{
	const gchar* result;
#line 62 "../src/Services/Device.vala"
	switch (self) {
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_BATTERY:
#line 254 "Device.c"
		{
#line 65 "../src/Services/Device.vala"
			result = _ ("Battery");
#line 65 "../src/Services/Device.vala"
			return result;
#line 260 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_UPS:
#line 264 "Device.c"
		{
#line 67 "../src/Services/Device.vala"
			result = _ ("UPS");
#line 67 "../src/Services/Device.vala"
			return result;
#line 270 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_MONITOR:
#line 274 "Device.c"
		{
#line 69 "../src/Services/Device.vala"
			result = _ ("Display");
#line 69 "../src/Services/Device.vala"
			return result;
#line 280 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_MOUSE:
#line 284 "Device.c"
		{
#line 71 "../src/Services/Device.vala"
			result = _ ("Mouse");
#line 71 "../src/Services/Device.vala"
			return result;
#line 290 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_KEYBOARD:
#line 294 "Device.c"
		{
#line 73 "../src/Services/Device.vala"
			result = _ ("Keyboard");
#line 73 "../src/Services/Device.vala"
			return result;
#line 300 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_PDA:
#line 304 "Device.c"
		{
#line 75 "../src/Services/Device.vala"
			result = _ ("PDA");
#line 75 "../src/Services/Device.vala"
			return result;
#line 310 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_PHONE:
#line 314 "Device.c"
		{
#line 77 "../src/Services/Device.vala"
			result = _ ("Phone");
#line 77 "../src/Services/Device.vala"
			return result;
#line 320 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_MEDIA_PLAYER:
#line 324 "Device.c"
		{
#line 79 "../src/Services/Device.vala"
			result = _ ("Media Player");
#line 79 "../src/Services/Device.vala"
			return result;
#line 330 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_TABLET:
#line 334 "Device.c"
		{
#line 81 "../src/Services/Device.vala"
			result = _ ("Tablet");
#line 81 "../src/Services/Device.vala"
			return result;
#line 340 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_COMPUTER:
#line 344 "Device.c"
		{
#line 83 "../src/Services/Device.vala"
			result = _ ("Computer");
#line 83 "../src/Services/Device.vala"
			return result;
#line 350 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_GAMING_INPUT:
#line 354 "Device.c"
		{
#line 85 "../src/Services/Device.vala"
			result = _ ("Controller");
#line 85 "../src/Services/Device.vala"
			return result;
#line 360 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_PEN:
#line 364 "Device.c"
		{
#line 87 "../src/Services/Device.vala"
			result = _ ("Pen");
#line 87 "../src/Services/Device.vala"
			return result;
#line 370 "Device.c"
		}
#line 62 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_LINE_POWER:
#line 374 "Device.c"
		{
#line 89 "../src/Services/Device.vala"
			result = _ ("Plugged In");
#line 89 "../src/Services/Device.vala"
			return result;
#line 380 "Device.c"
		}
		default:
		{
#line 91 "../src/Services/Device.vala"
			result = NULL;
#line 91 "../src/Services/Device.vala"
			return result;
#line 388 "Device.c"
		}
	}
}

const gchar*
power_services_device_type_get_icon_name (PowerServicesDeviceType self)
{
	const gchar* result;
#line 96 "../src/Services/Device.vala"
	switch (self) {
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_UPS:
#line 401 "Device.c"
		{
#line 98 "../src/Services/Device.vala"
			result = "uninterruptible-power-supply";
#line 98 "../src/Services/Device.vala"
			return result;
#line 407 "Device.c"
		}
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_MOUSE:
#line 411 "Device.c"
		{
#line 100 "../src/Services/Device.vala"
			result = "input-mouse";
#line 100 "../src/Services/Device.vala"
			return result;
#line 417 "Device.c"
		}
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_KEYBOARD:
#line 421 "Device.c"
		{
#line 102 "../src/Services/Device.vala"
			result = "input-keyboard";
#line 102 "../src/Services/Device.vala"
			return result;
#line 427 "Device.c"
		}
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_PDA:
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_PHONE:
#line 433 "Device.c"
		{
#line 105 "../src/Services/Device.vala"
			result = "phone";
#line 105 "../src/Services/Device.vala"
			return result;
#line 439 "Device.c"
		}
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_MEDIA_PLAYER:
#line 443 "Device.c"
		{
#line 107 "../src/Services/Device.vala"
			result = "multimedia-player";
#line 107 "../src/Services/Device.vala"
			return result;
#line 449 "Device.c"
		}
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_TABLET:
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_PEN:
#line 455 "Device.c"
		{
#line 110 "../src/Services/Device.vala"
			result = "input-tablet";
#line 110 "../src/Services/Device.vala"
			return result;
#line 461 "Device.c"
		}
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_GAMING_INPUT:
#line 465 "Device.c"
		{
#line 112 "../src/Services/Device.vala"
			result = "input-gaming";
#line 112 "../src/Services/Device.vala"
			return result;
#line 471 "Device.c"
		}
		default:
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_COMPUTER:
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_MONITOR:
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_UNKNOWN:
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_BATTERY:
#line 96 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TYPE_LINE_POWER:
#line 484 "Device.c"
		{
#line 119 "../src/Services/Device.vala"
			result = NULL;
#line 119 "../src/Services/Device.vala"
			return result;
#line 490 "Device.c"
		}
	}
}

static GType
power_services_device_type_get_type_once (void)
{
	static const GEnumValue values[] = {{POWER_SERVICES_DEVICE_TYPE_UNKNOWN, "POWER_SERVICES_DEVICE_TYPE_UNKNOWN", "unknown"}, {POWER_SERVICES_DEVICE_TYPE_LINE_POWER, "POWER_SERVICES_DEVICE_TYPE_LINE_POWER", "line-power"}, {POWER_SERVICES_DEVICE_TYPE_BATTERY, "POWER_SERVICES_DEVICE_TYPE_BATTERY", "battery"}, {POWER_SERVICES_DEVICE_TYPE_UPS, "POWER_SERVICES_DEVICE_TYPE_UPS", "ups"}, {POWER_SERVICES_DEVICE_TYPE_MONITOR, "POWER_SERVICES_DEVICE_TYPE_MONITOR", "monitor"}, {POWER_SERVICES_DEVICE_TYPE_MOUSE, "POWER_SERVICES_DEVICE_TYPE_MOUSE", "mouse"}, {POWER_SERVICES_DEVICE_TYPE_KEYBOARD, "POWER_SERVICES_DEVICE_TYPE_KEYBOARD", "keyboard"}, {POWER_SERVICES_DEVICE_TYPE_PDA, "POWER_SERVICES_DEVICE_TYPE_PDA", "pda"}, {POWER_SERVICES_DEVICE_TYPE_PHONE, "POWER_SERVICES_DEVICE_TYPE_PHONE", "phone"}, {POWER_SERVICES_DEVICE_TYPE_MEDIA_PLAYER, "POWER_SERVICES_DEVICE_TYPE_MEDIA_PLAYER", "media-player"}, {POWER_SERVICES_DEVICE_TYPE_TABLET, "POWER_SERVICES_DEVICE_TYPE_TABLET", "tablet"}, {POWER_SERVICES_DEVICE_TYPE_COMPUTER, "POWER_SERVICES_DEVICE_TYPE_COMPUTER", "computer"}, {POWER_SERVICES_DEVICE_TYPE_GAMING_INPUT, "POWER_SERVICES_DEVICE_TYPE_GAMING_INPUT", "gaming-input"}, {POWER_SERVICES_DEVICE_TYPE_PEN, "POWER_SERVICES_DEVICE_TYPE_PEN", "pen"}, {0, NULL, NULL}};
	GType power_services_device_type_type_id;
	power_services_device_type_type_id = g_enum_register_static ("PowerServicesDeviceType", values);
	return power_services_device_type_type_id;
}

GType
power_services_device_type_get_type (void)
{
	static volatile gsize power_services_device_type_type_id__once = 0;
	if (g_once_init_enter (&power_services_device_type_type_id__once)) {
		GType power_services_device_type_type_id;
		power_services_device_type_type_id = power_services_device_type_get_type_once ();
		g_once_init_leave (&power_services_device_type_type_id__once, power_services_device_type_type_id);
	}
	return power_services_device_type_type_id__once;
}

PowerServicesDevice*
power_services_device_construct (GType object_type,
                                 const gchar* device_path)
{
	PowerServicesDevice * self = NULL;
	gchar* _tmp0_;
#line 161 "../src/Services/Device.vala"
	g_return_val_if_fail (device_path != NULL, NULL);
#line 161 "../src/Services/Device.vala"
	self = (PowerServicesDevice*) g_object_new (object_type, NULL);
#line 162 "../src/Services/Device.vala"
	_tmp0_ = g_strdup (device_path);
#line 162 "../src/Services/Device.vala"
	_g_free0 (self->priv->device_path);
#line 162 "../src/Services/Device.vala"
	self->priv->device_path = _tmp0_;
#line 164 "../src/Services/Device.vala"
	if (power_services_device_connect_to_bus (self)) {
#line 165 "../src/Services/Device.vala"
		power_services_device_update_properties (self);
#line 166 "../src/Services/Device.vala"
		power_services_device_connect_signals (self);
#line 538 "Device.c"
	}
#line 161 "../src/Services/Device.vala"
	return self;
#line 542 "Device.c"
}

PowerServicesDevice*
power_services_device_new (const gchar* device_path)
{
#line 161 "../src/Services/Device.vala"
	return power_services_device_construct (POWER_SERVICES_TYPE_DEVICE, device_path);
#line 550 "Device.c"
}

static gboolean
power_services_device_connect_to_bus (PowerServicesDevice* self)
{
	PowerServicesDBusInterfacesDevice* _tmp7_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 170 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 561 "Device.c"
	{
		PowerServicesDBusInterfacesDevice* _tmp0_ = NULL;
		const gchar* _tmp1_;
		PowerServicesDBusInterfacesDevice* _tmp2_;
		PowerServicesDBusInterfacesDevice* _tmp3_;
#line 172 "../src/Services/Device.vala"
		_tmp1_ = self->priv->device_path;
#line 172 "../src/Services/Device.vala"
		_tmp2_ = (PowerServicesDBusInterfacesDevice*) g_initable_new (POWER_SERVICES_DBUS_INTERFACES_TYPE_DEVICE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", POWER_SERVICES_DEVICE_DEVICE_INTERFACE, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp1_, "g-interface-name", "org.freedesktop.UPower.Device", NULL);
#line 172 "../src/Services/Device.vala"
		_tmp0_ = (PowerServicesDBusInterfacesDevice*) _tmp2_;
#line 172 "../src/Services/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 575 "Device.c"
			goto __catch0_g_error;
		}
#line 172 "../src/Services/Device.vala"
		_tmp3_ = _tmp0_;
#line 172 "../src/Services/Device.vala"
		_tmp0_ = NULL;
#line 172 "../src/Services/Device.vala"
		_g_object_unref0 (self->priv->device);
#line 172 "../src/Services/Device.vala"
		self->priv->device = _tmp3_;
#line 174 "../src/Services/Device.vala"
		g_debug ("Device.vala:174: Connection to UPower device established");
#line 171 "../src/Services/Device.vala"
		_g_object_unref0 (_tmp0_);
#line 590 "Device.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 171 "../src/Services/Device.vala"
		e = _inner_error0_;
#line 171 "../src/Services/Device.vala"
		_inner_error0_ = NULL;
#line 176 "../src/Services/Device.vala"
		_tmp4_ = e;
#line 176 "../src/Services/Device.vala"
		_tmp5_ = _tmp4_->message;
#line 176 "../src/Services/Device.vala"
		g_critical ("Device.vala:176: Connecting to UPower device failed: %s", _tmp5_);
#line 171 "../src/Services/Device.vala"
		_g_error_free0 (e);
#line 610 "Device.c"
	}
	__finally0:
#line 171 "../src/Services/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 615 "Device.c"
		gboolean _tmp6_ = FALSE;
#line 171 "../src/Services/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "../src/Services/Device.vala"
		g_clear_error (&_inner_error0_);
#line 171 "../src/Services/Device.vala"
		return _tmp6_;
#line 623 "Device.c"
	}
#line 179 "../src/Services/Device.vala"
	_tmp7_ = self->priv->device;
#line 179 "../src/Services/Device.vala"
	result = _tmp7_ != NULL;
#line 179 "../src/Services/Device.vala"
	return result;
#line 631 "Device.c"
}

static void
_power_services_device_update_properties_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                            GVariant* changed_properties,
                                                                            gchar** invalidated_properties,
                                                                            gpointer self)
{
#line 183 "../src/Services/Device.vala"
	power_services_device_update_properties ((PowerServicesDevice*) self);
#line 642 "Device.c"
}

static void
power_services_device_connect_signals (PowerServicesDevice* self)
{
	PowerServicesDBusInterfacesDevice* _tmp0_;
#line 182 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 183 "../src/Services/Device.vala"
	_tmp0_ = self->priv->device;
#line 183 "../src/Services/Device.vala"
	g_signal_connect_object ((GDBusProxy*) _tmp0_, "g-properties-changed", (GCallback) _power_services_device_update_properties_g_dbus_proxy_g_properties_changed, self, 0);
#line 655 "Device.c"
}

static void
power_services_device_update_properties (PowerServicesDevice* self)
{
	PowerServicesDBusInterfacesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	PowerServicesDBusInterfacesDevice* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	PowerServicesDBusInterfacesDevice* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	PowerServicesDBusInterfacesDevice* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	PowerServicesDBusInterfacesDevice* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	PowerServicesDBusInterfacesDevice* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	PowerServicesDBusInterfacesDevice* _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	PowerServicesDBusInterfacesDevice* _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
	PowerServicesDBusInterfacesDevice* _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	PowerServicesDBusInterfacesDevice* _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	PowerServicesDBusInterfacesDevice* _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	PowerServicesDBusInterfacesDevice* _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
	PowerServicesDBusInterfacesDevice* _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
	PowerServicesDBusInterfacesDevice* _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	PowerServicesDBusInterfacesDevice* _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	PowerServicesDBusInterfacesDevice* _tmp45_;
	gdouble _tmp46_;
	gdouble _tmp47_;
	PowerServicesDBusInterfacesDevice* _tmp48_;
	gint64 _tmp49_;
	gint64 _tmp50_;
	PowerServicesDBusInterfacesDevice* _tmp51_;
	gint64 _tmp52_;
	gint64 _tmp53_;
	PowerServicesDBusInterfacesDevice* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	gchar* _tmp57_;
	PowerServicesDBusInterfacesDevice* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* _tmp61_;
	PowerServicesDBusInterfacesDevice* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	gchar* _tmp65_;
	PowerServicesDBusInterfacesDevice* _tmp66_;
	gchar* _tmp67_;
	gchar* _tmp68_;
	gchar* _tmp69_;
	PowerServicesDBusInterfacesDevice* _tmp70_;
	guint32 _tmp71_;
	guint32 _tmp72_;
	PowerServicesDBusInterfacesDevice* _tmp73_;
	guint32 _tmp74_;
	guint32 _tmp75_;
	PowerServicesDBusInterfacesDevice* _tmp76_;
	guint64 _tmp77_;
	guint64 _tmp78_;
	gboolean _tmp79_ = FALSE;
	PowerServicesDeviceState _tmp80_;
	gboolean _tmp82_ = FALSE;
	PowerServicesDeviceType _tmp83_;
#line 186 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/Services/Device.vala"
	_tmp0_ = self->priv->device;
#line 187 "../src/Services/Device.vala"
	_tmp1_ = power_services_dbus_interfaces_device_get_has_history (_tmp0_);
#line 187 "../src/Services/Device.vala"
	_tmp2_ = _tmp1_;
#line 187 "../src/Services/Device.vala"
	power_services_device_set_has_history (self, _tmp2_);
#line 188 "../src/Services/Device.vala"
	_tmp3_ = self->priv->device;
#line 188 "../src/Services/Device.vala"
	_tmp4_ = power_services_dbus_interfaces_device_get_has_statistics (_tmp3_);
#line 188 "../src/Services/Device.vala"
	_tmp5_ = _tmp4_;
#line 188 "../src/Services/Device.vala"
	power_services_device_set_has_statistics (self, _tmp5_);
#line 189 "../src/Services/Device.vala"
	_tmp6_ = self->priv->device;
#line 189 "../src/Services/Device.vala"
	_tmp7_ = power_services_dbus_interfaces_device_get_is_present (_tmp6_);
#line 189 "../src/Services/Device.vala"
	_tmp8_ = _tmp7_;
#line 189 "../src/Services/Device.vala"
	power_services_device_set_is_present (self, _tmp8_);
#line 190 "../src/Services/Device.vala"
	_tmp9_ = self->priv->device;
#line 190 "../src/Services/Device.vala"
	_tmp10_ = power_services_dbus_interfaces_device_get_is_rechargeable (_tmp9_);
#line 190 "../src/Services/Device.vala"
	_tmp11_ = _tmp10_;
#line 190 "../src/Services/Device.vala"
	power_services_device_set_is_rechargeable (self, _tmp11_);
#line 191 "../src/Services/Device.vala"
	_tmp12_ = self->priv->device;
#line 191 "../src/Services/Device.vala"
	_tmp13_ = power_services_dbus_interfaces_device_get_online (_tmp12_);
#line 191 "../src/Services/Device.vala"
	_tmp14_ = _tmp13_;
#line 191 "../src/Services/Device.vala"
	power_services_device_set_online (self, _tmp14_);
#line 192 "../src/Services/Device.vala"
	_tmp15_ = self->priv->device;
#line 192 "../src/Services/Device.vala"
	_tmp16_ = power_services_dbus_interfaces_device_get_power_supply (_tmp15_);
#line 192 "../src/Services/Device.vala"
	_tmp17_ = _tmp16_;
#line 192 "../src/Services/Device.vala"
	power_services_device_set_power_supply (self, _tmp17_);
#line 193 "../src/Services/Device.vala"
	_tmp18_ = self->priv->device;
#line 193 "../src/Services/Device.vala"
	_tmp19_ = power_services_dbus_interfaces_device_get_capacity (_tmp18_);
#line 193 "../src/Services/Device.vala"
	_tmp20_ = _tmp19_;
#line 193 "../src/Services/Device.vala"
	power_services_device_set_capacity (self, _tmp20_);
#line 194 "../src/Services/Device.vala"
	_tmp21_ = self->priv->device;
#line 194 "../src/Services/Device.vala"
	_tmp22_ = power_services_dbus_interfaces_device_get_energy (_tmp21_);
#line 194 "../src/Services/Device.vala"
	_tmp23_ = _tmp22_;
#line 194 "../src/Services/Device.vala"
	power_services_device_set_energy (self, _tmp23_);
#line 195 "../src/Services/Device.vala"
	_tmp24_ = self->priv->device;
#line 195 "../src/Services/Device.vala"
	_tmp25_ = power_services_dbus_interfaces_device_get_energy_empty (_tmp24_);
#line 195 "../src/Services/Device.vala"
	_tmp26_ = _tmp25_;
#line 195 "../src/Services/Device.vala"
	power_services_device_set_energy_empty (self, _tmp26_);
#line 196 "../src/Services/Device.vala"
	_tmp27_ = self->priv->device;
#line 196 "../src/Services/Device.vala"
	_tmp28_ = power_services_dbus_interfaces_device_get_energy_full (_tmp27_);
#line 196 "../src/Services/Device.vala"
	_tmp29_ = _tmp28_;
#line 196 "../src/Services/Device.vala"
	power_services_device_set_energy_full (self, _tmp29_);
#line 197 "../src/Services/Device.vala"
	_tmp30_ = self->priv->device;
#line 197 "../src/Services/Device.vala"
	_tmp31_ = power_services_dbus_interfaces_device_get_energy_full_design (_tmp30_);
#line 197 "../src/Services/Device.vala"
	_tmp32_ = _tmp31_;
#line 197 "../src/Services/Device.vala"
	power_services_device_set_energy_full_design (self, _tmp32_);
#line 198 "../src/Services/Device.vala"
	_tmp33_ = self->priv->device;
#line 198 "../src/Services/Device.vala"
	_tmp34_ = power_services_dbus_interfaces_device_get_energy_rate (_tmp33_);
#line 198 "../src/Services/Device.vala"
	_tmp35_ = _tmp34_;
#line 198 "../src/Services/Device.vala"
	power_services_device_set_energy_rate (self, _tmp35_);
#line 199 "../src/Services/Device.vala"
	_tmp36_ = self->priv->device;
#line 199 "../src/Services/Device.vala"
	_tmp37_ = power_services_dbus_interfaces_device_get_luminosity (_tmp36_);
#line 199 "../src/Services/Device.vala"
	_tmp38_ = _tmp37_;
#line 199 "../src/Services/Device.vala"
	power_services_device_set_luminosity (self, _tmp38_);
#line 200 "../src/Services/Device.vala"
	_tmp39_ = self->priv->device;
#line 200 "../src/Services/Device.vala"
	_tmp40_ = power_services_dbus_interfaces_device_get_percentage (_tmp39_);
#line 200 "../src/Services/Device.vala"
	_tmp41_ = _tmp40_;
#line 200 "../src/Services/Device.vala"
	power_services_device_set_percentage (self, _tmp41_);
#line 201 "../src/Services/Device.vala"
	_tmp42_ = self->priv->device;
#line 201 "../src/Services/Device.vala"
	_tmp43_ = power_services_dbus_interfaces_device_get_temperature (_tmp42_);
#line 201 "../src/Services/Device.vala"
	_tmp44_ = _tmp43_;
#line 201 "../src/Services/Device.vala"
	power_services_device_set_temperature (self, _tmp44_);
#line 202 "../src/Services/Device.vala"
	_tmp45_ = self->priv->device;
#line 202 "../src/Services/Device.vala"
	_tmp46_ = power_services_dbus_interfaces_device_get_voltage (_tmp45_);
#line 202 "../src/Services/Device.vala"
	_tmp47_ = _tmp46_;
#line 202 "../src/Services/Device.vala"
	power_services_device_set_voltage (self, _tmp47_);
#line 203 "../src/Services/Device.vala"
	_tmp48_ = self->priv->device;
#line 203 "../src/Services/Device.vala"
	_tmp49_ = power_services_dbus_interfaces_device_get_time_to_empty (_tmp48_);
#line 203 "../src/Services/Device.vala"
	_tmp50_ = _tmp49_;
#line 203 "../src/Services/Device.vala"
	power_services_device_set_time_to_empty (self, _tmp50_);
#line 204 "../src/Services/Device.vala"
	_tmp51_ = self->priv->device;
#line 204 "../src/Services/Device.vala"
	_tmp52_ = power_services_dbus_interfaces_device_get_time_to_full (_tmp51_);
#line 204 "../src/Services/Device.vala"
	_tmp53_ = _tmp52_;
#line 204 "../src/Services/Device.vala"
	power_services_device_set_time_to_full (self, _tmp53_);
#line 205 "../src/Services/Device.vala"
	_tmp54_ = self->priv->device;
#line 205 "../src/Services/Device.vala"
	_tmp55_ = power_services_dbus_interfaces_device_get_model (_tmp54_);
#line 205 "../src/Services/Device.vala"
	_tmp56_ = _tmp55_;
#line 205 "../src/Services/Device.vala"
	_tmp57_ = _tmp56_;
#line 205 "../src/Services/Device.vala"
	power_services_device_set_model (self, _tmp57_);
#line 205 "../src/Services/Device.vala"
	_g_free0 (_tmp57_);
#line 206 "../src/Services/Device.vala"
	_tmp58_ = self->priv->device;
#line 206 "../src/Services/Device.vala"
	_tmp59_ = power_services_dbus_interfaces_device_get_native_path (_tmp58_);
#line 206 "../src/Services/Device.vala"
	_tmp60_ = _tmp59_;
#line 206 "../src/Services/Device.vala"
	_tmp61_ = _tmp60_;
#line 206 "../src/Services/Device.vala"
	power_services_device_set_native_path (self, _tmp61_);
#line 206 "../src/Services/Device.vala"
	_g_free0 (_tmp61_);
#line 207 "../src/Services/Device.vala"
	_tmp62_ = self->priv->device;
#line 207 "../src/Services/Device.vala"
	_tmp63_ = power_services_dbus_interfaces_device_get_serial (_tmp62_);
#line 207 "../src/Services/Device.vala"
	_tmp64_ = _tmp63_;
#line 207 "../src/Services/Device.vala"
	_tmp65_ = _tmp64_;
#line 207 "../src/Services/Device.vala"
	power_services_device_set_serial (self, _tmp65_);
#line 207 "../src/Services/Device.vala"
	_g_free0 (_tmp65_);
#line 208 "../src/Services/Device.vala"
	_tmp66_ = self->priv->device;
#line 208 "../src/Services/Device.vala"
	_tmp67_ = power_services_dbus_interfaces_device_get_vendor (_tmp66_);
#line 208 "../src/Services/Device.vala"
	_tmp68_ = _tmp67_;
#line 208 "../src/Services/Device.vala"
	_tmp69_ = _tmp68_;
#line 208 "../src/Services/Device.vala"
	power_services_device_set_vendor (self, _tmp69_);
#line 208 "../src/Services/Device.vala"
	_g_free0 (_tmp69_);
#line 209 "../src/Services/Device.vala"
	power_services_device_set_device_type (self, power_services_device_determine_device_type (self));
#line 210 "../src/Services/Device.vala"
	_tmp70_ = self->priv->device;
#line 210 "../src/Services/Device.vala"
	_tmp71_ = power_services_dbus_interfaces_device_get_state (_tmp70_);
#line 210 "../src/Services/Device.vala"
	_tmp72_ = _tmp71_;
#line 210 "../src/Services/Device.vala"
	power_services_device_set_state (self, (PowerServicesDeviceState) _tmp72_);
#line 211 "../src/Services/Device.vala"
	_tmp73_ = self->priv->device;
#line 211 "../src/Services/Device.vala"
	_tmp74_ = power_services_dbus_interfaces_device_get_technology (_tmp73_);
#line 211 "../src/Services/Device.vala"
	_tmp75_ = _tmp74_;
#line 211 "../src/Services/Device.vala"
	power_services_device_set_technology (self, (PowerServicesDeviceTechnology) _tmp75_);
#line 212 "../src/Services/Device.vala"
	_tmp76_ = self->priv->device;
#line 212 "../src/Services/Device.vala"
	_tmp77_ = power_services_dbus_interfaces_device_get_update_time (_tmp76_);
#line 212 "../src/Services/Device.vala"
	_tmp78_ = _tmp77_;
#line 212 "../src/Services/Device.vala"
	power_services_device_set_update_time (self, _tmp78_);
#line 214 "../src/Services/Device.vala"
	_tmp80_ = self->priv->_state;
#line 214 "../src/Services/Device.vala"
	if (_tmp80_ == POWER_SERVICES_DEVICE_STATE_FULLY_CHARGED) {
#line 214 "../src/Services/Device.vala"
		_tmp79_ = TRUE;
#line 970 "Device.c"
	} else {
		PowerServicesDeviceState _tmp81_;
#line 214 "../src/Services/Device.vala"
		_tmp81_ = self->priv->_state;
#line 214 "../src/Services/Device.vala"
		_tmp79_ = _tmp81_ == POWER_SERVICES_DEVICE_STATE_CHARGING;
#line 977 "Device.c"
	}
#line 214 "../src/Services/Device.vala"
	power_services_device_set_is_charging (self, _tmp79_);
#line 215 "../src/Services/Device.vala"
	_tmp83_ = self->priv->_device_type;
#line 215 "../src/Services/Device.vala"
	if (_tmp83_ != POWER_SERVICES_DEVICE_TYPE_UNKNOWN) {
#line 985 "Device.c"
		PowerServicesDeviceType _tmp84_;
#line 215 "../src/Services/Device.vala"
		_tmp84_ = self->priv->_device_type;
#line 215 "../src/Services/Device.vala"
		_tmp82_ = _tmp84_ != POWER_SERVICES_DEVICE_TYPE_LINE_POWER;
#line 991 "Device.c"
	} else {
#line 215 "../src/Services/Device.vala"
		_tmp82_ = FALSE;
#line 995 "Device.c"
	}
#line 215 "../src/Services/Device.vala"
	power_services_device_set_is_a_battery (self, _tmp82_);
#line 217 "../src/Services/Device.vala"
	g_signal_emit (self, power_services_device_signals[POWER_SERVICES_DEVICE_PROPERTIES_UPDATED_SIGNAL], 0);
#line 1001 "Device.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1020 "Device.c"
}

static PowerServicesDeviceType
power_services_device_determine_device_type (PowerServicesDevice* self)
{
	gboolean _tmp0_ = FALSE;
	PowerServicesDBusInterfacesDevice* _tmp1_;
	guint32 _tmp2_;
	guint32 _tmp3_;
	PowerServicesDBusInterfacesDevice* _tmp8_;
	guint32 _tmp9_;
	guint32 _tmp10_;
	PowerServicesDeviceType result;
#line 220 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 223 "../src/Services/Device.vala"
	_tmp1_ = self->priv->device;
#line 223 "../src/Services/Device.vala"
	_tmp2_ = power_services_dbus_interfaces_device_get_Type (_tmp1_);
#line 223 "../src/Services/Device.vala"
	_tmp3_ = _tmp2_;
#line 223 "../src/Services/Device.vala"
	if (_tmp3_ == ((guint32) POWER_SERVICES_DEVICE_TYPE_MOUSE)) {
#line 1044 "Device.c"
		PowerServicesDBusInterfacesDevice* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 223 "../src/Services/Device.vala"
		_tmp4_ = self->priv->device;
#line 223 "../src/Services/Device.vala"
		_tmp5_ = power_services_dbus_interfaces_device_get_model (_tmp4_);
#line 223 "../src/Services/Device.vala"
		_tmp6_ = _tmp5_;
#line 223 "../src/Services/Device.vala"
		_tmp7_ = _tmp6_;
#line 223 "../src/Services/Device.vala"
		_tmp0_ = string_contains (_tmp7_, "keyboard");
#line 223 "../src/Services/Device.vala"
		_g_free0 (_tmp7_);
#line 1061 "Device.c"
	} else {
#line 223 "../src/Services/Device.vala"
		_tmp0_ = FALSE;
#line 1065 "Device.c"
	}
#line 223 "../src/Services/Device.vala"
	if (_tmp0_) {
#line 224 "../src/Services/Device.vala"
		result = (PowerServicesDeviceType) POWER_SERVICES_DEVICE_TYPE_KEYBOARD;
#line 224 "../src/Services/Device.vala"
		return result;
#line 1073 "Device.c"
	}
#line 226 "../src/Services/Device.vala"
	_tmp8_ = self->priv->device;
#line 226 "../src/Services/Device.vala"
	_tmp9_ = power_services_dbus_interfaces_device_get_Type (_tmp8_);
#line 226 "../src/Services/Device.vala"
	_tmp10_ = _tmp9_;
#line 226 "../src/Services/Device.vala"
	result = (PowerServicesDeviceType) _tmp10_;
#line 226 "../src/Services/Device.vala"
	return result;
#line 1085 "Device.c"
}

gchar*
power_services_device_get_symbolic_icon_name_for_battery (PowerServicesDevice* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result;
#line 229 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 230 "../src/Services/Device.vala"
	_tmp0_ = power_services_device_get_icon_name_for_battery (self);
#line 230 "../src/Services/Device.vala"
	_tmp1_ = _tmp0_;
#line 230 "../src/Services/Device.vala"
	_tmp2_ = g_strconcat (_tmp1_, "-symbolic", NULL);
#line 230 "../src/Services/Device.vala"
	_tmp3_ = _tmp2_;
#line 230 "../src/Services/Device.vala"
	_g_free0 (_tmp1_);
#line 230 "../src/Services/Device.vala"
	result = _tmp3_;
#line 230 "../src/Services/Device.vala"
	return result;
#line 1112 "Device.c"
}

gchar*
power_services_device_get_icon_name_for_battery (PowerServicesDevice* self)
{
	gboolean _tmp0_;
	gboolean _tmp2_ = FALSE;
	gdouble _tmp3_;
	const gchar* battery_icon = NULL;
	const gchar* _tmp6_;
	gboolean _tmp7_;
	gchar* result;
#line 233 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 234 "../src/Services/Device.vala"
	_tmp0_ = self->priv->_is_a_battery;
#line 234 "../src/Services/Device.vala"
	if (!_tmp0_) {
#line 1131 "Device.c"
		gchar* _tmp1_;
#line 235 "../src/Services/Device.vala"
		_tmp1_ = g_strdup ("preferences-system-power-symbolic");
#line 235 "../src/Services/Device.vala"
		result = _tmp1_;
#line 235 "../src/Services/Device.vala"
		return result;
#line 1139 "Device.c"
	}
#line 237 "../src/Services/Device.vala"
	_tmp3_ = self->priv->_percentage;
#line 237 "../src/Services/Device.vala"
	if (_tmp3_ == ((gdouble) 100)) {
#line 1145 "Device.c"
		gboolean _tmp4_;
#line 237 "../src/Services/Device.vala"
		_tmp4_ = self->priv->_is_charging;
#line 237 "../src/Services/Device.vala"
		_tmp2_ = _tmp4_;
#line 1151 "Device.c"
	} else {
#line 237 "../src/Services/Device.vala"
		_tmp2_ = FALSE;
#line 1155 "Device.c"
	}
#line 237 "../src/Services/Device.vala"
	if (_tmp2_) {
#line 1159 "Device.c"
		gchar* _tmp5_;
#line 238 "../src/Services/Device.vala"
		_tmp5_ = g_strdup ("battery-full-charged");
#line 238 "../src/Services/Device.vala"
		result = _tmp5_;
#line 238 "../src/Services/Device.vala"
		return result;
#line 1167 "Device.c"
	}
#line 240 "../src/Services/Device.vala"
	_tmp6_ = power_services_device_get_battery_icon (self);
#line 240 "../src/Services/Device.vala"
	battery_icon = _tmp6_;
#line 241 "../src/Services/Device.vala"
	_tmp7_ = self->priv->_is_charging;
#line 241 "../src/Services/Device.vala"
	if (_tmp7_) {
#line 1177 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 242 "../src/Services/Device.vala"
		_tmp8_ = battery_icon;
#line 242 "../src/Services/Device.vala"
		_tmp9_ = g_strconcat (_tmp8_, "-charging", NULL);
#line 242 "../src/Services/Device.vala"
		result = _tmp9_;
#line 242 "../src/Services/Device.vala"
		return result;
#line 1188 "Device.c"
	} else {
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 244 "../src/Services/Device.vala"
		_tmp10_ = battery_icon;
#line 244 "../src/Services/Device.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 244 "../src/Services/Device.vala"
		result = _tmp11_;
#line 244 "../src/Services/Device.vala"
		return result;
#line 1200 "Device.c"
	}
}

static const gchar*
power_services_device_get_battery_icon (PowerServicesDevice* self)
{
	gdouble _tmp0_;
	gboolean _tmp1_ = FALSE;
	gdouble _tmp2_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	const gchar* result;
#line 248 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 249 "../src/Services/Device.vala"
	_tmp0_ = self->priv->_percentage;
#line 249 "../src/Services/Device.vala"
	if (_tmp0_ <= ((gdouble) 0)) {
#line 250 "../src/Services/Device.vala"
		result = "battery-good";
#line 250 "../src/Services/Device.vala"
		return result;
#line 1224 "Device.c"
	}
#line 253 "../src/Services/Device.vala"
	_tmp2_ = self->priv->_percentage;
#line 253 "../src/Services/Device.vala"
	if (_tmp2_ < ((gdouble) 10)) {
#line 1230 "Device.c"
		gboolean _tmp3_ = FALSE;
		gint64 _tmp4_;
#line 253 "../src/Services/Device.vala"
		_tmp4_ = self->priv->_time_to_empty;
#line 253 "../src/Services/Device.vala"
		if (_tmp4_ == ((gint64) 0)) {
#line 253 "../src/Services/Device.vala"
			_tmp3_ = TRUE;
#line 1239 "Device.c"
		} else {
			gint64 _tmp5_;
#line 253 "../src/Services/Device.vala"
			_tmp5_ = self->priv->_time_to_empty;
#line 253 "../src/Services/Device.vala"
			_tmp3_ = _tmp5_ < ((gint64) (30 * 60));
#line 1246 "Device.c"
		}
#line 253 "../src/Services/Device.vala"
		_tmp1_ = _tmp3_;
#line 1250 "Device.c"
	} else {
#line 253 "../src/Services/Device.vala"
		_tmp1_ = FALSE;
#line 1254 "Device.c"
	}
#line 253 "../src/Services/Device.vala"
	if (_tmp1_) {
#line 254 "../src/Services/Device.vala"
		result = "battery-empty";
#line 254 "../src/Services/Device.vala"
		return result;
#line 1262 "Device.c"
	}
#line 257 "../src/Services/Device.vala"
	_tmp6_ = self->priv->_percentage;
#line 257 "../src/Services/Device.vala"
	if (_tmp6_ < ((gdouble) 37.5f)) {
#line 258 "../src/Services/Device.vala"
		result = "battery-caution";
#line 258 "../src/Services/Device.vala"
		return result;
#line 1272 "Device.c"
	}
#line 261 "../src/Services/Device.vala"
	_tmp7_ = self->priv->_percentage;
#line 261 "../src/Services/Device.vala"
	if (_tmp7_ < ((gdouble) 62.5f)) {
#line 262 "../src/Services/Device.vala"
		result = "battery-low";
#line 262 "../src/Services/Device.vala"
		return result;
#line 1282 "Device.c"
	}
#line 265 "../src/Services/Device.vala"
	_tmp8_ = self->priv->_percentage;
#line 265 "../src/Services/Device.vala"
	if (_tmp8_ < ((gdouble) 87.5f)) {
#line 266 "../src/Services/Device.vala"
		result = "battery-good";
#line 266 "../src/Services/Device.vala"
		return result;
#line 1292 "Device.c"
	}
#line 269 "../src/Services/Device.vala"
	result = "battery-full";
#line 269 "../src/Services/Device.vala"
	return result;
#line 1298 "Device.c"
}

gchar*
power_services_device_get_info (PowerServicesDevice* self)
{
	gint percent = 0;
	gdouble _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp4_ = FALSE;
	gchar* info = NULL;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gchar* result;
#line 272 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 273 "../src/Services/Device.vala"
	_tmp0_ = self->priv->_percentage;
#line 273 "../src/Services/Device.vala"
	percent = (gint) round (_tmp0_);
#line 275 "../src/Services/Device.vala"
	_tmp1_ = self->priv->_is_a_battery;
#line 275 "../src/Services/Device.vala"
	if (!_tmp1_) {
#line 1322 "Device.c"
		gchar* _tmp2_;
#line 276 "../src/Services/Device.vala"
		_tmp2_ = g_strdup ("");
#line 276 "../src/Services/Device.vala"
		result = _tmp2_;
#line 276 "../src/Services/Device.vala"
		return result;
#line 1330 "Device.c"
	}
#line 279 "../src/Services/Device.vala"
	if (percent <= 0) {
#line 1334 "Device.c"
		gchar* _tmp3_;
#line 280 "../src/Services/Device.vala"
		_tmp3_ = g_strdup (_ ("Calculating…"));
#line 280 "../src/Services/Device.vala"
		result = _tmp3_;
#line 280 "../src/Services/Device.vala"
		return result;
#line 1342 "Device.c"
	}
#line 283 "../src/Services/Device.vala"
	if (percent == 100) {
#line 1346 "Device.c"
		gboolean _tmp5_;
#line 283 "../src/Services/Device.vala"
		_tmp5_ = self->priv->_is_charging;
#line 283 "../src/Services/Device.vala"
		_tmp4_ = _tmp5_;
#line 1352 "Device.c"
	} else {
#line 283 "../src/Services/Device.vala"
		_tmp4_ = FALSE;
#line 1356 "Device.c"
	}
#line 283 "../src/Services/Device.vala"
	if (_tmp4_) {
#line 1360 "Device.c"
		gchar* _tmp6_;
#line 284 "../src/Services/Device.vala"
		_tmp6_ = g_strdup (_ ("Fully charged"));
#line 284 "../src/Services/Device.vala"
		result = _tmp6_;
#line 284 "../src/Services/Device.vala"
		return result;
#line 1368 "Device.c"
	}
#line 287 "../src/Services/Device.vala"
	_tmp7_ = g_strdup ("");
#line 287 "../src/Services/Device.vala"
	info = _tmp7_;
#line 289 "../src/Services/Device.vala"
	_tmp8_ = self->priv->_is_charging;
#line 289 "../src/Services/Device.vala"
	if (_tmp8_) {
#line 1378 "Device.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gint64 _tmp13_;
#line 290 "../src/Services/Device.vala"
		_tmp9_ = info;
#line 290 "../src/Services/Device.vala"
		_tmp10_ = g_strdup_printf (_ ("%i%% charged"), percent);
#line 290 "../src/Services/Device.vala"
		_tmp11_ = _tmp10_;
#line 290 "../src/Services/Device.vala"
		_tmp12_ = g_strconcat (_tmp9_, _tmp11_, NULL);
#line 290 "../src/Services/Device.vala"
		_g_free0 (info);
#line 290 "../src/Services/Device.vala"
		info = _tmp12_;
#line 290 "../src/Services/Device.vala"
		_g_free0 (_tmp11_);
#line 292 "../src/Services/Device.vala"
		_tmp13_ = self->priv->_time_to_full;
#line 292 "../src/Services/Device.vala"
		if (_tmp13_ > ((gint64) 0)) {
#line 1402 "Device.c"
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gint64 _tmp16_;
#line 293 "../src/Services/Device.vala"
			_tmp14_ = info;
#line 293 "../src/Services/Device.vala"
			_tmp15_ = g_strconcat (_tmp14_, " - ", NULL);
#line 293 "../src/Services/Device.vala"
			_g_free0 (info);
#line 293 "../src/Services/Device.vala"
			info = _tmp15_;
#line 294 "../src/Services/Device.vala"
			_tmp16_ = self->priv->_time_to_full;
#line 294 "../src/Services/Device.vala"
			if (_tmp16_ >= ((gint64) 3600)) {
#line 1418 "Device.c"
				gint64 hours = 0LL;
				gint64 _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 295 "../src/Services/Device.vala"
				_tmp17_ = self->priv->_time_to_full;
#line 295 "../src/Services/Device.vala"
				hours = _tmp17_ / 3600;
#line 296 "../src/Services/Device.vala"
				_tmp18_ = info;
#line 296 "../src/Services/Device.vala"
				_tmp19_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until full", "%lld hours until full", (gulong) hours), hours);
#line 296 "../src/Services/Device.vala"
				_tmp20_ = _tmp19_;
#line 296 "../src/Services/Device.vala"
				_tmp21_ = g_strconcat (_tmp18_, _tmp20_, NULL);
#line 296 "../src/Services/Device.vala"
				_g_free0 (info);
#line 296 "../src/Services/Device.vala"
				info = _tmp21_;
#line 296 "../src/Services/Device.vala"
				_g_free0 (_tmp20_);
#line 1443 "Device.c"
			} else {
				gint64 _tmp22_;
#line 302 "../src/Services/Device.vala"
				_tmp22_ = self->priv->_time_to_full;
#line 302 "../src/Services/Device.vala"
				if (_tmp22_ >= ((gint64) 60)) {
#line 1450 "Device.c"
					gint64 minutes = 0LL;
					gint64 _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
#line 303 "../src/Services/Device.vala"
					_tmp23_ = self->priv->_time_to_full;
#line 303 "../src/Services/Device.vala"
					minutes = _tmp23_ / 60;
#line 304 "../src/Services/Device.vala"
					_tmp24_ = info;
#line 304 "../src/Services/Device.vala"
					_tmp25_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until full", "%lld minutes until full", (gulong) minutes), minutes);
#line 304 "../src/Services/Device.vala"
					_tmp26_ = _tmp25_;
#line 304 "../src/Services/Device.vala"
					_tmp27_ = g_strconcat (_tmp24_, _tmp26_, NULL);
#line 304 "../src/Services/Device.vala"
					_g_free0 (info);
#line 304 "../src/Services/Device.vala"
					info = _tmp27_;
#line 304 "../src/Services/Device.vala"
					_g_free0 (_tmp26_);
#line 1475 "Device.c"
				} else {
					const gchar* _tmp28_;
					gint64 _tmp29_;
					gint64 _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
#line 311 "../src/Services/Device.vala"
					_tmp28_ = info;
#line 311 "../src/Services/Device.vala"
					_tmp29_ = self->priv->_time_to_full;
#line 311 "../src/Services/Device.vala"
					_tmp30_ = self->priv->_time_to_full;
#line 311 "../src/Services/Device.vala"
					_tmp31_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until full", "%lld seconds until full", (gulong) _tmp29_), _tmp30_);
#line 311 "../src/Services/Device.vala"
					_tmp32_ = _tmp31_;
#line 311 "../src/Services/Device.vala"
					_tmp33_ = g_strconcat (_tmp28_, _tmp32_, NULL);
#line 311 "../src/Services/Device.vala"
					_g_free0 (info);
#line 311 "../src/Services/Device.vala"
					info = _tmp33_;
#line 311 "../src/Services/Device.vala"
					_g_free0 (_tmp32_);
#line 1501 "Device.c"
				}
			}
		}
	} else {
		const gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gint64 _tmp38_;
#line 320 "../src/Services/Device.vala"
		_tmp34_ = info;
#line 320 "../src/Services/Device.vala"
		_tmp35_ = g_strdup_printf (_ ("%i%% remaining"), percent);
#line 320 "../src/Services/Device.vala"
		_tmp36_ = _tmp35_;
#line 320 "../src/Services/Device.vala"
		_tmp37_ = g_strconcat (_tmp34_, _tmp36_, NULL);
#line 320 "../src/Services/Device.vala"
		_g_free0 (info);
#line 320 "../src/Services/Device.vala"
		info = _tmp37_;
#line 320 "../src/Services/Device.vala"
		_g_free0 (_tmp36_);
#line 322 "../src/Services/Device.vala"
		_tmp38_ = self->priv->_time_to_empty;
#line 322 "../src/Services/Device.vala"
		if (_tmp38_ > ((gint64) 0)) {
#line 1529 "Device.c"
			const gchar* _tmp39_;
			gchar* _tmp40_;
			gint64 _tmp41_;
#line 323 "../src/Services/Device.vala"
			_tmp39_ = info;
#line 323 "../src/Services/Device.vala"
			_tmp40_ = g_strconcat (_tmp39_, " - ", NULL);
#line 323 "../src/Services/Device.vala"
			_g_free0 (info);
#line 323 "../src/Services/Device.vala"
			info = _tmp40_;
#line 324 "../src/Services/Device.vala"
			_tmp41_ = self->priv->_time_to_empty;
#line 324 "../src/Services/Device.vala"
			if (_tmp41_ >= ((gint64) 3600)) {
#line 1545 "Device.c"
				gint64 hours = 0LL;
				gint64 _tmp42_;
				const gchar* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
#line 325 "../src/Services/Device.vala"
				_tmp42_ = self->priv->_time_to_empty;
#line 325 "../src/Services/Device.vala"
				hours = _tmp42_ / 3600;
#line 326 "../src/Services/Device.vala"
				_tmp43_ = info;
#line 326 "../src/Services/Device.vala"
				_tmp44_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until empty", "%lld hours until empty", (gulong) hours), hours);
#line 326 "../src/Services/Device.vala"
				_tmp45_ = _tmp44_;
#line 326 "../src/Services/Device.vala"
				_tmp46_ = g_strconcat (_tmp43_, _tmp45_, NULL);
#line 326 "../src/Services/Device.vala"
				_g_free0 (info);
#line 326 "../src/Services/Device.vala"
				info = _tmp46_;
#line 326 "../src/Services/Device.vala"
				_g_free0 (_tmp45_);
#line 1570 "Device.c"
			} else {
				gint64 _tmp47_;
#line 332 "../src/Services/Device.vala"
				_tmp47_ = self->priv->_time_to_empty;
#line 332 "../src/Services/Device.vala"
				if (_tmp47_ >= ((gint64) 60)) {
#line 1577 "Device.c"
					gint64 minutes = 0LL;
					gint64 _tmp48_;
					const gchar* _tmp49_;
					gchar* _tmp50_;
					gchar* _tmp51_;
					gchar* _tmp52_;
#line 333 "../src/Services/Device.vala"
					_tmp48_ = self->priv->_time_to_empty;
#line 333 "../src/Services/Device.vala"
					minutes = _tmp48_ / 60;
#line 334 "../src/Services/Device.vala"
					_tmp49_ = info;
#line 334 "../src/Services/Device.vala"
					_tmp50_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until empty", "%lld minutes until empty", (gulong) minutes), minutes);
#line 334 "../src/Services/Device.vala"
					_tmp51_ = _tmp50_;
#line 334 "../src/Services/Device.vala"
					_tmp52_ = g_strconcat (_tmp49_, _tmp51_, NULL);
#line 334 "../src/Services/Device.vala"
					_g_free0 (info);
#line 334 "../src/Services/Device.vala"
					info = _tmp52_;
#line 334 "../src/Services/Device.vala"
					_g_free0 (_tmp51_);
#line 1602 "Device.c"
				} else {
					const gchar* _tmp53_;
					gint64 _tmp54_;
					gint64 _tmp55_;
					gchar* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
#line 341 "../src/Services/Device.vala"
					_tmp53_ = info;
#line 341 "../src/Services/Device.vala"
					_tmp54_ = self->priv->_time_to_empty;
#line 341 "../src/Services/Device.vala"
					_tmp55_ = self->priv->_time_to_empty;
#line 341 "../src/Services/Device.vala"
					_tmp56_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until empty", "%lld seconds until empty", (gulong) _tmp54_), _tmp55_);
#line 341 "../src/Services/Device.vala"
					_tmp57_ = _tmp56_;
#line 341 "../src/Services/Device.vala"
					_tmp58_ = g_strconcat (_tmp53_, _tmp57_, NULL);
#line 341 "../src/Services/Device.vala"
					_g_free0 (info);
#line 341 "../src/Services/Device.vala"
					info = _tmp58_;
#line 341 "../src/Services/Device.vala"
					_g_free0 (_tmp57_);
#line 1628 "Device.c"
				}
			}
		}
	}
#line 351 "../src/Services/Device.vala"
	result = info;
#line 351 "../src/Services/Device.vala"
	return result;
#line 1637 "Device.c"
}

gboolean
power_services_device_get_has_history (PowerServicesDevice* self)
{
	gboolean result;
#line 128 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 128 "../src/Services/Device.vala"
	result = self->priv->_has_history;
#line 128 "../src/Services/Device.vala"
	return result;
#line 1650 "Device.c"
}

static void
power_services_device_set_has_history (PowerServicesDevice* self,
                                       gboolean value)
{
	gboolean old_value;
#line 128 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/Services/Device.vala"
	old_value = power_services_device_get_has_history (self);
#line 128 "../src/Services/Device.vala"
	if (old_value != value) {
#line 128 "../src/Services/Device.vala"
		self->priv->_has_history = value;
#line 128 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_HAS_HISTORY_PROPERTY]);
#line 1668 "Device.c"
	}
}

gboolean
power_services_device_get_has_statistics (PowerServicesDevice* self)
{
	gboolean result;
#line 129 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "../src/Services/Device.vala"
	result = self->priv->_has_statistics;
#line 129 "../src/Services/Device.vala"
	return result;
#line 1682 "Device.c"
}

static void
power_services_device_set_has_statistics (PowerServicesDevice* self,
                                          gboolean value)
{
	gboolean old_value;
#line 129 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/Services/Device.vala"
	old_value = power_services_device_get_has_statistics (self);
#line 129 "../src/Services/Device.vala"
	if (old_value != value) {
#line 129 "../src/Services/Device.vala"
		self->priv->_has_statistics = value;
#line 129 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_HAS_STATISTICS_PROPERTY]);
#line 1700 "Device.c"
	}
}

gboolean
power_services_device_get_is_present (PowerServicesDevice* self)
{
	gboolean result;
#line 130 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 130 "../src/Services/Device.vala"
	result = self->priv->_is_present;
#line 130 "../src/Services/Device.vala"
	return result;
#line 1714 "Device.c"
}

static void
power_services_device_set_is_present (PowerServicesDevice* self,
                                      gboolean value)
{
	gboolean old_value;
#line 130 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/Services/Device.vala"
	old_value = power_services_device_get_is_present (self);
#line 130 "../src/Services/Device.vala"
	if (old_value != value) {
#line 130 "../src/Services/Device.vala"
		self->priv->_is_present = value;
#line 130 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_IS_PRESENT_PROPERTY]);
#line 1732 "Device.c"
	}
}

gboolean
power_services_device_get_is_rechargeable (PowerServicesDevice* self)
{
	gboolean result;
#line 131 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 131 "../src/Services/Device.vala"
	result = self->priv->_is_rechargeable;
#line 131 "../src/Services/Device.vala"
	return result;
#line 1746 "Device.c"
}

static void
power_services_device_set_is_rechargeable (PowerServicesDevice* self,
                                           gboolean value)
{
	gboolean old_value;
#line 131 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 131 "../src/Services/Device.vala"
	old_value = power_services_device_get_is_rechargeable (self);
#line 131 "../src/Services/Device.vala"
	if (old_value != value) {
#line 131 "../src/Services/Device.vala"
		self->priv->_is_rechargeable = value;
#line 131 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_IS_RECHARGEABLE_PROPERTY]);
#line 1764 "Device.c"
	}
}

gboolean
power_services_device_get_online (PowerServicesDevice* self)
{
	gboolean result;
#line 132 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 132 "../src/Services/Device.vala"
	result = self->priv->_online;
#line 132 "../src/Services/Device.vala"
	return result;
#line 1778 "Device.c"
}

static void
power_services_device_set_online (PowerServicesDevice* self,
                                  gboolean value)
{
	gboolean old_value;
#line 132 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/Services/Device.vala"
	old_value = power_services_device_get_online (self);
#line 132 "../src/Services/Device.vala"
	if (old_value != value) {
#line 132 "../src/Services/Device.vala"
		self->priv->_online = value;
#line 132 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_ONLINE_PROPERTY]);
#line 1796 "Device.c"
	}
}

gboolean
power_services_device_get_power_supply (PowerServicesDevice* self)
{
	gboolean result;
#line 133 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 133 "../src/Services/Device.vala"
	result = self->priv->_power_supply;
#line 133 "../src/Services/Device.vala"
	return result;
#line 1810 "Device.c"
}

static void
power_services_device_set_power_supply (PowerServicesDevice* self,
                                        gboolean value)
{
	gboolean old_value;
#line 133 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/Services/Device.vala"
	old_value = power_services_device_get_power_supply (self);
#line 133 "../src/Services/Device.vala"
	if (old_value != value) {
#line 133 "../src/Services/Device.vala"
		self->priv->_power_supply = value;
#line 133 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_POWER_SUPPLY_PROPERTY]);
#line 1828 "Device.c"
	}
}

gdouble
power_services_device_get_capacity (PowerServicesDevice* self)
{
	gdouble result;
#line 134 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 134 "../src/Services/Device.vala"
	result = self->priv->_capacity;
#line 134 "../src/Services/Device.vala"
	return result;
#line 1842 "Device.c"
}

static void
power_services_device_set_capacity (PowerServicesDevice* self,
                                    gdouble value)
{
	gdouble old_value;
#line 134 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/Services/Device.vala"
	old_value = power_services_device_get_capacity (self);
#line 134 "../src/Services/Device.vala"
	if (old_value != value) {
#line 134 "../src/Services/Device.vala"
		self->priv->_capacity = value;
#line 134 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_CAPACITY_PROPERTY]);
#line 1860 "Device.c"
	}
}

gdouble
power_services_device_get_energy (PowerServicesDevice* self)
{
	gdouble result;
#line 135 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 135 "../src/Services/Device.vala"
	result = self->priv->_energy;
#line 135 "../src/Services/Device.vala"
	return result;
#line 1874 "Device.c"
}

static void
power_services_device_set_energy (PowerServicesDevice* self,
                                  gdouble value)
{
	gdouble old_value;
#line 135 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/Services/Device.vala"
	old_value = power_services_device_get_energy (self);
#line 135 "../src/Services/Device.vala"
	if (old_value != value) {
#line 135 "../src/Services/Device.vala"
		self->priv->_energy = value;
#line 135 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_PROPERTY]);
#line 1892 "Device.c"
	}
}

gdouble
power_services_device_get_energy_empty (PowerServicesDevice* self)
{
	gdouble result;
#line 136 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 136 "../src/Services/Device.vala"
	result = self->priv->_energy_empty;
#line 136 "../src/Services/Device.vala"
	return result;
#line 1906 "Device.c"
}

static void
power_services_device_set_energy_empty (PowerServicesDevice* self,
                                        gdouble value)
{
	gdouble old_value;
#line 136 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/Services/Device.vala"
	old_value = power_services_device_get_energy_empty (self);
#line 136 "../src/Services/Device.vala"
	if (old_value != value) {
#line 136 "../src/Services/Device.vala"
		self->priv->_energy_empty = value;
#line 136 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_EMPTY_PROPERTY]);
#line 1924 "Device.c"
	}
}

gdouble
power_services_device_get_energy_full (PowerServicesDevice* self)
{
	gdouble result;
#line 137 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 137 "../src/Services/Device.vala"
	result = self->priv->_energy_full;
#line 137 "../src/Services/Device.vala"
	return result;
#line 1938 "Device.c"
}

static void
power_services_device_set_energy_full (PowerServicesDevice* self,
                                       gdouble value)
{
	gdouble old_value;
#line 137 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Services/Device.vala"
	old_value = power_services_device_get_energy_full (self);
#line 137 "../src/Services/Device.vala"
	if (old_value != value) {
#line 137 "../src/Services/Device.vala"
		self->priv->_energy_full = value;
#line 137 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_FULL_PROPERTY]);
#line 1956 "Device.c"
	}
}

gdouble
power_services_device_get_energy_full_design (PowerServicesDevice* self)
{
	gdouble result;
#line 138 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 138 "../src/Services/Device.vala"
	result = self->priv->_energy_full_design;
#line 138 "../src/Services/Device.vala"
	return result;
#line 1970 "Device.c"
}

static void
power_services_device_set_energy_full_design (PowerServicesDevice* self,
                                              gdouble value)
{
	gdouble old_value;
#line 138 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/Services/Device.vala"
	old_value = power_services_device_get_energy_full_design (self);
#line 138 "../src/Services/Device.vala"
	if (old_value != value) {
#line 138 "../src/Services/Device.vala"
		self->priv->_energy_full_design = value;
#line 138 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_FULL_DESIGN_PROPERTY]);
#line 1988 "Device.c"
	}
}

gdouble
power_services_device_get_energy_rate (PowerServicesDevice* self)
{
	gdouble result;
#line 139 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 139 "../src/Services/Device.vala"
	result = self->priv->_energy_rate;
#line 139 "../src/Services/Device.vala"
	return result;
#line 2002 "Device.c"
}

static void
power_services_device_set_energy_rate (PowerServicesDevice* self,
                                       gdouble value)
{
	gdouble old_value;
#line 139 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/Services/Device.vala"
	old_value = power_services_device_get_energy_rate (self);
#line 139 "../src/Services/Device.vala"
	if (old_value != value) {
#line 139 "../src/Services/Device.vala"
		self->priv->_energy_rate = value;
#line 139 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_RATE_PROPERTY]);
#line 2020 "Device.c"
	}
}

gdouble
power_services_device_get_luminosity (PowerServicesDevice* self)
{
	gdouble result;
#line 140 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 140 "../src/Services/Device.vala"
	result = self->priv->_luminosity;
#line 140 "../src/Services/Device.vala"
	return result;
#line 2034 "Device.c"
}

static void
power_services_device_set_luminosity (PowerServicesDevice* self,
                                      gdouble value)
{
	gdouble old_value;
#line 140 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/Services/Device.vala"
	old_value = power_services_device_get_luminosity (self);
#line 140 "../src/Services/Device.vala"
	if (old_value != value) {
#line 140 "../src/Services/Device.vala"
		self->priv->_luminosity = value;
#line 140 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_LUMINOSITY_PROPERTY]);
#line 2052 "Device.c"
	}
}

gdouble
power_services_device_get_percentage (PowerServicesDevice* self)
{
	gdouble result;
#line 141 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 141 "../src/Services/Device.vala"
	result = self->priv->_percentage;
#line 141 "../src/Services/Device.vala"
	return result;
#line 2066 "Device.c"
}

static void
power_services_device_set_percentage (PowerServicesDevice* self,
                                      gdouble value)
{
	gdouble old_value;
#line 141 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 141 "../src/Services/Device.vala"
	old_value = power_services_device_get_percentage (self);
#line 141 "../src/Services/Device.vala"
	if (old_value != value) {
#line 141 "../src/Services/Device.vala"
		self->priv->_percentage = value;
#line 141 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_PERCENTAGE_PROPERTY]);
#line 2084 "Device.c"
	}
}

gdouble
power_services_device_get_temperature (PowerServicesDevice* self)
{
	gdouble result;
#line 142 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 142 "../src/Services/Device.vala"
	result = self->priv->_temperature;
#line 142 "../src/Services/Device.vala"
	return result;
#line 2098 "Device.c"
}

static void
power_services_device_set_temperature (PowerServicesDevice* self,
                                       gdouble value)
{
	gdouble old_value;
#line 142 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/Services/Device.vala"
	old_value = power_services_device_get_temperature (self);
#line 142 "../src/Services/Device.vala"
	if (old_value != value) {
#line 142 "../src/Services/Device.vala"
		self->priv->_temperature = value;
#line 142 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_TEMPERATURE_PROPERTY]);
#line 2116 "Device.c"
	}
}

gdouble
power_services_device_get_voltage (PowerServicesDevice* self)
{
	gdouble result;
#line 143 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 143 "../src/Services/Device.vala"
	result = self->priv->_voltage;
#line 143 "../src/Services/Device.vala"
	return result;
#line 2130 "Device.c"
}

static void
power_services_device_set_voltage (PowerServicesDevice* self,
                                   gdouble value)
{
	gdouble old_value;
#line 143 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/Services/Device.vala"
	old_value = power_services_device_get_voltage (self);
#line 143 "../src/Services/Device.vala"
	if (old_value != value) {
#line 143 "../src/Services/Device.vala"
		self->priv->_voltage = value;
#line 143 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_VOLTAGE_PROPERTY]);
#line 2148 "Device.c"
	}
}

gint64
power_services_device_get_time_to_empty (PowerServicesDevice* self)
{
	gint64 result;
#line 144 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 144 "../src/Services/Device.vala"
	result = self->priv->_time_to_empty;
#line 144 "../src/Services/Device.vala"
	return result;
#line 2162 "Device.c"
}

static void
power_services_device_set_time_to_empty (PowerServicesDevice* self,
                                         gint64 value)
{
	gint64 old_value;
#line 144 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/Services/Device.vala"
	old_value = power_services_device_get_time_to_empty (self);
#line 144 "../src/Services/Device.vala"
	if (old_value != value) {
#line 144 "../src/Services/Device.vala"
		self->priv->_time_to_empty = value;
#line 144 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_TIME_TO_EMPTY_PROPERTY]);
#line 2180 "Device.c"
	}
}

gint64
power_services_device_get_time_to_full (PowerServicesDevice* self)
{
	gint64 result;
#line 145 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 145 "../src/Services/Device.vala"
	result = self->priv->_time_to_full;
#line 145 "../src/Services/Device.vala"
	return result;
#line 2194 "Device.c"
}

static void
power_services_device_set_time_to_full (PowerServicesDevice* self,
                                        gint64 value)
{
	gint64 old_value;
#line 145 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/Services/Device.vala"
	old_value = power_services_device_get_time_to_full (self);
#line 145 "../src/Services/Device.vala"
	if (old_value != value) {
#line 145 "../src/Services/Device.vala"
		self->priv->_time_to_full = value;
#line 145 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_TIME_TO_FULL_PROPERTY]);
#line 2212 "Device.c"
	}
}

const gchar*
power_services_device_get_model (PowerServicesDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 146 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 146 "../src/Services/Device.vala"
	_tmp0_ = self->priv->_model;
#line 146 "../src/Services/Device.vala"
	result = _tmp0_;
#line 146 "../src/Services/Device.vala"
	return result;
#line 2229 "Device.c"
}

static void
power_services_device_set_model (PowerServicesDevice* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 146 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/Services/Device.vala"
	old_value = power_services_device_get_model (self);
#line 146 "../src/Services/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2243 "Device.c"
		gchar* _tmp0_;
#line 146 "../src/Services/Device.vala"
		_tmp0_ = g_strdup (value);
#line 146 "../src/Services/Device.vala"
		_g_free0 (self->priv->_model);
#line 146 "../src/Services/Device.vala"
		self->priv->_model = _tmp0_;
#line 146 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_MODEL_PROPERTY]);
#line 2253 "Device.c"
	}
}

const gchar*
power_services_device_get_native_path (PowerServicesDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 147 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 147 "../src/Services/Device.vala"
	_tmp0_ = self->priv->_native_path;
#line 147 "../src/Services/Device.vala"
	result = _tmp0_;
#line 147 "../src/Services/Device.vala"
	return result;
#line 2270 "Device.c"
}

static void
power_services_device_set_native_path (PowerServicesDevice* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 147 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/Services/Device.vala"
	old_value = power_services_device_get_native_path (self);
#line 147 "../src/Services/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2284 "Device.c"
		gchar* _tmp0_;
#line 147 "../src/Services/Device.vala"
		_tmp0_ = g_strdup (value);
#line 147 "../src/Services/Device.vala"
		_g_free0 (self->priv->_native_path);
#line 147 "../src/Services/Device.vala"
		self->priv->_native_path = _tmp0_;
#line 147 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_NATIVE_PATH_PROPERTY]);
#line 2294 "Device.c"
	}
}

const gchar*
power_services_device_get_serial (PowerServicesDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 148 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "../src/Services/Device.vala"
	_tmp0_ = self->priv->_serial;
#line 148 "../src/Services/Device.vala"
	result = _tmp0_;
#line 148 "../src/Services/Device.vala"
	return result;
#line 2311 "Device.c"
}

static void
power_services_device_set_serial (PowerServicesDevice* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 148 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/Services/Device.vala"
	old_value = power_services_device_get_serial (self);
#line 148 "../src/Services/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2325 "Device.c"
		gchar* _tmp0_;
#line 148 "../src/Services/Device.vala"
		_tmp0_ = g_strdup (value);
#line 148 "../src/Services/Device.vala"
		_g_free0 (self->priv->_serial);
#line 148 "../src/Services/Device.vala"
		self->priv->_serial = _tmp0_;
#line 148 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_SERIAL_PROPERTY]);
#line 2335 "Device.c"
	}
}

const gchar*
power_services_device_get_vendor (PowerServicesDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 149 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 149 "../src/Services/Device.vala"
	_tmp0_ = self->priv->_vendor;
#line 149 "../src/Services/Device.vala"
	result = _tmp0_;
#line 149 "../src/Services/Device.vala"
	return result;
#line 2352 "Device.c"
}

static void
power_services_device_set_vendor (PowerServicesDevice* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 149 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/Services/Device.vala"
	old_value = power_services_device_get_vendor (self);
#line 149 "../src/Services/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2366 "Device.c"
		gchar* _tmp0_;
#line 149 "../src/Services/Device.vala"
		_tmp0_ = g_strdup (value);
#line 149 "../src/Services/Device.vala"
		_g_free0 (self->priv->_vendor);
#line 149 "../src/Services/Device.vala"
		self->priv->_vendor = _tmp0_;
#line 149 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_VENDOR_PROPERTY]);
#line 2376 "Device.c"
	}
}

PowerServicesDeviceState
power_services_device_get_state (PowerServicesDevice* self)
{
	PowerServicesDeviceState result;
#line 150 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 150 "../src/Services/Device.vala"
	result = self->priv->_state;
#line 150 "../src/Services/Device.vala"
	return result;
#line 2390 "Device.c"
}

static void
power_services_device_set_state (PowerServicesDevice* self,
                                 PowerServicesDeviceState value)
{
	PowerServicesDeviceState old_value;
#line 150 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/Services/Device.vala"
	old_value = power_services_device_get_state (self);
#line 150 "../src/Services/Device.vala"
	if (old_value != value) {
#line 150 "../src/Services/Device.vala"
		self->priv->_state = value;
#line 150 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_STATE_PROPERTY]);
#line 2408 "Device.c"
	}
}

PowerServicesDeviceTechnology
power_services_device_get_technology (PowerServicesDevice* self)
{
	PowerServicesDeviceTechnology result;
#line 151 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 151 "../src/Services/Device.vala"
	result = self->priv->_technology;
#line 151 "../src/Services/Device.vala"
	return result;
#line 2422 "Device.c"
}

static void
power_services_device_set_technology (PowerServicesDevice* self,
                                      PowerServicesDeviceTechnology value)
{
	PowerServicesDeviceTechnology old_value;
#line 151 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/Services/Device.vala"
	old_value = power_services_device_get_technology (self);
#line 151 "../src/Services/Device.vala"
	if (old_value != value) {
#line 151 "../src/Services/Device.vala"
		self->priv->_technology = value;
#line 151 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_TECHNOLOGY_PROPERTY]);
#line 2440 "Device.c"
	}
}

PowerServicesDeviceType
power_services_device_get_device_type (PowerServicesDevice* self)
{
	PowerServicesDeviceType result;
#line 152 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 152 "../src/Services/Device.vala"
	result = self->priv->_device_type;
#line 152 "../src/Services/Device.vala"
	return result;
#line 2454 "Device.c"
}

static void
power_services_device_set_device_type (PowerServicesDevice* self,
                                       PowerServicesDeviceType value)
{
	PowerServicesDeviceType old_value;
#line 152 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/Services/Device.vala"
	old_value = power_services_device_get_device_type (self);
#line 152 "../src/Services/Device.vala"
	if (old_value != value) {
#line 152 "../src/Services/Device.vala"
		self->priv->_device_type = value;
#line 152 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_DEVICE_TYPE_PROPERTY]);
#line 2472 "Device.c"
	}
}

guint64
power_services_device_get_update_time (PowerServicesDevice* self)
{
	guint64 result;
#line 153 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 153 "../src/Services/Device.vala"
	result = self->priv->_update_time;
#line 153 "../src/Services/Device.vala"
	return result;
#line 2486 "Device.c"
}

static void
power_services_device_set_update_time (PowerServicesDevice* self,
                                       guint64 value)
{
	guint64 old_value;
#line 153 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 153 "../src/Services/Device.vala"
	old_value = power_services_device_get_update_time (self);
#line 153 "../src/Services/Device.vala"
	if (old_value != value) {
#line 153 "../src/Services/Device.vala"
		self->priv->_update_time = value;
#line 153 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_UPDATE_TIME_PROPERTY]);
#line 2504 "Device.c"
	}
}

gboolean
power_services_device_get_is_charging (PowerServicesDevice* self)
{
	gboolean result;
#line 156 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 156 "../src/Services/Device.vala"
	result = self->priv->_is_charging;
#line 156 "../src/Services/Device.vala"
	return result;
#line 2518 "Device.c"
}

static void
power_services_device_set_is_charging (PowerServicesDevice* self,
                                       gboolean value)
{
	gboolean old_value;
#line 156 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Services/Device.vala"
	old_value = power_services_device_get_is_charging (self);
#line 156 "../src/Services/Device.vala"
	if (old_value != value) {
#line 156 "../src/Services/Device.vala"
		self->priv->_is_charging = value;
#line 156 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_IS_CHARGING_PROPERTY]);
#line 2536 "Device.c"
	}
}

gboolean
power_services_device_get_is_a_battery (PowerServicesDevice* self)
{
	gboolean result;
#line 157 "../src/Services/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 157 "../src/Services/Device.vala"
	result = self->priv->_is_a_battery;
#line 157 "../src/Services/Device.vala"
	return result;
#line 2550 "Device.c"
}

static void
power_services_device_set_is_a_battery (PowerServicesDevice* self,
                                        gboolean value)
{
	gboolean old_value;
#line 157 "../src/Services/Device.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Services/Device.vala"
	old_value = power_services_device_get_is_a_battery (self);
#line 157 "../src/Services/Device.vala"
	if (old_value != value) {
#line 157 "../src/Services/Device.vala"
		self->priv->_is_a_battery = value;
#line 157 "../src/Services/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_properties[POWER_SERVICES_DEVICE_IS_A_BATTERY_PROPERTY]);
#line 2568 "Device.c"
	}
}

static void
power_services_device_class_init (PowerServicesDeviceClass * klass,
                                  gpointer klass_data)
{
#line 20 "../src/Services/Device.vala"
	power_services_device_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Services/Device.vala"
	g_type_class_adjust_private_offset (klass, &PowerServicesDevice_private_offset);
#line 20 "../src/Services/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_services_device_get_property;
#line 20 "../src/Services/Device.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_services_device_set_property;
#line 20 "../src/Services/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = power_services_device_finalize;
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_HAS_HISTORY_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_HAS_HISTORY_PROPERTY] = g_param_spec_boolean ("has-history", "has-history", "has-history", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_HAS_STATISTICS_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_HAS_STATISTICS_PROPERTY] = g_param_spec_boolean ("has-statistics", "has-statistics", "has-statistics", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_IS_PRESENT_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_IS_PRESENT_PROPERTY] = g_param_spec_boolean ("is-present", "is-present", "is-present", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_IS_RECHARGEABLE_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_IS_RECHARGEABLE_PROPERTY] = g_param_spec_boolean ("is-rechargeable", "is-rechargeable", "is-rechargeable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_ONLINE_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_ONLINE_PROPERTY] = g_param_spec_boolean ("online", "online", "online", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_POWER_SUPPLY_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_POWER_SUPPLY_PROPERTY] = g_param_spec_boolean ("power-supply", "power-supply", "power-supply", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_CAPACITY_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_CAPACITY_PROPERTY] = g_param_spec_double ("capacity", "capacity", "capacity", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_ENERGY_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_PROPERTY] = g_param_spec_double ("energy", "energy", "energy", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_ENERGY_EMPTY_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_EMPTY_PROPERTY] = g_param_spec_double ("energy-empty", "energy-empty", "energy-empty", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_ENERGY_FULL_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_FULL_PROPERTY] = g_param_spec_double ("energy-full", "energy-full", "energy-full", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_ENERGY_FULL_DESIGN_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_FULL_DESIGN_PROPERTY] = g_param_spec_double ("energy-full-design", "energy-full-design", "energy-full-design", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_ENERGY_RATE_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_ENERGY_RATE_PROPERTY] = g_param_spec_double ("energy-rate", "energy-rate", "energy-rate", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_LUMINOSITY_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_LUMINOSITY_PROPERTY] = g_param_spec_double ("luminosity", "luminosity", "luminosity", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_PERCENTAGE_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_PERCENTAGE_PROPERTY] = g_param_spec_double ("percentage", "percentage", "percentage", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_TEMPERATURE_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_TEMPERATURE_PROPERTY] = g_param_spec_double ("temperature", "temperature", "temperature", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_VOLTAGE_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_VOLTAGE_PROPERTY] = g_param_spec_double ("voltage", "voltage", "voltage", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_TIME_TO_EMPTY_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_TIME_TO_EMPTY_PROPERTY] = g_param_spec_int64 ("time-to-empty", "time-to-empty", "time-to-empty", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_TIME_TO_FULL_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_TIME_TO_FULL_PROPERTY] = g_param_spec_int64 ("time-to-full", "time-to-full", "time-to-full", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_MODEL_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_MODEL_PROPERTY] = g_param_spec_string ("model", "model", "model", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_NATIVE_PATH_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_NATIVE_PATH_PROPERTY] = g_param_spec_string ("native-path", "native-path", "native-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_SERIAL_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_SERIAL_PROPERTY] = g_param_spec_string ("serial", "serial", "serial", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_VENDOR_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_VENDOR_PROPERTY] = g_param_spec_string ("vendor", "vendor", "vendor", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_STATE_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", POWER_SERVICES_DEVICE_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_TECHNOLOGY_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_TECHNOLOGY_PROPERTY] = g_param_spec_enum ("technology", "technology", "technology", POWER_SERVICES_DEVICE_TYPE_TECHNOLOGY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_DEVICE_TYPE_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_DEVICE_TYPE_PROPERTY] = g_param_spec_enum ("device-type", "device-type", "device-type", POWER_SERVICES_DEVICE_TYPE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_UPDATE_TIME_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_UPDATE_TIME_PROPERTY] = g_param_spec_uint64 ("update-time", "update-time", "update-time", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_IS_CHARGING_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_IS_CHARGING_PROPERTY] = g_param_spec_boolean ("is-charging", "is-charging", "is-charging", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_IS_A_BATTERY_PROPERTY, power_services_device_properties[POWER_SERVICES_DEVICE_IS_A_BATTERY_PROPERTY] = g_param_spec_boolean ("is-a-battery", "is-a-battery", "is-a-battery", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/Device.vala"
	power_services_device_signals[POWER_SERVICES_DEVICE_PROPERTIES_UPDATED_SIGNAL] = g_signal_new ("properties-updated", POWER_SERVICES_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2644 "Device.c"
}

static void
power_services_device_instance_init (PowerServicesDevice * self,
                                     gpointer klass)
{
	gchar* _tmp0_;
#line 20 "../src/Services/Device.vala"
	self->priv = power_services_device_get_instance_private (self);
#line 124 "../src/Services/Device.vala"
	_tmp0_ = g_strdup ("");
#line 124 "../src/Services/Device.vala"
	self->priv->device_path = _tmp0_;
#line 126 "../src/Services/Device.vala"
	self->priv->device = NULL;
#line 2660 "Device.c"
}

static void
power_services_device_finalize (GObject * obj)
{
	PowerServicesDevice * self;
#line 20 "../src/Services/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_SERVICES_TYPE_DEVICE, PowerServicesDevice);
#line 124 "../src/Services/Device.vala"
	_g_free0 (self->priv->device_path);
#line 126 "../src/Services/Device.vala"
	_g_object_unref0 (self->priv->device);
#line 146 "../src/Services/Device.vala"
	_g_free0 (self->priv->_model);
#line 147 "../src/Services/Device.vala"
	_g_free0 (self->priv->_native_path);
#line 148 "../src/Services/Device.vala"
	_g_free0 (self->priv->_serial);
#line 149 "../src/Services/Device.vala"
	_g_free0 (self->priv->_vendor);
#line 20 "../src/Services/Device.vala"
	G_OBJECT_CLASS (power_services_device_parent_class)->finalize (obj);
#line 2683 "Device.c"
}

static GType
power_services_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerServicesDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_services_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerServicesDevice), 0, (GInstanceInitFunc) power_services_device_instance_init, NULL };
	GType power_services_device_type_id;
	power_services_device_type_id = g_type_register_static (G_TYPE_OBJECT, "PowerServicesDevice", &g_define_type_info, 0);
	PowerServicesDevice_private_offset = g_type_add_instance_private (power_services_device_type_id, sizeof (PowerServicesDevicePrivate));
	return power_services_device_type_id;
}

GType
power_services_device_get_type (void)
{
	static volatile gsize power_services_device_type_id__once = 0;
	if (g_once_init_enter (&power_services_device_type_id__once)) {
		GType power_services_device_type_id;
		power_services_device_type_id = power_services_device_get_type_once ();
		g_once_init_leave (&power_services_device_type_id__once, power_services_device_type_id);
	}
	return power_services_device_type_id__once;
}

static void
_vala_power_services_device_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec)
{
	PowerServicesDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_SERVICES_TYPE_DEVICE, PowerServicesDevice);
#line 20 "../src/Services/Device.vala"
	switch (property_id) {
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_HAS_HISTORY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_boolean (value, power_services_device_get_has_history (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_HAS_STATISTICS_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_boolean (value, power_services_device_get_has_statistics (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_IS_PRESENT_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_boolean (value, power_services_device_get_is_present (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_IS_RECHARGEABLE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_boolean (value, power_services_device_get_is_rechargeable (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ONLINE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_boolean (value, power_services_device_get_online (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_POWER_SUPPLY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_boolean (value, power_services_device_get_power_supply (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_CAPACITY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_capacity (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_energy (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_EMPTY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_energy_empty (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_FULL_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_energy_full (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_FULL_DESIGN_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_energy_full_design (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_RATE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_energy_rate (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_LUMINOSITY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_luminosity (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_PERCENTAGE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_percentage (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TEMPERATURE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_temperature (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_VOLTAGE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_double (value, power_services_device_get_voltage (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TIME_TO_EMPTY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_int64 (value, power_services_device_get_time_to_empty (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TIME_TO_FULL_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_int64 (value, power_services_device_get_time_to_full (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_MODEL_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_string (value, power_services_device_get_model (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_NATIVE_PATH_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_string (value, power_services_device_get_native_path (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_SERIAL_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_string (value, power_services_device_get_serial (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_VENDOR_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_string (value, power_services_device_get_vendor (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_STATE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_enum (value, power_services_device_get_state (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TECHNOLOGY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_enum (value, power_services_device_get_technology (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_DEVICE_TYPE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_enum (value, power_services_device_get_device_type (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_UPDATE_TIME_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_uint64 (value, power_services_device_get_update_time (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_IS_CHARGING_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_boolean (value, power_services_device_get_is_charging (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_IS_A_BATTERY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		g_value_set_boolean (value, power_services_device_get_is_a_battery (self));
#line 20 "../src/Services/Device.vala"
		break;
#line 2886 "Device.c"
		default:
#line 20 "../src/Services/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Services/Device.vala"
		break;
#line 2892 "Device.c"
	}
}

static void
_vala_power_services_device_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec)
{
	PowerServicesDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_SERVICES_TYPE_DEVICE, PowerServicesDevice);
#line 20 "../src/Services/Device.vala"
	switch (property_id) {
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_HAS_HISTORY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_has_history (self, g_value_get_boolean (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_HAS_STATISTICS_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_has_statistics (self, g_value_get_boolean (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_IS_PRESENT_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_is_present (self, g_value_get_boolean (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_IS_RECHARGEABLE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_is_rechargeable (self, g_value_get_boolean (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ONLINE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_online (self, g_value_get_boolean (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_POWER_SUPPLY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_power_supply (self, g_value_get_boolean (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_CAPACITY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_capacity (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_energy (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_EMPTY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_energy_empty (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_FULL_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_energy_full (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_FULL_DESIGN_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_energy_full_design (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_ENERGY_RATE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_energy_rate (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_LUMINOSITY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_luminosity (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_PERCENTAGE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_percentage (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TEMPERATURE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_temperature (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_VOLTAGE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_voltage (self, g_value_get_double (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TIME_TO_EMPTY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_time_to_empty (self, g_value_get_int64 (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TIME_TO_FULL_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_time_to_full (self, g_value_get_int64 (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_MODEL_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_model (self, g_value_get_string (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_NATIVE_PATH_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_native_path (self, g_value_get_string (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_SERIAL_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_serial (self, g_value_get_string (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_VENDOR_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_vendor (self, g_value_get_string (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_STATE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_state (self, g_value_get_enum (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_TECHNOLOGY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_technology (self, g_value_get_enum (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_DEVICE_TYPE_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_device_type (self, g_value_get_enum (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_UPDATE_TIME_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_update_time (self, g_value_get_uint64 (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_IS_CHARGING_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_is_charging (self, g_value_get_boolean (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 20 "../src/Services/Device.vala"
		case POWER_SERVICES_DEVICE_IS_A_BATTERY_PROPERTY:
#line 20 "../src/Services/Device.vala"
		power_services_device_set_is_a_battery (self, g_value_get_boolean (value));
#line 20 "../src/Services/Device.vala"
		break;
#line 3074 "Device.c"
		default:
#line 20 "../src/Services/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Services/Device.vala"
		break;
#line 3080 "Device.c"
	}
}

