/* DeviceManager.c generated by valac 0.56.17, the Vala compiler
 * generated from DeviceManager.vala, do not modify */

/*
 * Copyright (c) 2011-2021 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "power.h"
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>

#define POWER_SERVICES_DEVICE_MANAGER_UPOWER_INTERFACE "org.freedesktop.UPower"
#define POWER_SERVICES_DEVICE_MANAGER_UPOWER_PATH "/org/freedesktop/UPower"
#define POWER_SERVICES_DEVICE_MANAGER_POWER_SETTINGS_INTERFACE "org.gnome.SettingsDaemon.Power"
#define POWER_SERVICES_DEVICE_MANAGER_POWER_SETTINGS_PATH "/org/gnome/SettingsDaemon/Power"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define POWER_SERVICES_DBUS_INTERFACES_TYPE_POWER_SETTINGS (power_services_dbus_interfaces_power_settings_get_type ())
#define POWER_SERVICES_DBUS_INTERFACES_POWER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_SERVICES_DBUS_INTERFACES_TYPE_POWER_SETTINGS, PowerServicesDBusInterfacesPowerSettings))
#define POWER_SERVICES_DBUS_INTERFACES_IS_POWER_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_SERVICES_DBUS_INTERFACES_TYPE_POWER_SETTINGS))
#define POWER_SERVICES_DBUS_INTERFACES_POWER_SETTINGS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), POWER_SERVICES_DBUS_INTERFACES_TYPE_POWER_SETTINGS, PowerServicesDBusInterfacesPowerSettingsIface))

typedef struct _PowerServicesDBusInterfacesPowerSettings PowerServicesDBusInterfacesPowerSettings;
typedef struct _PowerServicesDBusInterfacesPowerSettingsIface PowerServicesDBusInterfacesPowerSettingsIface;

#define POWER_SERVICES_DBUS_INTERFACES_TYPE_POWER_SETTINGS_PROXY (power_services_dbus_interfaces_power_settings_proxy_get_type ())
enum  {
	POWER_SERVICES_DEVICE_MANAGER_0_PROPERTY,
	POWER_SERVICES_DEVICE_MANAGER_BACKLIGHT_PROPERTY,
	POWER_SERVICES_DEVICE_MANAGER_DEVICES_PROPERTY,
	POWER_SERVICES_DEVICE_MANAGER_BATTERIES_PROPERTY,
	POWER_SERVICES_DEVICE_MANAGER_DISPLAY_DEVICE_PROPERTY,
	POWER_SERVICES_DEVICE_MANAGER_HAS_BATTERY_PROPERTY,
	POWER_SERVICES_DEVICE_MANAGER_ON_BATTERY_PROPERTY,
	POWER_SERVICES_DEVICE_MANAGER_ON_LOW_BATTERY_PROPERTY,
	POWER_SERVICES_DEVICE_MANAGER_BRIGHTNESS_PROPERTY,
	POWER_SERVICES_DEVICE_MANAGER_NUM_PROPERTIES
};
static GParamSpec* power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PowerServicesDeviceManagerConnectToBusData PowerServicesDeviceManagerConnectToBusData;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	POWER_SERVICES_DEVICE_MANAGER_BATTERY_REGISTERED_SIGNAL,
	POWER_SERVICES_DEVICE_MANAGER_BATTERY_DEREGISTERED_SIGNAL,
	POWER_SERVICES_DEVICE_MANAGER_BRIGHTNESS_CHANGED_SIGNAL,
	POWER_SERVICES_DEVICE_MANAGER_NUM_SIGNALS
};
static guint power_services_device_manager_signals[POWER_SERVICES_DEVICE_MANAGER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PowerServicesDBusInterfacesPowerSettingsIface {
	GTypeInterface parent_iface;
	gint (*get_brightness) (PowerServicesDBusInterfacesPowerSettings* self);
	void (*set_brightness) (PowerServicesDBusInterfacesPowerSettings* self, gint value);
};

struct _PowerServicesDeviceManagerPrivate {
	PowerServicesDBusInterfacesUPower* upower;
	PowerServicesDBusInterfacesPowerSettings* iscreen;
	PowerServicesBacklight* _backlight;
	GeeHashMap* _devices;
	GeeIterator* _batteries;
	PowerServicesDevice* _display_device;
	gboolean _has_battery;
	gboolean _on_battery;
	gboolean _on_low_battery;
};

struct _PowerServicesDeviceManagerConnectToBusData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PowerServicesDeviceManager* self;
	gboolean result;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	PowerServicesDBusInterfacesUPower* _tmp2_;
	PowerServicesDBusInterfacesUPower* _tmp3_;
	PowerServicesDBusInterfacesUPower* _tmp4_;
	PowerServicesDBusInterfacesPowerSettings* _tmp5_;
	PowerServicesDBusInterfacesPowerSettings* _tmp6_;
	PowerServicesDBusInterfacesPowerSettings* _tmp7_;
	GError* e;
	GError* _tmp8_;
	const gchar* _tmp9_;
	GError* _inner_error0_;
};

static gint PowerServicesDeviceManager_private_offset;
static gpointer power_services_device_manager_parent_class = NULL;
static PowerServicesDeviceManager* power_services_device_manager_instance;
static PowerServicesDeviceManager* power_services_device_manager_instance = NULL;

VALA_EXTERN GType power_services_dbus_interfaces_power_settings_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType power_services_dbus_interfaces_power_settings_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint power_services_dbus_interfaces_power_settings_register_object (void* object,
                                                                     GDBusConnection* connection,
                                                                     const gchar* path,
                                                                     GError** error);
static void power_services_device_manager_connect_to_bus_data_free (gpointer _data);
static void power_services_device_manager_connect_to_bus (PowerServicesDeviceManager* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static gboolean power_services_device_manager_connect_to_bus_finish (PowerServicesDeviceManager* self,
                                                              GAsyncResult* _res_);
static gboolean power_services_device_manager_connect_to_bus_co (PowerServicesDeviceManagerConnectToBusData* _data_);
static void power_services_device_manager_set_devices (PowerServicesDeviceManager* self,
                                                GeeHashMap* value);
static void power_services_device_manager_connect_to_bus_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static gboolean power_services_device_manager_determine_attached_device (PowerServicesDeviceManager* self,
                                                                  const char* device_path);
static void power_services_device_manager_set_display_device (PowerServicesDeviceManager* self,
                                                       PowerServicesDevice* value);
static void power_services_device_manager_register_device (PowerServicesDeviceManager* self,
                                                    const char* device_path);
static void power_services_device_manager_connect_signals (PowerServicesDeviceManager* self);
static void __lambda6_ (PowerServicesDeviceManager* self);
static void power_services_device_manager_update_properties (PowerServicesDeviceManager* self);
static void power_services_device_manager_update_batteries (PowerServicesDeviceManager* self);
static void ___lambda6__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                    GVariant* changed_properties,
                                                    gchar** invalidated_properties,
                                                    gpointer self);
static void _power_services_device_manager_register_device_power_services_dbus_interfaces_upower_device_added (PowerServicesDBusInterfacesUPower* _sender,
                                                                                                        const char* device_path,
                                                                                                        gpointer self);
static void power_services_device_manager_deregister_device (PowerServicesDeviceManager* self,
                                                      const char* device_path);
static void _power_services_device_manager_deregister_device_power_services_dbus_interfaces_upower_device_removed (PowerServicesDBusInterfacesUPower* _sender,
                                                                                                            const char* device_path,
                                                                                                            gpointer self);
static void __lambda7_ (PowerServicesDeviceManager* self,
                 GVariant* changed_properties,
                 gchar** invalidated_properties);
static void ___lambda7__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                    GVariant* changed_properties,
                                                    gchar** invalidated_properties,
                                                    gpointer self);
static void power_services_device_manager_set_on_battery (PowerServicesDeviceManager* self,
                                                   gboolean value);
static gboolean __lambda5_ (PowerServicesDeviceManager* self,
                     GeeMapEntry* entry);
static gboolean ___lambda5__gee_predicate (gconstpointer g,
                                    gpointer self);
static void power_services_device_manager_set_batteries (PowerServicesDeviceManager* self,
                                                  GeeIterator* value);
static void power_services_device_manager_set_has_battery (PowerServicesDeviceManager* self,
                                                    gboolean value);
VALA_EXTERN gint power_services_dbus_interfaces_power_settings_get_brightness (PowerServicesDBusInterfacesPowerSettings* self);
static void power_services_device_manager_set_on_low_battery (PowerServicesDeviceManager* self,
                                                       gboolean value);
VALA_EXTERN void power_services_dbus_interfaces_power_settings_set_brightness (PowerServicesDBusInterfacesPowerSettings* self,
                                                                   gint value);
static void g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GObject * power_services_device_manager_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static void _power_services_device_manager___lambda8_ (PowerServicesDeviceManager* self,
                                                GObject* obj,
                                                GAsyncResult* res);
static void __power_services_device_manager___lambda8__gasync_ready_callback (GObject* source_object,
                                                                       GAsyncResult* res,
                                                                       gpointer self);
static void power_services_device_manager_finalize (GObject * obj);
static GType power_services_device_manager_get_type_once (void);
static void _vala_power_services_device_manager_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_power_services_device_manager_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
power_services_device_manager_get_instance_private (PowerServicesDeviceManager* self)
{
	return G_STRUCT_MEMBER_P (self, PowerServicesDeviceManager_private_offset);
}

PowerServicesDeviceManager*
power_services_device_manager_get_default (void)
{
	PowerServicesDeviceManager* _tmp0_;
	PowerServicesDeviceManager* _tmp2_;
	PowerServicesDeviceManager* result;
#line 74 "../src/Services/DeviceManager.vala"
	_tmp0_ = power_services_device_manager_instance;
#line 74 "../src/Services/DeviceManager.vala"
	if (_tmp0_ == NULL) {
#line 239 "DeviceManager.c"
		PowerServicesDeviceManager* _tmp1_;
#line 75 "../src/Services/DeviceManager.vala"
		_tmp1_ = power_services_device_manager_new ();
#line 75 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (power_services_device_manager_instance);
#line 75 "../src/Services/DeviceManager.vala"
		power_services_device_manager_instance = _tmp1_;
#line 247 "DeviceManager.c"
	}
#line 78 "../src/Services/DeviceManager.vala"
	_tmp2_ = power_services_device_manager_instance;
#line 78 "../src/Services/DeviceManager.vala"
	result = _tmp2_;
#line 78 "../src/Services/DeviceManager.vala"
	return result;
#line 255 "DeviceManager.c"
}

static void
power_services_device_manager_connect_to_bus_data_free (gpointer _data)
{
	PowerServicesDeviceManagerConnectToBusData* _data_;
	_data_ = _data;
#line 20 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/Services/DeviceManager.vala"
	g_slice_free (PowerServicesDeviceManagerConnectToBusData, _data_);
#line 267 "DeviceManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 20 "../src/Services/DeviceManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 275 "DeviceManager.c"
}

static void
power_services_device_manager_connect_to_bus (PowerServicesDeviceManager* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	PowerServicesDeviceManagerConnectToBusData* _data_;
	PowerServicesDeviceManager* _tmp0_;
#line 20 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 20 "../src/Services/DeviceManager.vala"
	_data_ = g_slice_new0 (PowerServicesDeviceManagerConnectToBusData);
#line 20 "../src/Services/DeviceManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/Services/DeviceManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, power_services_device_manager_connect_to_bus_data_free);
#line 20 "../src/Services/DeviceManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/Services/DeviceManager.vala"
	_data_->self = _tmp0_;
#line 20 "../src/Services/DeviceManager.vala"
	power_services_device_manager_connect_to_bus_co (_data_);
#line 299 "DeviceManager.c"
}

static gboolean
power_services_device_manager_connect_to_bus_finish (PowerServicesDeviceManager* self,
                                                     GAsyncResult* _res_)
{
	gboolean result;
	PowerServicesDeviceManagerConnectToBusData* _data_;
#line 20 "../src/Services/DeviceManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 20 "../src/Services/DeviceManager.vala"
	result = _data_->result;
#line 20 "../src/Services/DeviceManager.vala"
	return result;
#line 314 "DeviceManager.c"
}

static void
power_services_device_manager_connect_to_bus_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	PowerServicesDeviceManagerConnectToBusData* _data_;
#line 85 "../src/Services/DeviceManager.vala"
	_data_ = _user_data_;
#line 85 "../src/Services/DeviceManager.vala"
	_data_->_source_object_ = source_object;
#line 85 "../src/Services/DeviceManager.vala"
	_data_->_res_ = _res_;
#line 85 "../src/Services/DeviceManager.vala"
	power_services_device_manager_connect_to_bus_co (_data_);
#line 331 "DeviceManager.c"
}

static gboolean
power_services_device_manager_connect_to_bus_co (PowerServicesDeviceManagerConnectToBusData* _data_)
{
#line 81 "../src/Services/DeviceManager.vala"
	switch (_data_->_state_) {
#line 81 "../src/Services/DeviceManager.vala"
		case 0:
#line 341 "DeviceManager.c"
		goto _state_0;
#line 81 "../src/Services/DeviceManager.vala"
		case 1:
#line 345 "DeviceManager.c"
		goto _state_1;
#line 81 "../src/Services/DeviceManager.vala"
		case 2:
#line 349 "DeviceManager.c"
		goto _state_2;
		default:
#line 81 "../src/Services/DeviceManager.vala"
		g_assert_not_reached ();
#line 354 "DeviceManager.c"
	}
	_state_0:
#line 82 "../src/Services/DeviceManager.vala"
	_data_->_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, POWER_SERVICES_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 82 "../src/Services/DeviceManager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 82 "../src/Services/DeviceManager.vala"
	power_services_device_manager_set_devices (_data_->self, _data_->_tmp1_);
#line 82 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 365 "DeviceManager.c"
	{
#line 85 "../src/Services/DeviceManager.vala"
		_data_->_state_ = 1;
#line 85 "../src/Services/DeviceManager.vala"
		g_async_initable_new_async (POWER_SERVICES_DBUS_INTERFACES_TYPE_UPOWER_PROXY, 0, NULL, power_services_device_manager_connect_to_bus_ready, _data_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", POWER_SERVICES_DEVICE_MANAGER_UPOWER_INTERFACE, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", POWER_SERVICES_DEVICE_MANAGER_UPOWER_PATH, "g-interface-name", "org.freedesktop.UPower", NULL);
#line 85 "../src/Services/DeviceManager.vala"
		return FALSE;
#line 373 "DeviceManager.c"
		_state_1:
#line 85 "../src/Services/DeviceManager.vala"
		_data_->_tmp3_ = (PowerServicesDBusInterfacesUPower*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 85 "../src/Services/DeviceManager.vala"
		_data_->_tmp2_ = (PowerServicesDBusInterfacesUPower*) _data_->_tmp3_;
#line 85 "../src/Services/DeviceManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 381 "DeviceManager.c"
			goto __catch0_g_error;
		}
#line 85 "../src/Services/DeviceManager.vala"
		_data_->_tmp4_ = _data_->_tmp2_;
#line 85 "../src/Services/DeviceManager.vala"
		_data_->_tmp2_ = NULL;
#line 85 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (_data_->self->priv->upower);
#line 85 "../src/Services/DeviceManager.vala"
		_data_->self->priv->upower = _data_->_tmp4_;
#line 91 "../src/Services/DeviceManager.vala"
		g_debug ("DeviceManager.vala:91: Connection to UPower bus established");
#line 93 "../src/Services/DeviceManager.vala"
		_data_->_state_ = 2;
#line 93 "../src/Services/DeviceManager.vala"
		g_async_initable_new_async (POWER_SERVICES_DBUS_INTERFACES_TYPE_POWER_SETTINGS_PROXY, 0, NULL, power_services_device_manager_connect_to_bus_ready, _data_, "g-flags", G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, "g-name", POWER_SERVICES_DEVICE_MANAGER_POWER_SETTINGS_INTERFACE, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", POWER_SERVICES_DEVICE_MANAGER_POWER_SETTINGS_PATH, "g-interface-name", "org.gnome.SettingsDaemon.Power.Screen", NULL);
#line 93 "../src/Services/DeviceManager.vala"
		return FALSE;
#line 400 "DeviceManager.c"
		_state_2:
#line 93 "../src/Services/DeviceManager.vala"
		_data_->_tmp6_ = (PowerServicesDBusInterfacesPowerSettings*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 93 "../src/Services/DeviceManager.vala"
		_data_->_tmp5_ = (PowerServicesDBusInterfacesPowerSettings*) _data_->_tmp6_;
#line 93 "../src/Services/DeviceManager.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 93 "../src/Services/DeviceManager.vala"
			_g_object_unref0 (_data_->_tmp2_);
#line 410 "DeviceManager.c"
			goto __catch0_g_error;
		}
#line 93 "../src/Services/DeviceManager.vala"
		_data_->_tmp7_ = _data_->_tmp5_;
#line 93 "../src/Services/DeviceManager.vala"
		_data_->_tmp5_ = NULL;
#line 93 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (_data_->self->priv->iscreen);
#line 93 "../src/Services/DeviceManager.vala"
		_data_->self->priv->iscreen = _data_->_tmp7_;
#line 99 "../src/Services/DeviceManager.vala"
		g_debug ("DeviceManager.vala:99: Connection to Power Settings bus established");
#line 101 "../src/Services/DeviceManager.vala"
		_data_->result = TRUE;
#line 101 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (_data_->_tmp5_);
#line 101 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (_data_->_tmp2_);
#line 101 "../src/Services/DeviceManager.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 101 "../src/Services/DeviceManager.vala"
		if (_data_->_state_ != 0) {
#line 101 "../src/Services/DeviceManager.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 101 "../src/Services/DeviceManager.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 437 "DeviceManager.c"
			}
		}
#line 101 "../src/Services/DeviceManager.vala"
		g_object_unref (_data_->_async_result);
#line 101 "../src/Services/DeviceManager.vala"
		return FALSE;
#line 444 "DeviceManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 84 "../src/Services/DeviceManager.vala"
		_data_->e = _data_->_inner_error0_;
#line 84 "../src/Services/DeviceManager.vala"
		_data_->_inner_error0_ = NULL;
#line 103 "../src/Services/DeviceManager.vala"
		_data_->_tmp8_ = _data_->e;
#line 103 "../src/Services/DeviceManager.vala"
		_data_->_tmp9_ = _data_->_tmp8_->message;
#line 103 "../src/Services/DeviceManager.vala"
		g_critical ("DeviceManager.vala:103: Connecting to UPower or PowerSettings bus fail" \
"ed: %s", _data_->_tmp9_);
#line 105 "../src/Services/DeviceManager.vala"
		_data_->result = FALSE;
#line 105 "../src/Services/DeviceManager.vala"
		_g_error_free0 (_data_->e);
#line 105 "../src/Services/DeviceManager.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 105 "../src/Services/DeviceManager.vala"
		if (_data_->_state_ != 0) {
#line 105 "../src/Services/DeviceManager.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 105 "../src/Services/DeviceManager.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 471 "DeviceManager.c"
			}
		}
#line 105 "../src/Services/DeviceManager.vala"
		g_object_unref (_data_->_async_result);
#line 105 "../src/Services/DeviceManager.vala"
		return FALSE;
#line 478 "DeviceManager.c"
	}
	__finally0:
#line 84 "../src/Services/DeviceManager.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 84 "../src/Services/DeviceManager.vala"
	g_clear_error (&_data_->_inner_error0_);
#line 84 "../src/Services/DeviceManager.vala"
	g_object_unref (_data_->_async_result);
#line 84 "../src/Services/DeviceManager.vala"
	return FALSE;
#line 489 "DeviceManager.c"
}

static gboolean
power_services_device_manager_determine_attached_device (PowerServicesDeviceManager* self,
                                                         const char* device_path)
{
	PowerServicesDevice* device = NULL;
	PowerServicesDevice* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PowerServicesDevice* _tmp2_;
	PowerServicesDeviceTechnology _tmp3_;
	PowerServicesDeviceTechnology _tmp4_;
	gboolean result;
#line 109 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 109 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (device_path != NULL, FALSE);
#line 110 "../src/Services/DeviceManager.vala"
	_tmp0_ = power_services_device_new ((const gchar*) device_path);
#line 110 "../src/Services/DeviceManager.vala"
	device = _tmp0_;
#line 114 "../src/Services/DeviceManager.vala"
	_tmp2_ = device;
#line 114 "../src/Services/DeviceManager.vala"
	_tmp3_ = power_services_device_get_technology (_tmp2_);
#line 114 "../src/Services/DeviceManager.vala"
	_tmp4_ = _tmp3_;
#line 114 "../src/Services/DeviceManager.vala"
	if (_tmp4_ == POWER_SERVICES_DEVICE_TECHNOLOGY_UNKNOWN) {
#line 519 "DeviceManager.c"
		PowerServicesDevice* _tmp5_;
		PowerServicesDeviceState _tmp6_;
		PowerServicesDeviceState _tmp7_;
#line 115 "../src/Services/DeviceManager.vala"
		_tmp5_ = device;
#line 115 "../src/Services/DeviceManager.vala"
		_tmp6_ = power_services_device_get_state (_tmp5_);
#line 115 "../src/Services/DeviceManager.vala"
		_tmp7_ = _tmp6_;
#line 115 "../src/Services/DeviceManager.vala"
		_tmp1_ = _tmp7_ == POWER_SERVICES_DEVICE_STATE_UNKNOWN;
#line 531 "DeviceManager.c"
	} else {
#line 114 "../src/Services/DeviceManager.vala"
		_tmp1_ = FALSE;
#line 535 "DeviceManager.c"
	}
#line 114 "../src/Services/DeviceManager.vala"
	if (_tmp1_) {
#line 116 "../src/Services/DeviceManager.vala"
		result = FALSE;
#line 116 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (device);
#line 116 "../src/Services/DeviceManager.vala"
		return result;
#line 545 "DeviceManager.c"
	}
#line 118 "../src/Services/DeviceManager.vala"
	result = TRUE;
#line 118 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (device);
#line 118 "../src/Services/DeviceManager.vala"
	return result;
#line 553 "DeviceManager.c"
}

void
power_services_device_manager_read_devices (PowerServicesDeviceManager* self)
{
	PowerServicesDBusInterfacesUPower* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 121 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->upower;
#line 122 "../src/Services/DeviceManager.vala"
	if (_tmp0_ == NULL) {
#line 123 "../src/Services/DeviceManager.vala"
		return;
#line 569 "DeviceManager.c"
	}
	{
		char* display_device_path = NULL;
		PowerServicesDBusInterfacesUPower* _tmp1_;
		char* _tmp2_;
		const char* _tmp3_;
		PowerServicesDevice* _tmp4_;
		PowerServicesDevice* _tmp5_;
		char** devices = NULL;
		PowerServicesDBusInterfacesUPower* _tmp6_;
		gint _tmp7_ = 0;
		char** _tmp8_;
		gint devices_length1;
		gint _devices_size_;
		char** _tmp9_;
		gint _tmp9__length1;
#line 128 "../src/Services/DeviceManager.vala"
		_tmp1_ = self->priv->upower;
#line 128 "../src/Services/DeviceManager.vala"
		_tmp2_ = power_services_dbus_interfaces_upower_get_display_device (_tmp1_, &_inner_error0_);
#line 128 "../src/Services/DeviceManager.vala"
		display_device_path = _tmp2_;
#line 128 "../src/Services/DeviceManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 594 "DeviceManager.c"
			goto __catch0_g_error;
		}
#line 129 "../src/Services/DeviceManager.vala"
		_tmp3_ = display_device_path;
#line 129 "../src/Services/DeviceManager.vala"
		_tmp4_ = power_services_device_new ((const gchar*) _tmp3_);
#line 129 "../src/Services/DeviceManager.vala"
		_tmp5_ = _tmp4_;
#line 129 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_display_device (self, _tmp5_);
#line 129 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (_tmp5_);
#line 131 "../src/Services/DeviceManager.vala"
		_tmp6_ = self->priv->upower;
#line 131 "../src/Services/DeviceManager.vala"
		_tmp8_ = power_services_dbus_interfaces_upower_enumerate_devices (_tmp6_, &_tmp7_, &_inner_error0_);
#line 131 "../src/Services/DeviceManager.vala"
		devices = _tmp8_;
#line 131 "../src/Services/DeviceManager.vala"
		devices_length1 = _tmp7_;
#line 131 "../src/Services/DeviceManager.vala"
		_devices_size_ = devices_length1;
#line 131 "../src/Services/DeviceManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 131 "../src/Services/DeviceManager.vala"
			_g_free0 (display_device_path);
#line 621 "DeviceManager.c"
			goto __catch0_g_error;
		}
#line 132 "../src/Services/DeviceManager.vala"
		_tmp9_ = devices;
#line 132 "../src/Services/DeviceManager.vala"
		_tmp9__length1 = devices_length1;
#line 628 "DeviceManager.c"
		{
			char** device_path_collection = NULL;
			gint device_path_collection_length1 = 0;
			gint _device_path_collection_size_ = 0;
			gint device_path_it = 0;
#line 132 "../src/Services/DeviceManager.vala"
			device_path_collection = _tmp9_;
#line 132 "../src/Services/DeviceManager.vala"
			device_path_collection_length1 = _tmp9__length1;
#line 132 "../src/Services/DeviceManager.vala"
			for (device_path_it = 0; device_path_it < device_path_collection_length1; device_path_it = device_path_it + 1) {
#line 640 "DeviceManager.c"
				char* _tmp10_;
				char* device_path = NULL;
#line 132 "../src/Services/DeviceManager.vala"
				_tmp10_ = g_strdup (device_path_collection[device_path_it]);
#line 132 "../src/Services/DeviceManager.vala"
				device_path = _tmp10_;
#line 647 "DeviceManager.c"
				{
					const char* _tmp11_;
#line 133 "../src/Services/DeviceManager.vala"
					_tmp11_ = device_path;
#line 133 "../src/Services/DeviceManager.vala"
					if (power_services_device_manager_determine_attached_device (self, _tmp11_) == TRUE) {
#line 654 "DeviceManager.c"
						const char* _tmp12_;
#line 134 "../src/Services/DeviceManager.vala"
						_tmp12_ = device_path;
#line 134 "../src/Services/DeviceManager.vala"
						power_services_device_manager_register_device (self, _tmp12_);
#line 660 "DeviceManager.c"
					}
#line 132 "../src/Services/DeviceManager.vala"
					_g_free0 (device_path);
#line 664 "DeviceManager.c"
				}
			}
		}
#line 126 "../src/Services/DeviceManager.vala"
		devices = (_vala_array_free (devices, devices_length1, (GDestroyNotify) g_free), NULL);
#line 126 "../src/Services/DeviceManager.vala"
		_g_free0 (display_device_path);
#line 672 "DeviceManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 126 "../src/Services/DeviceManager.vala"
		e = _inner_error0_;
#line 126 "../src/Services/DeviceManager.vala"
		_inner_error0_ = NULL;
#line 138 "../src/Services/DeviceManager.vala"
		_tmp13_ = e;
#line 138 "../src/Services/DeviceManager.vala"
		_tmp14_ = _tmp13_->message;
#line 138 "../src/Services/DeviceManager.vala"
		g_critical ("DeviceManager.vala:138: Reading UPower devices failed: %s", _tmp14_);
#line 126 "../src/Services/DeviceManager.vala"
		_g_error_free0 (e);
#line 692 "DeviceManager.c"
	}
	__finally0:
#line 126 "../src/Services/DeviceManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 126 "../src/Services/DeviceManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 126 "../src/Services/DeviceManager.vala"
		g_clear_error (&_inner_error0_);
#line 126 "../src/Services/DeviceManager.vala"
		return;
#line 703 "DeviceManager.c"
	}
}

static void
__lambda6_ (PowerServicesDeviceManager* self)
{
#line 144 "../src/Services/DeviceManager.vala"
	power_services_device_manager_update_properties (self);
#line 145 "../src/Services/DeviceManager.vala"
	power_services_device_manager_update_batteries (self);
#line 714 "DeviceManager.c"
}

static void
___lambda6__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                               GVariant* changed_properties,
                                               gchar** invalidated_properties,
                                               gpointer self)
{
#line 143 "../src/Services/DeviceManager.vala"
	__lambda6_ ((PowerServicesDeviceManager*) self);
#line 725 "DeviceManager.c"
}

static void
_power_services_device_manager_register_device_power_services_dbus_interfaces_upower_device_added (PowerServicesDBusInterfacesUPower* _sender,
                                                                                                   const char* device_path,
                                                                                                   gpointer self)
{
#line 148 "../src/Services/DeviceManager.vala"
	power_services_device_manager_register_device ((PowerServicesDeviceManager*) self, device_path);
#line 735 "DeviceManager.c"
}

static void
_power_services_device_manager_deregister_device_power_services_dbus_interfaces_upower_device_removed (PowerServicesDBusInterfacesUPower* _sender,
                                                                                                       const char* device_path,
                                                                                                       gpointer self)
{
#line 149 "../src/Services/DeviceManager.vala"
	power_services_device_manager_deregister_device ((PowerServicesDeviceManager*) self, device_path);
#line 745 "DeviceManager.c"
}

static void
__lambda7_ (PowerServicesDeviceManager* self,
            GVariant* changed_properties,
            gchar** invalidated_properties)
{
	GVariant* changed_brightness = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
#line 151 "../src/Services/DeviceManager.vala"
	g_return_if_fail (changed_properties != NULL);
#line 152 "../src/Services/DeviceManager.vala"
	_tmp0_ = g_variant_type_new ("i");
#line 152 "../src/Services/DeviceManager.vala"
	_tmp1_ = _tmp0_;
#line 152 "../src/Services/DeviceManager.vala"
	_tmp2_ = g_variant_lookup_value (changed_properties, "Brightness", _tmp1_);
#line 152 "../src/Services/DeviceManager.vala"
	_tmp3_ = _tmp2_;
#line 152 "../src/Services/DeviceManager.vala"
	_g_variant_type_free0 (_tmp1_);
#line 152 "../src/Services/DeviceManager.vala"
	changed_brightness = _tmp3_;
#line 153 "../src/Services/DeviceManager.vala"
	_tmp4_ = changed_brightness;
#line 153 "../src/Services/DeviceManager.vala"
	if (_tmp4_ != NULL) {
#line 777 "DeviceManager.c"
		GVariant* _tmp5_;
#line 154 "../src/Services/DeviceManager.vala"
		_tmp5_ = changed_brightness;
#line 154 "../src/Services/DeviceManager.vala"
		g_signal_emit (self, power_services_device_manager_signals[POWER_SERVICES_DEVICE_MANAGER_BRIGHTNESS_CHANGED_SIGNAL], 0, (gint) g_variant_get_int32 (_tmp5_));
#line 783 "DeviceManager.c"
	}
#line 151 "../src/Services/DeviceManager.vala"
	_g_variant_unref0 (changed_brightness);
#line 787 "DeviceManager.c"
}

static void
___lambda7__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                               GVariant* changed_properties,
                                               gchar** invalidated_properties,
                                               gpointer self)
{
#line 151 "../src/Services/DeviceManager.vala"
	__lambda7_ ((PowerServicesDeviceManager*) self, changed_properties, invalidated_properties);
#line 798 "DeviceManager.c"
}

static void
power_services_device_manager_connect_signals (PowerServicesDeviceManager* self)
{
	PowerServicesDBusInterfacesUPower* _tmp0_;
	PowerServicesDBusInterfacesPowerSettings* _tmp1_;
	PowerServicesDBusInterfacesUPower* _tmp2_;
	PowerServicesDBusInterfacesUPower* _tmp3_;
	PowerServicesDBusInterfacesUPower* _tmp4_;
	PowerServicesDBusInterfacesPowerSettings* _tmp5_;
#line 142 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 142 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->upower;
#line 142 "../src/Services/DeviceManager.vala"
	_tmp1_ = self->priv->iscreen;
#line 142 "../src/Services/DeviceManager.vala"
	_vala_return_if_fail ((_tmp0_ != NULL) && (_tmp1_ != NULL), "upower != null && iscreen != null");
#line 143 "../src/Services/DeviceManager.vala"
	_tmp2_ = self->priv->upower;
#line 143 "../src/Services/DeviceManager.vala"
	g_signal_connect_object ((GDBusProxy*) _tmp2_, "g-properties-changed", (GCallback) ___lambda6__g_dbus_proxy_g_properties_changed, self, 0);
#line 148 "../src/Services/DeviceManager.vala"
	_tmp3_ = self->priv->upower;
#line 148 "../src/Services/DeviceManager.vala"
	g_signal_connect_object (_tmp3_, "device-added", (GCallback) _power_services_device_manager_register_device_power_services_dbus_interfaces_upower_device_added, self, 0);
#line 149 "../src/Services/DeviceManager.vala"
	_tmp4_ = self->priv->upower;
#line 149 "../src/Services/DeviceManager.vala"
	g_signal_connect_object (_tmp4_, "device-removed", (GCallback) _power_services_device_manager_deregister_device_power_services_dbus_interfaces_upower_device_removed, self, 0);
#line 151 "../src/Services/DeviceManager.vala"
	_tmp5_ = self->priv->iscreen;
#line 151 "../src/Services/DeviceManager.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) ___lambda7__g_dbus_proxy_g_properties_changed, self, 0);
#line 834 "DeviceManager.c"
}

static void
power_services_device_manager_update_properties (PowerServicesDeviceManager* self)
{
	PowerServicesDBusInterfacesUPower* _tmp0_;
	PowerServicesDBusInterfacesUPower* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 159 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->upower;
#line 159 "../src/Services/DeviceManager.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "upower != null");
#line 160 "../src/Services/DeviceManager.vala"
	_tmp1_ = self->priv->upower;
#line 160 "../src/Services/DeviceManager.vala"
	_tmp2_ = power_services_dbus_interfaces_upower_get_on_battery (_tmp1_);
#line 160 "../src/Services/DeviceManager.vala"
	_tmp3_ = _tmp2_;
#line 160 "../src/Services/DeviceManager.vala"
	power_services_device_manager_set_on_battery (self, _tmp3_);
#line 858 "DeviceManager.c"
}

static gboolean
__lambda5_ (PowerServicesDeviceManager* self,
            GeeMapEntry* entry)
{
	PowerServicesDevice* device = NULL;
	gconstpointer _tmp0_;
	gconstpointer _tmp1_;
	PowerServicesDevice* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 164 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (entry != NULL, FALSE);
#line 165 "../src/Services/DeviceManager.vala"
	_tmp0_ = gee_map_entry_get_value (entry);
#line 165 "../src/Services/DeviceManager.vala"
	_tmp1_ = _tmp0_;
#line 165 "../src/Services/DeviceManager.vala"
	_tmp2_ = _g_object_ref0 ((PowerServicesDevice*) _tmp1_);
#line 165 "../src/Services/DeviceManager.vala"
	device = _tmp2_;
#line 166 "../src/Services/DeviceManager.vala"
	_tmp3_ = power_services_device_get_is_a_battery (device);
#line 166 "../src/Services/DeviceManager.vala"
	_tmp4_ = _tmp3_;
#line 166 "../src/Services/DeviceManager.vala"
	result = _tmp4_;
#line 166 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (device);
#line 166 "../src/Services/DeviceManager.vala"
	return result;
#line 892 "DeviceManager.c"
}

static gboolean
___lambda5__gee_predicate (gconstpointer g,
                           gpointer self)
{
	gboolean result;
	result = __lambda5_ ((PowerServicesDeviceManager*) self, (GeeMapEntry*) g);
#line 164 "../src/Services/DeviceManager.vala"
	return result;
#line 903 "DeviceManager.c"
}

static void
power_services_device_manager_update_batteries (PowerServicesDeviceManager* self)
{
	GeeHashMap* _tmp0_;
	GeeIterator* _tmp1_;
	GeeIterator* _tmp2_;
	GeeIterator* _tmp3_;
#line 163 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->_devices;
#line 164 "../src/Services/DeviceManager.vala"
	_tmp1_ = gee_traversable_filter ((GeeTraversable*) _tmp0_, ___lambda5__gee_predicate, g_object_ref (self), g_object_unref);
#line 164 "../src/Services/DeviceManager.vala"
	_tmp2_ = _tmp1_;
#line 164 "../src/Services/DeviceManager.vala"
	power_services_device_manager_set_batteries (self, _tmp2_);
#line 164 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (_tmp2_);
#line 169 "../src/Services/DeviceManager.vala"
	_tmp3_ = self->priv->_batteries;
#line 169 "../src/Services/DeviceManager.vala"
	power_services_device_manager_set_has_battery (self, gee_iterator_has_next (_tmp3_));
#line 929 "DeviceManager.c"
}

static void
power_services_device_manager_register_device (PowerServicesDeviceManager* self,
                                               const char* device_path)
{
	PowerServicesDevice* device = NULL;
	PowerServicesDevice* _tmp0_;
	GeeHashMap* _tmp1_;
	PowerServicesDevice* _tmp2_;
	PowerServicesDevice* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 172 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/Services/DeviceManager.vala"
	g_return_if_fail (device_path != NULL);
#line 173 "../src/Services/DeviceManager.vala"
	_tmp0_ = power_services_device_new ((const gchar*) device_path);
#line 173 "../src/Services/DeviceManager.vala"
	device = _tmp0_;
#line 175 "../src/Services/DeviceManager.vala"
	_tmp1_ = self->priv->_devices;
#line 175 "../src/Services/DeviceManager.vala"
	_tmp2_ = device;
#line 175 "../src/Services/DeviceManager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, (const gchar*) device_path, _tmp2_);
#line 176 "../src/Services/DeviceManager.vala"
	g_debug ("DeviceManager.vala:176: Device \"%s\" registered", (const gchar*) device_path);
#line 177 "../src/Services/DeviceManager.vala"
	power_services_device_manager_update_batteries (self);
#line 179 "../src/Services/DeviceManager.vala"
	_tmp3_ = device;
#line 179 "../src/Services/DeviceManager.vala"
	_tmp4_ = power_services_device_get_is_a_battery (_tmp3_);
#line 179 "../src/Services/DeviceManager.vala"
	_tmp5_ = _tmp4_;
#line 179 "../src/Services/DeviceManager.vala"
	if (_tmp5_) {
#line 969 "DeviceManager.c"
		PowerServicesDevice* _tmp6_;
#line 180 "../src/Services/DeviceManager.vala"
		_tmp6_ = device;
#line 180 "../src/Services/DeviceManager.vala"
		g_signal_emit (self, power_services_device_manager_signals[POWER_SERVICES_DEVICE_MANAGER_BATTERY_REGISTERED_SIGNAL], 0, (const gchar*) device_path, _tmp6_);
#line 975 "DeviceManager.c"
	}
#line 172 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (device);
#line 979 "DeviceManager.c"
}

static void
power_services_device_manager_deregister_device (PowerServicesDeviceManager* self,
                                                 const char* device_path)
{
	GeeHashMap* _tmp0_;
	PowerServicesDevice* device = NULL;
	GeeHashMap* _tmp1_;
	gpointer _tmp2_;
	GeeHashMap* _tmp3_;
	PowerServicesDevice* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 184 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/Services/DeviceManager.vala"
	g_return_if_fail (device_path != NULL);
#line 185 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->_devices;
#line 185 "../src/Services/DeviceManager.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, (const gchar*) device_path)) {
#line 186 "../src/Services/DeviceManager.vala"
		return;
#line 1004 "DeviceManager.c"
	}
#line 189 "../src/Services/DeviceManager.vala"
	_tmp1_ = self->priv->_devices;
#line 189 "../src/Services/DeviceManager.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, (const gchar*) device_path);
#line 189 "../src/Services/DeviceManager.vala"
	device = (PowerServicesDevice*) _tmp2_;
#line 191 "../src/Services/DeviceManager.vala"
	_tmp3_ = self->priv->_devices;
#line 191 "../src/Services/DeviceManager.vala"
	if (!gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, (const gchar*) device_path, NULL)) {
#line 192 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (device);
#line 192 "../src/Services/DeviceManager.vala"
		return;
#line 1020 "DeviceManager.c"
	}
#line 195 "../src/Services/DeviceManager.vala"
	g_debug ("DeviceManager.vala:195: Device \"%s\" deregistered", (const gchar*) device_path);
#line 196 "../src/Services/DeviceManager.vala"
	power_services_device_manager_update_batteries (self);
#line 198 "../src/Services/DeviceManager.vala"
	_tmp4_ = device;
#line 198 "../src/Services/DeviceManager.vala"
	_tmp5_ = power_services_device_get_is_a_battery (_tmp4_);
#line 198 "../src/Services/DeviceManager.vala"
	_tmp6_ = _tmp5_;
#line 198 "../src/Services/DeviceManager.vala"
	if (_tmp6_) {
#line 199 "../src/Services/DeviceManager.vala"
		g_signal_emit (self, power_services_device_manager_signals[POWER_SERVICES_DEVICE_MANAGER_BATTERY_DEREGISTERED_SIGNAL], 0, (const gchar*) device_path);
#line 1036 "DeviceManager.c"
	}
#line 184 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (device);
#line 1040 "DeviceManager.c"
}

void
power_services_device_manager_change_brightness (PowerServicesDeviceManager* self,
                                                 gint change)
{
	PowerServicesDBusInterfacesPowerSettings* _tmp0_;
#line 203 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->iscreen;
#line 204 "../src/Services/DeviceManager.vala"
	if (_tmp0_ != NULL) {
#line 1054 "DeviceManager.c"
		PowerServicesDBusInterfacesPowerSettings* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 205 "../src/Services/DeviceManager.vala"
		_tmp1_ = self->priv->iscreen;
#line 205 "../src/Services/DeviceManager.vala"
		_tmp2_ = power_services_dbus_interfaces_power_settings_get_brightness (_tmp1_);
#line 205 "../src/Services/DeviceManager.vala"
		_tmp3_ = _tmp2_;
#line 205 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_brightness (self, _tmp3_ + change);
#line 1066 "DeviceManager.c"
	}
}

PowerServicesDeviceManager*
power_services_device_manager_construct (GType object_type)
{
	PowerServicesDeviceManager * self = NULL;
#line 20 "../src/Services/DeviceManager.vala"
	self = (PowerServicesDeviceManager*) g_object_new (object_type, NULL);
#line 20 "../src/Services/DeviceManager.vala"
	return self;
#line 1078 "DeviceManager.c"
}

PowerServicesDeviceManager*
power_services_device_manager_new (void)
{
#line 20 "../src/Services/DeviceManager.vala"
	return power_services_device_manager_construct (POWER_SERVICES_TYPE_DEVICE_MANAGER);
#line 1086 "DeviceManager.c"
}

PowerServicesBacklight*
power_services_device_manager_get_backlight (PowerServicesDeviceManager* self)
{
	PowerServicesBacklight* result;
	PowerServicesBacklight* _tmp0_;
#line 32 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->_backlight;
#line 32 "../src/Services/DeviceManager.vala"
	result = _tmp0_;
#line 32 "../src/Services/DeviceManager.vala"
	return result;
#line 1102 "DeviceManager.c"
}

static void
power_services_device_manager_set_backlight (PowerServicesDeviceManager* self,
                                             PowerServicesBacklight* value)
{
	PowerServicesBacklight* old_value;
#line 32 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Services/DeviceManager.vala"
	old_value = power_services_device_manager_get_backlight (self);
#line 32 "../src/Services/DeviceManager.vala"
	if (old_value != value) {
#line 1116 "DeviceManager.c"
		PowerServicesBacklight* _tmp0_;
#line 32 "../src/Services/DeviceManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 32 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (self->priv->_backlight);
#line 32 "../src/Services/DeviceManager.vala"
		self->priv->_backlight = _tmp0_;
#line 32 "../src/Services/DeviceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_BACKLIGHT_PROPERTY]);
#line 1126 "DeviceManager.c"
	}
}

GeeHashMap*
power_services_device_manager_get_devices (PowerServicesDeviceManager* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 33 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->_devices;
#line 33 "../src/Services/DeviceManager.vala"
	result = _tmp0_;
#line 33 "../src/Services/DeviceManager.vala"
	return result;
#line 1143 "DeviceManager.c"
}

static void
power_services_device_manager_set_devices (PowerServicesDeviceManager* self,
                                           GeeHashMap* value)
{
	GeeHashMap* old_value;
#line 33 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Services/DeviceManager.vala"
	old_value = power_services_device_manager_get_devices (self);
#line 33 "../src/Services/DeviceManager.vala"
	if (old_value != value) {
#line 1157 "DeviceManager.c"
		GeeHashMap* _tmp0_;
#line 33 "../src/Services/DeviceManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (self->priv->_devices);
#line 33 "../src/Services/DeviceManager.vala"
		self->priv->_devices = _tmp0_;
#line 33 "../src/Services/DeviceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_DEVICES_PROPERTY]);
#line 1167 "DeviceManager.c"
	}
}

GeeIterator*
power_services_device_manager_get_batteries (PowerServicesDeviceManager* self)
{
	GeeIterator* result;
	GeeIterator* _tmp0_;
#line 34 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->_batteries;
#line 34 "../src/Services/DeviceManager.vala"
	result = _tmp0_;
#line 34 "../src/Services/DeviceManager.vala"
	return result;
#line 1184 "DeviceManager.c"
}

static void
power_services_device_manager_set_batteries (PowerServicesDeviceManager* self,
                                             GeeIterator* value)
{
	GeeIterator* old_value;
#line 34 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Services/DeviceManager.vala"
	old_value = power_services_device_manager_get_batteries (self);
#line 34 "../src/Services/DeviceManager.vala"
	if (old_value != value) {
#line 1198 "DeviceManager.c"
		GeeIterator* _tmp0_;
#line 34 "../src/Services/DeviceManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 34 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (self->priv->_batteries);
#line 34 "../src/Services/DeviceManager.vala"
		self->priv->_batteries = _tmp0_;
#line 34 "../src/Services/DeviceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_BATTERIES_PROPERTY]);
#line 1208 "DeviceManager.c"
	}
}

PowerServicesDevice*
power_services_device_manager_get_display_device (PowerServicesDeviceManager* self)
{
	PowerServicesDevice* result;
	PowerServicesDevice* _tmp0_;
#line 35 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Services/DeviceManager.vala"
	_tmp0_ = self->priv->_display_device;
#line 35 "../src/Services/DeviceManager.vala"
	result = _tmp0_;
#line 35 "../src/Services/DeviceManager.vala"
	return result;
#line 1225 "DeviceManager.c"
}

static void
power_services_device_manager_set_display_device (PowerServicesDeviceManager* self,
                                                  PowerServicesDevice* value)
{
	PowerServicesDevice* old_value;
#line 35 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Services/DeviceManager.vala"
	old_value = power_services_device_manager_get_display_device (self);
#line 35 "../src/Services/DeviceManager.vala"
	if (old_value != value) {
#line 1239 "DeviceManager.c"
		PowerServicesDevice* _tmp0_;
#line 35 "../src/Services/DeviceManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 35 "../src/Services/DeviceManager.vala"
		_g_object_unref0 (self->priv->_display_device);
#line 35 "../src/Services/DeviceManager.vala"
		self->priv->_display_device = _tmp0_;
#line 35 "../src/Services/DeviceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_DISPLAY_DEVICE_PROPERTY]);
#line 1249 "DeviceManager.c"
	}
}

gboolean
power_services_device_manager_get_has_battery (PowerServicesDeviceManager* self)
{
	gboolean result;
#line 36 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Services/DeviceManager.vala"
	result = self->priv->_has_battery;
#line 36 "../src/Services/DeviceManager.vala"
	return result;
#line 1263 "DeviceManager.c"
}

static void
power_services_device_manager_set_has_battery (PowerServicesDeviceManager* self,
                                               gboolean value)
{
	gboolean old_value;
#line 36 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Services/DeviceManager.vala"
	old_value = power_services_device_manager_get_has_battery (self);
#line 36 "../src/Services/DeviceManager.vala"
	if (old_value != value) {
#line 36 "../src/Services/DeviceManager.vala"
		self->priv->_has_battery = value;
#line 36 "../src/Services/DeviceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_HAS_BATTERY_PROPERTY]);
#line 1281 "DeviceManager.c"
	}
}

gboolean
power_services_device_manager_get_on_battery (PowerServicesDeviceManager* self)
{
	gboolean result;
#line 37 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "../src/Services/DeviceManager.vala"
	result = self->priv->_on_battery;
#line 37 "../src/Services/DeviceManager.vala"
	return result;
#line 1295 "DeviceManager.c"
}

static void
power_services_device_manager_set_on_battery (PowerServicesDeviceManager* self,
                                              gboolean value)
{
	gboolean old_value;
#line 37 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Services/DeviceManager.vala"
	old_value = power_services_device_manager_get_on_battery (self);
#line 37 "../src/Services/DeviceManager.vala"
	if (old_value != value) {
#line 37 "../src/Services/DeviceManager.vala"
		self->priv->_on_battery = value;
#line 37 "../src/Services/DeviceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_ON_BATTERY_PROPERTY]);
#line 1313 "DeviceManager.c"
	}
}

gboolean
power_services_device_manager_get_on_low_battery (PowerServicesDeviceManager* self)
{
	gboolean result;
#line 38 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/Services/DeviceManager.vala"
	result = self->priv->_on_low_battery;
#line 38 "../src/Services/DeviceManager.vala"
	return result;
#line 1327 "DeviceManager.c"
}

static void
power_services_device_manager_set_on_low_battery (PowerServicesDeviceManager* self,
                                                  gboolean value)
{
	gboolean old_value;
#line 38 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Services/DeviceManager.vala"
	old_value = power_services_device_manager_get_on_low_battery (self);
#line 38 "../src/Services/DeviceManager.vala"
	if (old_value != value) {
#line 38 "../src/Services/DeviceManager.vala"
		self->priv->_on_low_battery = value;
#line 38 "../src/Services/DeviceManager.vala"
		g_object_notify_by_pspec ((GObject *) self, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_ON_LOW_BATTERY_PROPERTY]);
#line 1345 "DeviceManager.c"
	}
}

gint
power_services_device_manager_get_brightness (PowerServicesDeviceManager* self)
{
	gint result;
	gboolean _tmp0_ = FALSE;
	PowerServicesBacklight* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 40 "../src/Services/DeviceManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/Services/DeviceManager.vala"
	_tmp1_ = self->priv->_backlight;
#line 41 "../src/Services/DeviceManager.vala"
	_tmp2_ = power_services_backlight_get_present (_tmp1_);
#line 41 "../src/Services/DeviceManager.vala"
	_tmp3_ = _tmp2_;
#line 41 "../src/Services/DeviceManager.vala"
	if (_tmp3_) {
#line 1367 "DeviceManager.c"
		PowerServicesDBusInterfacesPowerSettings* _tmp4_;
#line 41 "../src/Services/DeviceManager.vala"
		_tmp4_ = self->priv->iscreen;
#line 41 "../src/Services/DeviceManager.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1373 "DeviceManager.c"
	} else {
#line 41 "../src/Services/DeviceManager.vala"
		_tmp0_ = FALSE;
#line 1377 "DeviceManager.c"
	}
#line 41 "../src/Services/DeviceManager.vala"
	if (_tmp0_) {
#line 1381 "DeviceManager.c"
		PowerServicesDBusInterfacesPowerSettings* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 42 "../src/Services/DeviceManager.vala"
		_tmp5_ = self->priv->iscreen;
#line 42 "../src/Services/DeviceManager.vala"
		_tmp6_ = power_services_dbus_interfaces_power_settings_get_brightness (_tmp5_);
#line 42 "../src/Services/DeviceManager.vala"
		_tmp7_ = _tmp6_;
#line 42 "../src/Services/DeviceManager.vala"
		result = _tmp7_;
#line 42 "../src/Services/DeviceManager.vala"
		return result;
#line 1395 "DeviceManager.c"
	} else {
#line 44 "../src/Services/DeviceManager.vala"
		result = -1;
#line 44 "../src/Services/DeviceManager.vala"
		return result;
#line 1401 "DeviceManager.c"
	}
}

void
power_services_device_manager_set_brightness (PowerServicesDeviceManager* self,
                                              gint value)
{
	gboolean _tmp0_ = FALSE;
	PowerServicesBacklight* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 48 "../src/Services/DeviceManager.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Services/DeviceManager.vala"
	_tmp1_ = self->priv->_backlight;
#line 49 "../src/Services/DeviceManager.vala"
	_tmp2_ = power_services_backlight_get_present (_tmp1_);
#line 49 "../src/Services/DeviceManager.vala"
	_tmp3_ = _tmp2_;
#line 49 "../src/Services/DeviceManager.vala"
	if (_tmp3_) {
#line 1423 "DeviceManager.c"
		PowerServicesDBusInterfacesPowerSettings* _tmp4_;
#line 49 "../src/Services/DeviceManager.vala"
		_tmp4_ = self->priv->iscreen;
#line 49 "../src/Services/DeviceManager.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1429 "DeviceManager.c"
	} else {
#line 49 "../src/Services/DeviceManager.vala"
		_tmp0_ = FALSE;
#line 1433 "DeviceManager.c"
	}
#line 49 "../src/Services/DeviceManager.vala"
	if (_tmp0_) {
#line 1437 "DeviceManager.c"
		PowerServicesDBusInterfacesPowerSettings* _tmp5_;
#line 50 "../src/Services/DeviceManager.vala"
		_tmp5_ = self->priv->iscreen;
#line 50 "../src/Services/DeviceManager.vala"
		power_services_dbus_interfaces_power_settings_set_brightness (_tmp5_, CLAMP (value, 0, 100));
#line 1443 "DeviceManager.c"
	}
#line 48 "../src/Services/DeviceManager.vala"
	g_object_notify_by_pspec ((GObject *) self, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_BRIGHTNESS_PROPERTY]);
#line 1447 "DeviceManager.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_OBJECT) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 20 "../src/Services/DeviceManager.vala"
	g_return_if_fail (n_param_values == 3);
#line 20 "../src/Services/DeviceManager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 20 "../src/Services/DeviceManager.vala"
		data1 = closure->data;
#line 20 "../src/Services/DeviceManager.vala"
		data2 = param_values->data[0].v_pointer;
#line 1472 "DeviceManager.c"
	} else {
#line 20 "../src/Services/DeviceManager.vala"
		data1 = param_values->data[0].v_pointer;
#line 20 "../src/Services/DeviceManager.vala"
		data2 = closure->data;
#line 1478 "DeviceManager.c"
	}
#line 20 "../src/Services/DeviceManager.vala"
	callback = (GMarshalFunc_VOID__STRING_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 20 "../src/Services/DeviceManager.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1484 "DeviceManager.c"
}

static void
_power_services_device_manager___lambda8_ (PowerServicesDeviceManager* self,
                                           GObject* obj,
                                           GAsyncResult* res)
{
#line 62 "../src/Services/DeviceManager.vala"
	g_return_if_fail (res != NULL);
#line 63 "../src/Services/DeviceManager.vala"
	if (power_services_device_manager_connect_to_bus_finish (self, res)) {
#line 64 "../src/Services/DeviceManager.vala"
		power_services_device_manager_update_properties (self);
#line 65 "../src/Services/DeviceManager.vala"
		power_services_device_manager_read_devices (self);
#line 66 "../src/Services/DeviceManager.vala"
		power_services_device_manager_update_batteries (self);
#line 67 "../src/Services/DeviceManager.vala"
		power_services_device_manager_connect_signals (self);
#line 1504 "DeviceManager.c"
	}
}

static void
__power_services_device_manager___lambda8__gasync_ready_callback (GObject* source_object,
                                                                  GAsyncResult* res,
                                                                  gpointer self)
{
#line 62 "../src/Services/DeviceManager.vala"
	_power_services_device_manager___lambda8_ ((PowerServicesDeviceManager*) self, source_object, res);
#line 62 "../src/Services/DeviceManager.vala"
	g_object_unref (self);
#line 1517 "DeviceManager.c"
}

static GObject *
power_services_device_manager_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerServicesDeviceManager * self;
	PowerServicesBacklight* _tmp0_;
	PowerServicesBacklight* _tmp1_;
#line 59 "../src/Services/DeviceManager.vala"
	parent_class = G_OBJECT_CLASS (power_services_device_manager_parent_class);
#line 59 "../src/Services/DeviceManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/Services/DeviceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_SERVICES_TYPE_DEVICE_MANAGER, PowerServicesDeviceManager);
#line 60 "../src/Services/DeviceManager.vala"
	_tmp0_ = power_services_backlight_new ();
#line 60 "../src/Services/DeviceManager.vala"
	_tmp1_ = _tmp0_;
#line 60 "../src/Services/DeviceManager.vala"
	power_services_device_manager_set_backlight (self, _tmp1_);
#line 60 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (_tmp1_);
#line 62 "../src/Services/DeviceManager.vala"
	power_services_device_manager_connect_to_bus (self, __power_services_device_manager___lambda8__gasync_ready_callback, g_object_ref (self));
#line 59 "../src/Services/DeviceManager.vala"
	return obj;
#line 1548 "DeviceManager.c"
}

static void
power_services_device_manager_class_init (PowerServicesDeviceManagerClass * klass,
                                          gpointer klass_data)
{
#line 20 "../src/Services/DeviceManager.vala"
	power_services_device_manager_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Services/DeviceManager.vala"
	g_type_class_adjust_private_offset (klass, &PowerServicesDeviceManager_private_offset);
#line 20 "../src/Services/DeviceManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_services_device_manager_get_property;
#line 20 "../src/Services/DeviceManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_services_device_manager_set_property;
#line 20 "../src/Services/DeviceManager.vala"
	G_OBJECT_CLASS (klass)->constructor = power_services_device_manager_constructor;
#line 20 "../src/Services/DeviceManager.vala"
	G_OBJECT_CLASS (klass)->finalize = power_services_device_manager_finalize;
#line 20 "../src/Services/DeviceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_MANAGER_BACKLIGHT_PROPERTY, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_BACKLIGHT_PROPERTY] = g_param_spec_object ("backlight", "backlight", "backlight", POWER_SERVICES_TYPE_BACKLIGHT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 20 "../src/Services/DeviceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_MANAGER_DEVICES_PROPERTY, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_DEVICES_PROPERTY] = g_param_spec_object ("devices", "devices", "devices", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/DeviceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_MANAGER_BATTERIES_PROPERTY, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_BATTERIES_PROPERTY] = g_param_spec_object ("batteries", "batteries", "batteries", GEE_TYPE_ITERATOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/DeviceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_MANAGER_DISPLAY_DEVICE_PROPERTY, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_DISPLAY_DEVICE_PROPERTY] = g_param_spec_object ("display-device", "display-device", "display-device", POWER_SERVICES_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/DeviceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_MANAGER_HAS_BATTERY_PROPERTY, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_HAS_BATTERY_PROPERTY] = g_param_spec_boolean ("has-battery", "has-battery", "has-battery", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/DeviceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_MANAGER_ON_BATTERY_PROPERTY, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_ON_BATTERY_PROPERTY] = g_param_spec_boolean ("on-battery", "on-battery", "on-battery", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/DeviceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_MANAGER_ON_LOW_BATTERY_PROPERTY, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_ON_LOW_BATTERY_PROPERTY] = g_param_spec_boolean ("on-low-battery", "on-low-battery", "on-low-battery", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 20 "../src/Services/DeviceManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_SERVICES_DEVICE_MANAGER_BRIGHTNESS_PROPERTY, power_services_device_manager_properties[POWER_SERVICES_DEVICE_MANAGER_BRIGHTNESS_PROPERTY] = g_param_spec_int ("brightness", "brightness", "brightness", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 20 "../src/Services/DeviceManager.vala"
	power_services_device_manager_signals[POWER_SERVICES_DEVICE_MANAGER_BATTERY_REGISTERED_SIGNAL] = g_signal_new ("battery-registered", POWER_SERVICES_TYPE_DEVICE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_OBJECT, G_TYPE_NONE, 2, G_TYPE_STRING, POWER_SERVICES_TYPE_DEVICE);
#line 20 "../src/Services/DeviceManager.vala"
	power_services_device_manager_signals[POWER_SERVICES_DEVICE_MANAGER_BATTERY_DEREGISTERED_SIGNAL] = g_signal_new ("battery-deregistered", POWER_SERVICES_TYPE_DEVICE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 20 "../src/Services/DeviceManager.vala"
	power_services_device_manager_signals[POWER_SERVICES_DEVICE_MANAGER_BRIGHTNESS_CHANGED_SIGNAL] = g_signal_new ("brightness-changed", POWER_SERVICES_TYPE_DEVICE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 1589 "DeviceManager.c"
}

static void
power_services_device_manager_instance_init (PowerServicesDeviceManager * self,
                                             gpointer klass)
{
#line 20 "../src/Services/DeviceManager.vala"
	self->priv = power_services_device_manager_get_instance_private (self);
#line 29 "../src/Services/DeviceManager.vala"
	self->priv->upower = NULL;
#line 30 "../src/Services/DeviceManager.vala"
	self->priv->iscreen = NULL;
#line 1602 "DeviceManager.c"
}

static void
power_services_device_manager_finalize (GObject * obj)
{
	PowerServicesDeviceManager * self;
#line 20 "../src/Services/DeviceManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_SERVICES_TYPE_DEVICE_MANAGER, PowerServicesDeviceManager);
#line 29 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (self->priv->upower);
#line 30 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (self->priv->iscreen);
#line 32 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (self->priv->_backlight);
#line 33 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (self->priv->_devices);
#line 34 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (self->priv->_batteries);
#line 35 "../src/Services/DeviceManager.vala"
	_g_object_unref0 (self->priv->_display_device);
#line 20 "../src/Services/DeviceManager.vala"
	G_OBJECT_CLASS (power_services_device_manager_parent_class)->finalize (obj);
#line 1625 "DeviceManager.c"
}

static GType
power_services_device_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerServicesDeviceManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_services_device_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerServicesDeviceManager), 0, (GInstanceInitFunc) power_services_device_manager_instance_init, NULL };
	GType power_services_device_manager_type_id;
	power_services_device_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "PowerServicesDeviceManager", &g_define_type_info, 0);
	PowerServicesDeviceManager_private_offset = g_type_add_instance_private (power_services_device_manager_type_id, sizeof (PowerServicesDeviceManagerPrivate));
	return power_services_device_manager_type_id;
}

GType
power_services_device_manager_get_type (void)
{
	static volatile gsize power_services_device_manager_type_id__once = 0;
	if (g_once_init_enter (&power_services_device_manager_type_id__once)) {
		GType power_services_device_manager_type_id;
		power_services_device_manager_type_id = power_services_device_manager_get_type_once ();
		g_once_init_leave (&power_services_device_manager_type_id__once, power_services_device_manager_type_id);
	}
	return power_services_device_manager_type_id__once;
}

static void
_vala_power_services_device_manager_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	PowerServicesDeviceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_SERVICES_TYPE_DEVICE_MANAGER, PowerServicesDeviceManager);
#line 20 "../src/Services/DeviceManager.vala"
	switch (property_id) {
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_BACKLIGHT_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		g_value_set_object (value, power_services_device_manager_get_backlight (self));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_DEVICES_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		g_value_set_object (value, power_services_device_manager_get_devices (self));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_BATTERIES_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		g_value_set_object (value, power_services_device_manager_get_batteries (self));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_DISPLAY_DEVICE_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		g_value_set_object (value, power_services_device_manager_get_display_device (self));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_HAS_BATTERY_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		g_value_set_boolean (value, power_services_device_manager_get_has_battery (self));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_ON_BATTERY_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		g_value_set_boolean (value, power_services_device_manager_get_on_battery (self));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_ON_LOW_BATTERY_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		g_value_set_boolean (value, power_services_device_manager_get_on_low_battery (self));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_BRIGHTNESS_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		g_value_set_int (value, power_services_device_manager_get_brightness (self));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 1708 "DeviceManager.c"
		default:
#line 20 "../src/Services/DeviceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 1714 "DeviceManager.c"
	}
}

static void
_vala_power_services_device_manager_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	PowerServicesDeviceManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_SERVICES_TYPE_DEVICE_MANAGER, PowerServicesDeviceManager);
#line 20 "../src/Services/DeviceManager.vala"
	switch (property_id) {
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_BACKLIGHT_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_backlight (self, g_value_get_object (value));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_DEVICES_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_devices (self, g_value_get_object (value));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_BATTERIES_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_batteries (self, g_value_get_object (value));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_DISPLAY_DEVICE_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_display_device (self, g_value_get_object (value));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_HAS_BATTERY_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_has_battery (self, g_value_get_boolean (value));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_ON_BATTERY_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_on_battery (self, g_value_get_boolean (value));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_ON_LOW_BATTERY_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_on_low_battery (self, g_value_get_boolean (value));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 20 "../src/Services/DeviceManager.vala"
		case POWER_SERVICES_DEVICE_MANAGER_BRIGHTNESS_PROPERTY:
#line 20 "../src/Services/DeviceManager.vala"
		power_services_device_manager_set_brightness (self, g_value_get_int (value));
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 1776 "DeviceManager.c"
		default:
#line 20 "../src/Services/DeviceManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Services/DeviceManager.vala"
		break;
#line 1782 "DeviceManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

