/* PopoverWidget.c generated by valac 0.56.17, the Vala compiler
 * generated from PopoverWidget.vala, do not modify */

/*
 * Copyright 2011-2020 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "power.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	POWER_WIDGETS_POPOVER_WIDGET_0_PROPERTY,
	POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY,
	POWER_WIDGETS_POPOVER_WIDGET_NUM_PROPERTIES
};
static GParamSpec* power_widgets_popover_widget_properties[POWER_WIDGETS_POPOVER_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerWidgetsPopoverWidgetPrivate {
	gboolean _is_in_session;
	PowerWidgetsAppList* app_list;
	GtkRevealer* device_separator_revealer;
};

struct _Block7Data {
	int _ref_count_;
	PowerWidgetsPopoverWidget* self;
	GtkRevealer* last_separator_revealer;
};

static gint PowerWidgetsPopoverWidget_private_offset;
static gpointer power_widgets_popover_widget_parent_class = NULL;
static PowerServicesDeviceManager* power_widgets_popover_widget_dm;
static PowerServicesDeviceManager* power_widgets_popover_widget_dm = NULL;

static void power_widgets_popover_widget_update_device_seperator_revealer (PowerWidgetsPopoverWidget* self);
static GObject * power_widgets_popover_widget_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _power_widgets_popover_widget___lambda23_ (PowerWidgetsPopoverWidget* self,
                                                GObject* s,
                                                GParamSpec* p);
static void __power_widgets_popover_widget___lambda23__g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self);
static void _power_widgets_popover_widget___lambda24_ (PowerWidgetsPopoverWidget* self);
static void __power_widgets_popover_widget___lambda24__gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self);
static void _power_widgets_popover_widget___lambda25_ (Block7Data* _data7_,
                                                gint brightness);
static void __power_widgets_popover_widget___lambda25__power_services_device_manager_brightness_changed (PowerServicesDeviceManager* _sender,
                                                                                                  gint brightness,
                                                                                                  gpointer self);
static void power_widgets_popover_widget_finalize (GObject * obj);
static GType power_widgets_popover_widget_get_type_once (void);
static void _vala_power_widgets_popover_widget_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_power_widgets_popover_widget_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
power_widgets_popover_widget_get_instance_private (PowerWidgetsPopoverWidget* self)
{
	return G_STRUCT_MEMBER_P (self, PowerWidgetsPopoverWidget_private_offset);
}

PowerWidgetsPopoverWidget*
power_widgets_popover_widget_construct (GType object_type,
                                        gboolean is_in_session)
{
	PowerWidgetsPopoverWidget * self = NULL;
#line 29 "../src/Widgets/PopoverWidget.vala"
	self = (PowerWidgetsPopoverWidget*) g_object_new (object_type, "is-in-session", is_in_session, NULL);
#line 28 "../src/Widgets/PopoverWidget.vala"
	return self;
#line 119 "PopoverWidget.c"
}

PowerWidgetsPopoverWidget*
power_widgets_popover_widget_new (gboolean is_in_session)
{
#line 28 "../src/Widgets/PopoverWidget.vala"
	return power_widgets_popover_widget_construct (POWER_WIDGETS_TYPE_POPOVER_WIDGET, is_in_session);
#line 127 "PopoverWidget.c"
}

static void
power_widgets_popover_widget_update_device_seperator_revealer (PowerWidgetsPopoverWidget* self)
{
	gboolean _tmp0_ = FALSE;
	PowerServicesDeviceManager* _tmp1_;
	PowerServicesBacklight* _tmp2_;
	PowerServicesBacklight* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkRevealer* _tmp9_;
#line 133 "../src/Widgets/PopoverWidget.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/Widgets/PopoverWidget.vala"
	_tmp1_ = power_widgets_popover_widget_dm;
#line 134 "../src/Widgets/PopoverWidget.vala"
	_tmp2_ = power_services_device_manager_get_backlight (_tmp1_);
#line 134 "../src/Widgets/PopoverWidget.vala"
	_tmp3_ = _tmp2_;
#line 134 "../src/Widgets/PopoverWidget.vala"
	_tmp4_ = power_services_backlight_get_present (_tmp3_);
#line 134 "../src/Widgets/PopoverWidget.vala"
	_tmp5_ = _tmp4_;
#line 134 "../src/Widgets/PopoverWidget.vala"
	if (_tmp5_) {
#line 154 "PopoverWidget.c"
		PowerServicesDeviceManager* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 134 "../src/Widgets/PopoverWidget.vala"
		_tmp6_ = power_widgets_popover_widget_dm;
#line 134 "../src/Widgets/PopoverWidget.vala"
		_tmp7_ = power_services_device_manager_get_has_battery (_tmp6_);
#line 134 "../src/Widgets/PopoverWidget.vala"
		_tmp8_ = _tmp7_;
#line 134 "../src/Widgets/PopoverWidget.vala"
		_tmp0_ = _tmp8_;
#line 166 "PopoverWidget.c"
	} else {
#line 134 "../src/Widgets/PopoverWidget.vala"
		_tmp0_ = FALSE;
#line 170 "PopoverWidget.c"
	}
#line 134 "../src/Widgets/PopoverWidget.vala"
	_tmp9_ = self->priv->device_separator_revealer;
#line 134 "../src/Widgets/PopoverWidget.vala"
	gtk_revealer_set_reveal_child (_tmp9_, _tmp0_);
#line 176 "PopoverWidget.c"
}

void
power_widgets_popover_widget_slim_down (PowerWidgetsPopoverWidget* self)
{
	gboolean _tmp0_;
#line 137 "../src/Widgets/PopoverWidget.vala"
	g_return_if_fail (self != NULL);
#line 138 "../src/Widgets/PopoverWidget.vala"
	_tmp0_ = self->priv->_is_in_session;
#line 138 "../src/Widgets/PopoverWidget.vala"
	if (_tmp0_) {
#line 189 "PopoverWidget.c"
		PowerWidgetsAppList* _tmp1_;
#line 139 "../src/Widgets/PopoverWidget.vala"
		_tmp1_ = self->priv->app_list;
#line 139 "../src/Widgets/PopoverWidget.vala"
		power_widgets_app_list_clear_list (_tmp1_);
#line 195 "PopoverWidget.c"
	}
}

gboolean
power_widgets_popover_widget_get_is_in_session (PowerWidgetsPopoverWidget* self)
{
	gboolean result;
#line 21 "../src/Widgets/PopoverWidget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 21 "../src/Widgets/PopoverWidget.vala"
	result = self->priv->_is_in_session;
#line 21 "../src/Widgets/PopoverWidget.vala"
	return result;
#line 209 "PopoverWidget.c"
}

static void
power_widgets_popover_widget_set_is_in_session (PowerWidgetsPopoverWidget* self,
                                                gboolean value)
{
	gboolean old_value;
#line 21 "../src/Widgets/PopoverWidget.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/Widgets/PopoverWidget.vala"
	old_value = power_widgets_popover_widget_get_is_in_session (self);
#line 21 "../src/Widgets/PopoverWidget.vala"
	if (old_value != value) {
#line 21 "../src/Widgets/PopoverWidget.vala"
		self->priv->_is_in_session = value;
#line 21 "../src/Widgets/PopoverWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, power_widgets_popover_widget_properties[POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY]);
#line 227 "PopoverWidget.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 36 "../src/Widgets/PopoverWidget.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 36 "../src/Widgets/PopoverWidget.vala"
	return _data7_;
#line 238 "PopoverWidget.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 36 "../src/Widgets/PopoverWidget.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 248 "PopoverWidget.c"
		PowerWidgetsPopoverWidget* self;
#line 36 "../src/Widgets/PopoverWidget.vala"
		self = _data7_->self;
#line 36 "../src/Widgets/PopoverWidget.vala"
		_g_object_unref0 (_data7_->last_separator_revealer);
#line 36 "../src/Widgets/PopoverWidget.vala"
		_g_object_unref0 (self);
#line 36 "../src/Widgets/PopoverWidget.vala"
		g_slice_free (Block7Data, _data7_);
#line 258 "PopoverWidget.c"
	}
}

static void
_power_widgets_popover_widget___lambda23_ (PowerWidgetsPopoverWidget* self,
                                           GObject* s,
                                           GParamSpec* p)
{
#line 99 "../src/Widgets/PopoverWidget.vala"
	g_return_if_fail (s != NULL);
#line 99 "../src/Widgets/PopoverWidget.vala"
	g_return_if_fail (p != NULL);
#line 100 "../src/Widgets/PopoverWidget.vala"
	power_widgets_popover_widget_update_device_seperator_revealer (self);
#line 273 "PopoverWidget.c"
}

static void
__power_widgets_popover_widget___lambda23__g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self)
{
#line 99 "../src/Widgets/PopoverWidget.vala"
	_power_widgets_popover_widget___lambda23_ ((PowerWidgetsPopoverWidget*) self, _sender, pspec);
#line 283 "PopoverWidget.c"
}

static void
_power_widgets_popover_widget___lambda24_ (PowerWidgetsPopoverWidget* self)
{
	GError* _inner_error0_ = NULL;
	{
#line 118 "../src/Widgets/PopoverWidget.vala"
		g_app_info_launch_default_for_uri ("settings://power", NULL, &_inner_error0_);
#line 118 "../src/Widgets/PopoverWidget.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 295 "PopoverWidget.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 117 "../src/Widgets/PopoverWidget.vala"
		e = _inner_error0_;
#line 117 "../src/Widgets/PopoverWidget.vala"
		_inner_error0_ = NULL;
#line 120 "../src/Widgets/PopoverWidget.vala"
		_tmp0_ = e;
#line 120 "../src/Widgets/PopoverWidget.vala"
		_tmp1_ = _tmp0_->message;
#line 120 "../src/Widgets/PopoverWidget.vala"
		g_warning ("PopoverWidget.vala:120: Failed to open power settings: %s", _tmp1_);
#line 117 "../src/Widgets/PopoverWidget.vala"
		_g_error_free0 (e);
#line 317 "PopoverWidget.c"
	}
	__finally0:
#line 117 "../src/Widgets/PopoverWidget.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/Widgets/PopoverWidget.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 117 "../src/Widgets/PopoverWidget.vala"
		g_clear_error (&_inner_error0_);
#line 117 "../src/Widgets/PopoverWidget.vala"
		return;
#line 328 "PopoverWidget.c"
	}
}

static void
__power_widgets_popover_widget___lambda24__gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self)
{
#line 116 "../src/Widgets/PopoverWidget.vala"
	_power_widgets_popover_widget___lambda24_ ((PowerWidgetsPopoverWidget*) self);
#line 338 "PopoverWidget.c"
}

static void
_power_widgets_popover_widget___lambda25_ (Block7Data* _data7_,
                                           gint brightness)
{
	PowerWidgetsPopoverWidget* self;
#line 124 "../src/Widgets/PopoverWidget.vala"
	self = _data7_->self;
#line 125 "../src/Widgets/PopoverWidget.vala"
	if (brightness != -1) {
#line 350 "PopoverWidget.c"
		GtkRevealer* _tmp0_;
#line 126 "../src/Widgets/PopoverWidget.vala"
		_tmp0_ = _data7_->last_separator_revealer;
#line 126 "../src/Widgets/PopoverWidget.vala"
		gtk_revealer_set_reveal_child (_tmp0_, TRUE);
#line 356 "PopoverWidget.c"
	} else {
		GtkRevealer* _tmp1_;
#line 128 "../src/Widgets/PopoverWidget.vala"
		_tmp1_ = _data7_->last_separator_revealer;
#line 128 "../src/Widgets/PopoverWidget.vala"
		gtk_revealer_set_reveal_child (_tmp1_, FALSE);
#line 363 "PopoverWidget.c"
	}
}

static void
__power_widgets_popover_widget___lambda25__power_services_device_manager_brightness_changed (PowerServicesDeviceManager* _sender,
                                                                                             gint brightness,
                                                                                             gpointer self)
{
#line 124 "../src/Widgets/PopoverWidget.vala"
	_power_widgets_popover_widget___lambda25_ (self, brightness);
#line 374 "PopoverWidget.c"
}

static GObject *
power_widgets_popover_widget_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerWidgetsPopoverWidget * self;
	Block7Data* _data7_;
	GSettings* settings = NULL;
	GSettings* _tmp0_;
	PowerWidgetsDeviceList* device_list = NULL;
	PowerWidgetsDeviceList* _tmp1_;
	GtkRevealer* device_list_revealer = NULL;
	GtkRevealer* _tmp2_;
	GtkRevealer* _tmp3_;
	PowerWidgetsDeviceList* _tmp4_;
	GtkSeparator* device_separator = NULL;
	GtkSeparator* _tmp5_ = NULL;
	GtkRevealer* _tmp6_;
	GtkRevealer* _tmp7_;
	GtkSeparator* _tmp8_;
	GtkSeparator* last_separator = NULL;
	GtkSeparator* _tmp9_ = NULL;
	PowerServicesDeviceManager* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GtkRevealer* _tmp13_ = NULL;
	GtkRevealer* _tmp14_;
	GtkSeparator* _tmp15_;
	GraniteSwitchModelButton* show_percent_switch = NULL;
	GraniteSwitchModelButton* _tmp16_;
	GraniteSwitchModelButton* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkSeparator* show_percent_sep = NULL;
	GtkSeparator* _tmp19_ = NULL;
	GtkBox* show_percent_box = NULL;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GraniteSwitchModelButton* _tmp22_;
	GtkBox* _tmp23_;
	GtkSeparator* _tmp24_;
	GtkRevealer* show_percent_revealer = NULL;
	GtkRevealer* _tmp25_;
	GtkRevealer* _tmp26_;
	GtkBox* _tmp27_;
	GtkModelButton* show_settings_button = NULL;
	gchar* _tmp28_;
	GtkModelButton* _tmp29_ = NULL;
	GtkRevealer* _tmp30_;
	GtkRevealer* _tmp31_;
	GtkRevealer* _tmp32_;
	PowerServicesDeviceManager* _tmp33_;
	PowerServicesBacklight* _tmp34_;
	PowerServicesBacklight* _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp40_;
	PowerServicesDeviceManager* _tmp45_;
	GSettings* _tmp46_;
	GraniteSwitchModelButton* _tmp47_;
	PowerServicesDeviceManager* _tmp48_;
	GtkRevealer* _tmp49_;
	gboolean _tmp50_ = FALSE;
	PowerServicesDeviceManager* _tmp51_;
	gboolean _tmp52_;
	gboolean _tmp53_;
	GtkModelButton* _tmp60_;
	PowerServicesDeviceManager* _tmp61_;
#line 36 "../src/Widgets/PopoverWidget.vala"
	parent_class = G_OBJECT_CLASS (power_widgets_popover_widget_parent_class);
#line 36 "../src/Widgets/PopoverWidget.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/Widgets/PopoverWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_WIDGETS_TYPE_POPOVER_WIDGET, PowerWidgetsPopoverWidget);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_data7_->_ref_count_ = 1;
#line 36 "../src/Widgets/PopoverWidget.vala"
	_data7_->self = g_object_ref (self);
#line 37 "../src/Widgets/PopoverWidget.vala"
	_tmp0_ = g_settings_new ("io.elementary.desktop.wingpanel.power");
#line 37 "../src/Widgets/PopoverWidget.vala"
	settings = _tmp0_;
#line 39 "../src/Widgets/PopoverWidget.vala"
	_tmp1_ = power_widgets_device_list_new ();
#line 39 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp1_);
#line 39 "../src/Widgets/PopoverWidget.vala"
	device_list = _tmp1_;
#line 41 "../src/Widgets/PopoverWidget.vala"
	_tmp2_ = (GtkRevealer*) gtk_revealer_new ();
#line 41 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp2_);
#line 41 "../src/Widgets/PopoverWidget.vala"
	device_list_revealer = _tmp2_;
#line 42 "../src/Widgets/PopoverWidget.vala"
	_tmp3_ = device_list_revealer;
#line 42 "../src/Widgets/PopoverWidget.vala"
	_tmp4_ = device_list;
#line 42 "../src/Widgets/PopoverWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 44 "../src/Widgets/PopoverWidget.vala"
	_tmp5_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 44 "../src/Widgets/PopoverWidget.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp5_, 3);
#line 44 "../src/Widgets/PopoverWidget.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp5_, 3);
#line 44 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp5_);
#line 44 "../src/Widgets/PopoverWidget.vala"
	device_separator = _tmp5_;
#line 49 "../src/Widgets/PopoverWidget.vala"
	_tmp6_ = (GtkRevealer*) gtk_revealer_new ();
#line 49 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp6_);
#line 49 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (self->priv->device_separator_revealer);
#line 49 "../src/Widgets/PopoverWidget.vala"
	self->priv->device_separator_revealer = _tmp6_;
#line 50 "../src/Widgets/PopoverWidget.vala"
	_tmp7_ = self->priv->device_separator_revealer;
#line 50 "../src/Widgets/PopoverWidget.vala"
	_tmp8_ = device_separator;
#line 50 "../src/Widgets/PopoverWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 52 "../src/Widgets/PopoverWidget.vala"
	_tmp9_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 52 "../src/Widgets/PopoverWidget.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp9_, 3);
#line 52 "../src/Widgets/PopoverWidget.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp9_, 3);
#line 52 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp9_);
#line 52 "../src/Widgets/PopoverWidget.vala"
	last_separator = _tmp9_;
#line 57 "../src/Widgets/PopoverWidget.vala"
	_tmp10_ = power_widgets_popover_widget_dm;
#line 57 "../src/Widgets/PopoverWidget.vala"
	_tmp11_ = power_services_device_manager_get_brightness (_tmp10_);
#line 57 "../src/Widgets/PopoverWidget.vala"
	_tmp12_ = _tmp11_;
#line 57 "../src/Widgets/PopoverWidget.vala"
	_tmp13_ = (GtkRevealer*) gtk_revealer_new ();
#line 57 "../src/Widgets/PopoverWidget.vala"
	gtk_revealer_set_reveal_child (_tmp13_, _tmp12_ != -1);
#line 57 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp13_);
#line 57 "../src/Widgets/PopoverWidget.vala"
	_data7_->last_separator_revealer = _tmp13_;
#line 60 "../src/Widgets/PopoverWidget.vala"
	_tmp14_ = _data7_->last_separator_revealer;
#line 60 "../src/Widgets/PopoverWidget.vala"
	_tmp15_ = last_separator;
#line 60 "../src/Widgets/PopoverWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 62 "../src/Widgets/PopoverWidget.vala"
	_tmp16_ = granite_switch_model_button_new (_ ("Show Percentage"));
#line 62 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp16_);
#line 62 "../src/Widgets/PopoverWidget.vala"
	show_percent_switch = _tmp16_;
#line 63 "../src/Widgets/PopoverWidget.vala"
	_tmp17_ = show_percent_switch;
#line 63 "../src/Widgets/PopoverWidget.vala"
	_tmp18_ = gtk_widget_get_style_context ((GtkWidget*) _tmp17_);
#line 63 "../src/Widgets/PopoverWidget.vala"
	gtk_style_context_add_class (_tmp18_, GRANITE_STYLE_CLASS_H4_LABEL);
#line 65 "../src/Widgets/PopoverWidget.vala"
	_tmp19_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 65 "../src/Widgets/PopoverWidget.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp19_, 3);
#line 65 "../src/Widgets/PopoverWidget.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp19_, 3);
#line 65 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp19_);
#line 65 "../src/Widgets/PopoverWidget.vala"
	show_percent_sep = _tmp19_;
#line 70 "../src/Widgets/PopoverWidget.vala"
	_tmp20_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 70 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp20_);
#line 70 "../src/Widgets/PopoverWidget.vala"
	show_percent_box = _tmp20_;
#line 71 "../src/Widgets/PopoverWidget.vala"
	_tmp21_ = show_percent_box;
#line 71 "../src/Widgets/PopoverWidget.vala"
	_tmp22_ = show_percent_switch;
#line 71 "../src/Widgets/PopoverWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp22_);
#line 72 "../src/Widgets/PopoverWidget.vala"
	_tmp23_ = show_percent_box;
#line 72 "../src/Widgets/PopoverWidget.vala"
	_tmp24_ = show_percent_sep;
#line 72 "../src/Widgets/PopoverWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 74 "../src/Widgets/PopoverWidget.vala"
	_tmp25_ = (GtkRevealer*) gtk_revealer_new ();
#line 74 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp25_);
#line 74 "../src/Widgets/PopoverWidget.vala"
	show_percent_revealer = _tmp25_;
#line 75 "../src/Widgets/PopoverWidget.vala"
	_tmp26_ = show_percent_revealer;
#line 75 "../src/Widgets/PopoverWidget.vala"
	_tmp27_ = show_percent_box;
#line 75 "../src/Widgets/PopoverWidget.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 77 "../src/Widgets/PopoverWidget.vala"
	_tmp28_ = g_strdup (_ ("Power Settings…"));
#line 77 "../src/Widgets/PopoverWidget.vala"
	_tmp29_ = (GtkModelButton*) gtk_model_button_new ();
#line 77 "../src/Widgets/PopoverWidget.vala"
	g_object_set (_tmp29_, "text", _tmp28_, NULL);
#line 77 "../src/Widgets/PopoverWidget.vala"
	_g_free0 (_tmp28_);
#line 77 "../src/Widgets/PopoverWidget.vala"
	g_object_ref_sink (_tmp29_);
#line 77 "../src/Widgets/PopoverWidget.vala"
	show_settings_button = _tmp29_;
#line 81 "../src/Widgets/PopoverWidget.vala"
	_tmp30_ = show_percent_revealer;
#line 81 "../src/Widgets/PopoverWidget.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp30_, 0, 0, 1, 1);
#line 82 "../src/Widgets/PopoverWidget.vala"
	_tmp31_ = device_list_revealer;
#line 82 "../src/Widgets/PopoverWidget.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp31_, 0, 1, 1, 1);
#line 83 "../src/Widgets/PopoverWidget.vala"
	_tmp32_ = self->priv->device_separator_revealer;
#line 83 "../src/Widgets/PopoverWidget.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp32_, 0, 3, 1, 1);
#line 85 "../src/Widgets/PopoverWidget.vala"
	_tmp33_ = power_widgets_popover_widget_dm;
#line 85 "../src/Widgets/PopoverWidget.vala"
	_tmp34_ = power_services_device_manager_get_backlight (_tmp33_);
#line 85 "../src/Widgets/PopoverWidget.vala"
	_tmp35_ = _tmp34_;
#line 85 "../src/Widgets/PopoverWidget.vala"
	_tmp36_ = power_services_backlight_get_present (_tmp35_);
#line 85 "../src/Widgets/PopoverWidget.vala"
	_tmp37_ = _tmp36_;
#line 85 "../src/Widgets/PopoverWidget.vala"
	if (_tmp37_) {
#line 622 "PopoverWidget.c"
		PowerWidgetsScreenBrightness* screen_brightness = NULL;
		PowerWidgetsScreenBrightness* _tmp38_;
		PowerWidgetsScreenBrightness* _tmp39_;
#line 86 "../src/Widgets/PopoverWidget.vala"
		_tmp38_ = power_widgets_screen_brightness_new ();
#line 86 "../src/Widgets/PopoverWidget.vala"
		g_object_ref_sink (_tmp38_);
#line 86 "../src/Widgets/PopoverWidget.vala"
		screen_brightness = _tmp38_;
#line 87 "../src/Widgets/PopoverWidget.vala"
		_tmp39_ = screen_brightness;
#line 87 "../src/Widgets/PopoverWidget.vala"
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp39_, 0, 4, 1, 1);
#line 85 "../src/Widgets/PopoverWidget.vala"
		_g_object_unref0 (screen_brightness);
#line 638 "PopoverWidget.c"
	}
#line 90 "../src/Widgets/PopoverWidget.vala"
	_tmp40_ = self->priv->_is_in_session;
#line 90 "../src/Widgets/PopoverWidget.vala"
	if (_tmp40_) {
#line 644 "PopoverWidget.c"
		PowerWidgetsAppList* _tmp41_;
		PowerWidgetsAppList* _tmp42_;
		GtkRevealer* _tmp43_;
		GtkModelButton* _tmp44_;
#line 91 "../src/Widgets/PopoverWidget.vala"
		_tmp41_ = power_widgets_app_list_new ();
#line 91 "../src/Widgets/PopoverWidget.vala"
		g_object_ref_sink (_tmp41_);
#line 91 "../src/Widgets/PopoverWidget.vala"
		_g_object_unref0 (self->priv->app_list);
#line 91 "../src/Widgets/PopoverWidget.vala"
		self->priv->app_list = _tmp41_;
#line 92 "../src/Widgets/PopoverWidget.vala"
		_tmp42_ = self->priv->app_list;
#line 92 "../src/Widgets/PopoverWidget.vala"
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp42_, 0, 2, 1, 1);
#line 93 "../src/Widgets/PopoverWidget.vala"
		_tmp43_ = _data7_->last_separator_revealer;
#line 93 "../src/Widgets/PopoverWidget.vala"
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp43_, 0, 5, 1, 1);
#line 94 "../src/Widgets/PopoverWidget.vala"
		_tmp44_ = show_settings_button;
#line 94 "../src/Widgets/PopoverWidget.vala"
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp44_, 0, 6, 1, 1);
#line 669 "PopoverWidget.c"
	}
#line 97 "../src/Widgets/PopoverWidget.vala"
	power_widgets_popover_widget_update_device_seperator_revealer (self);
#line 99 "../src/Widgets/PopoverWidget.vala"
	_tmp45_ = power_widgets_popover_widget_dm;
#line 99 "../src/Widgets/PopoverWidget.vala"
	g_signal_connect_object ((GObject*) _tmp45_, "notify::has-battery", (GCallback) __power_widgets_popover_widget___lambda23__g_object_notify, self, 0);
#line 103 "../src/Widgets/PopoverWidget.vala"
	_tmp46_ = settings;
#line 103 "../src/Widgets/PopoverWidget.vala"
	_tmp47_ = show_percent_switch;
#line 103 "../src/Widgets/PopoverWidget.vala"
	g_settings_bind (_tmp46_, "show-percentage", (GObject*) _tmp47_, "active", G_SETTINGS_BIND_DEFAULT);
#line 105 "../src/Widgets/PopoverWidget.vala"
	_tmp48_ = power_widgets_popover_widget_dm;
#line 105 "../src/Widgets/PopoverWidget.vala"
	_tmp49_ = device_list_revealer;
#line 105 "../src/Widgets/PopoverWidget.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp48_, "has-battery", (GObject*) _tmp49_, "reveal-child", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 112 "../src/Widgets/PopoverWidget.vala"
	_tmp51_ = power_widgets_popover_widget_dm;
#line 112 "../src/Widgets/PopoverWidget.vala"
	_tmp52_ = power_services_device_manager_get_has_battery (_tmp51_);
#line 112 "../src/Widgets/PopoverWidget.vala"
	_tmp53_ = _tmp52_;
#line 112 "../src/Widgets/PopoverWidget.vala"
	if (_tmp53_) {
#line 697 "PopoverWidget.c"
		PowerServicesDeviceManager* _tmp54_;
		PowerServicesDevice* _tmp55_;
		PowerServicesDevice* _tmp56_;
		gboolean _tmp57_;
		gboolean _tmp58_;
#line 112 "../src/Widgets/PopoverWidget.vala"
		_tmp54_ = power_widgets_popover_widget_dm;
#line 112 "../src/Widgets/PopoverWidget.vala"
		_tmp55_ = power_services_device_manager_get_display_device (_tmp54_);
#line 112 "../src/Widgets/PopoverWidget.vala"
		_tmp56_ = _tmp55_;
#line 112 "../src/Widgets/PopoverWidget.vala"
		_tmp57_ = power_services_device_get_is_a_battery (_tmp56_);
#line 112 "../src/Widgets/PopoverWidget.vala"
		_tmp58_ = _tmp57_;
#line 112 "../src/Widgets/PopoverWidget.vala"
		_tmp50_ = _tmp58_;
#line 715 "PopoverWidget.c"
	} else {
#line 112 "../src/Widgets/PopoverWidget.vala"
		_tmp50_ = FALSE;
#line 719 "PopoverWidget.c"
	}
#line 112 "../src/Widgets/PopoverWidget.vala"
	if (_tmp50_) {
#line 723 "PopoverWidget.c"
		GtkRevealer* _tmp59_;
#line 113 "../src/Widgets/PopoverWidget.vala"
		_tmp59_ = show_percent_revealer;
#line 113 "../src/Widgets/PopoverWidget.vala"
		gtk_revealer_set_reveal_child (_tmp59_, TRUE);
#line 729 "PopoverWidget.c"
	}
#line 116 "../src/Widgets/PopoverWidget.vala"
	_tmp60_ = show_settings_button;
#line 116 "../src/Widgets/PopoverWidget.vala"
	g_signal_connect_object ((GtkButton*) _tmp60_, "clicked", (GCallback) __power_widgets_popover_widget___lambda24__gtk_button_clicked, self, 0);
#line 124 "../src/Widgets/PopoverWidget.vala"
	_tmp61_ = power_widgets_popover_widget_dm;
#line 124 "../src/Widgets/PopoverWidget.vala"
	g_signal_connect_data (_tmp61_, "brightness-changed", (GCallback) __power_widgets_popover_widget___lambda25__power_services_device_manager_brightness_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (show_settings_button);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (show_percent_revealer);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (show_percent_box);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (show_percent_sep);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (show_percent_switch);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (last_separator);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (device_separator);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (device_list_revealer);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (device_list);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (settings);
#line 36 "../src/Widgets/PopoverWidget.vala"
	block7_data_unref (_data7_);
#line 36 "../src/Widgets/PopoverWidget.vala"
	_data7_ = NULL;
#line 36 "../src/Widgets/PopoverWidget.vala"
	return obj;
#line 765 "PopoverWidget.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../src/Widgets/PopoverWidget.vala"
	return self ? g_object_ref (self) : NULL;
#line 773 "PopoverWidget.c"
}

static void
power_widgets_popover_widget_class_init (PowerWidgetsPopoverWidgetClass * klass,
                                         gpointer klass_data)
{
	PowerServicesDeviceManager* _tmp0_;
	PowerServicesDeviceManager* _tmp1_;
#line 20 "../src/Widgets/PopoverWidget.vala"
	power_widgets_popover_widget_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Widgets/PopoverWidget.vala"
	g_type_class_adjust_private_offset (klass, &PowerWidgetsPopoverWidget_private_offset);
#line 20 "../src/Widgets/PopoverWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_power_widgets_popover_widget_get_property;
#line 20 "../src/Widgets/PopoverWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_power_widgets_popover_widget_set_property;
#line 20 "../src/Widgets/PopoverWidget.vala"
	G_OBJECT_CLASS (klass)->constructor = power_widgets_popover_widget_constructor;
#line 20 "../src/Widgets/PopoverWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = power_widgets_popover_widget_finalize;
#line 20 "../src/Widgets/PopoverWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY, power_widgets_popover_widget_properties[POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY] = g_param_spec_boolean ("is-in-session", "is-in-session", "is-in-session", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 33 "../src/Widgets/PopoverWidget.vala"
	_tmp0_ = power_services_device_manager_get_default ();
#line 33 "../src/Widgets/PopoverWidget.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 33 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (power_widgets_popover_widget_dm);
#line 33 "../src/Widgets/PopoverWidget.vala"
	power_widgets_popover_widget_dm = _tmp1_;
#line 804 "PopoverWidget.c"
}

static void
power_widgets_popover_widget_instance_init (PowerWidgetsPopoverWidget * self,
                                            gpointer klass)
{
#line 20 "../src/Widgets/PopoverWidget.vala"
	self->priv = power_widgets_popover_widget_get_instance_private (self);
#line 21 "../src/Widgets/PopoverWidget.vala"
	self->priv->_is_in_session = FALSE;
#line 815 "PopoverWidget.c"
}

static void
power_widgets_popover_widget_finalize (GObject * obj)
{
	PowerWidgetsPopoverWidget * self;
#line 20 "../src/Widgets/PopoverWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_WIDGETS_TYPE_POPOVER_WIDGET, PowerWidgetsPopoverWidget);
#line 25 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (self->priv->app_list);
#line 26 "../src/Widgets/PopoverWidget.vala"
	_g_object_unref0 (self->priv->device_separator_revealer);
#line 20 "../src/Widgets/PopoverWidget.vala"
	G_OBJECT_CLASS (power_widgets_popover_widget_parent_class)->finalize (obj);
#line 830 "PopoverWidget.c"
}

static GType
power_widgets_popover_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerWidgetsPopoverWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_widgets_popover_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerWidgetsPopoverWidget), 0, (GInstanceInitFunc) power_widgets_popover_widget_instance_init, NULL };
	GType power_widgets_popover_widget_type_id;
	power_widgets_popover_widget_type_id = g_type_register_static (gtk_grid_get_type (), "PowerWidgetsPopoverWidget", &g_define_type_info, 0);
	PowerWidgetsPopoverWidget_private_offset = g_type_add_instance_private (power_widgets_popover_widget_type_id, sizeof (PowerWidgetsPopoverWidgetPrivate));
	return power_widgets_popover_widget_type_id;
}

GType
power_widgets_popover_widget_get_type (void)
{
	static volatile gsize power_widgets_popover_widget_type_id__once = 0;
	if (g_once_init_enter (&power_widgets_popover_widget_type_id__once)) {
		GType power_widgets_popover_widget_type_id;
		power_widgets_popover_widget_type_id = power_widgets_popover_widget_get_type_once ();
		g_once_init_leave (&power_widgets_popover_widget_type_id__once, power_widgets_popover_widget_type_id);
	}
	return power_widgets_popover_widget_type_id__once;
}

static void
_vala_power_widgets_popover_widget_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	PowerWidgetsPopoverWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_WIDGETS_TYPE_POPOVER_WIDGET, PowerWidgetsPopoverWidget);
#line 20 "../src/Widgets/PopoverWidget.vala"
	switch (property_id) {
#line 20 "../src/Widgets/PopoverWidget.vala"
		case POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY:
#line 20 "../src/Widgets/PopoverWidget.vala"
		g_value_set_boolean (value, power_widgets_popover_widget_get_is_in_session (self));
#line 20 "../src/Widgets/PopoverWidget.vala"
		break;
#line 871 "PopoverWidget.c"
		default:
#line 20 "../src/Widgets/PopoverWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/PopoverWidget.vala"
		break;
#line 877 "PopoverWidget.c"
	}
}

static void
_vala_power_widgets_popover_widget_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	PowerWidgetsPopoverWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_WIDGETS_TYPE_POPOVER_WIDGET, PowerWidgetsPopoverWidget);
#line 20 "../src/Widgets/PopoverWidget.vala"
	switch (property_id) {
#line 20 "../src/Widgets/PopoverWidget.vala"
		case POWER_WIDGETS_POPOVER_WIDGET_IS_IN_SESSION_PROPERTY:
#line 20 "../src/Widgets/PopoverWidget.vala"
		power_widgets_popover_widget_set_is_in_session (self, g_value_get_boolean (value));
#line 20 "../src/Widgets/PopoverWidget.vala"
		break;
#line 897 "PopoverWidget.c"
		default:
#line 20 "../src/Widgets/PopoverWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 20 "../src/Widgets/PopoverWidget.vala"
		break;
#line 903 "PopoverWidget.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

